require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&DLG_INTERNALS_H_included)) {
    eval 'sub DLG_INTERNALS_H_included () {1;}' unless defined(&DLG_INTERNALS_H_included);
    require 'dialog.ph';
    if(defined(&NEED_WCHAR_H)) {
	require 'wchar.ph';
    }
    if(defined(&ENABLE_NLS)) {
	require 'libintl.ph';
	require 'langinfo.ph';
	eval 'sub _ {
	    my($s) = @_;
    	    eval q( &dgettext( &PACKAGE, $s));
	}' unless defined(&_);
    } else {
	undef(&_) if defined(&_);
	eval 'sub _ {
	    my($s) = @_;
    	    eval q($s);
	}' unless defined(&_);
    }
    require 'time.ph';
    if(defined(&HAVE_STDINT_H)) {
	require 'stdint.ph';
    } else {
	eval 'sub intptr_t () {\'long\';}' unless defined(&intptr_t);
    }
    require 'errno.ph';
    require 'string.ph';
    require 'sys/types.ph';
    require 'sys/stat.ph';
    if(defined(&HAVE_SETLOCALE)) {
	require 'locale.ph';
    }
    if(defined(&STDC_HEADERS)) {
	require 'stddef.ph';
    }
    if(defined(&HAVE_SYS_PARAM_H)) {
	require 'sys/param.ph';
    }
    if(defined(&TIME_WITH_SYS_TIME)) {
	require 'sys/time.ph';
	require 'time.ph';
    } else {
	if(defined(&HAVE_SYS_TIME_H)) {
	    require 'sys/time.ph';
	} else {
	    require 'time.ph';
	}
    }
    if(defined(&HAVE_DIRENT_H)) {
	require 'dirent.ph';
	eval 'sub NAMLEN {
	    my($dirent) = @_;
    	    eval q( &strlen(($dirent)-> &d_name));
	}' unless defined(&NAMLEN);
    } else {
	eval 'sub dirent () { &direct;}' unless defined(&dirent);
	eval 'sub NAMLEN {
	    my($dirent) = @_;
    	    eval q(($dirent)-> &d_namlen);
	}' unless defined(&NAMLEN);
	if(defined(&HAVE_SYS_NDIR_H)) {
	    require 'sys/ndir.ph';
	}
	if(defined(&HAVE_SYS_DIR_H)) {
	    require 'sys/dir.ph';
	}
	if(defined(&HAVE_NDIR_H)) {
	    require 'ndir.ph';
	}
    }
    if(defined(&_FILE_OFFSET_BITS)  && defined(&HAVE_STRUCT_DIRENT64)) {
	if(!defined(&_LP64)  && ((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 64)) {
	    eval 'sub DIRENT () {\'struct dirent64\';}' unless defined(&DIRENT);
	} else {
	    eval 'sub DIRENT () {\'struct dirent\';}' unless defined(&DIRENT);
	}
    } else {
	eval 'sub DIRENT () {\'struct dirent\';}' unless defined(&DIRENT);
    }
    if(defined(&HAVE_SEARCH_H)  && defined(&HAVE_TSEARCH)) {
	require 'search.ph';
	eval 'sub leaf () { &leaf2;}' unless defined(&leaf);
    } else {
	undef(&HAVE_TSEARCH) if defined(&HAVE_TSEARCH);
    }
    if(defined(&color_names)) {
	undef(&color_names) if defined(&color_names);
    }
    if(defined(&buttons)) {
	undef(&buttons) if defined(&buttons);
    }
    unless(defined(&HAVE_WGET_WCH)) {
	undef(&USE_WIDE_CURSES) if defined(&USE_WIDE_CURSES);
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&HAVE_GETBEGYX)) {
	undef(&getbegyx) if defined(&getbegyx);
	eval 'sub getbegyx {
	    my($win,$y,$x) = @_;
    	    eval q(($y = ($win)?($win)-> &_begy: &ERR, $x = ($win)?($win)-> &_begx: &ERR));
	}' unless defined(&getbegyx);
    }
    unless(defined(&HAVE_GETMAXYX)) {
	undef(&getmaxyx) if defined(&getmaxyx);
	eval 'sub getmaxyx {
	    my($win,$y,$x) = @_;
    	    eval q(($y = ($win)?($win)-> &_maxy: &ERR, $x = ($win)?($win)-> &_maxx: &ERR));
	}' unless defined(&getmaxyx);
    }
    unless(defined(&HAVE_GETPARYX)) {
	undef(&getparyx) if defined(&getparyx);
	eval 'sub getparyx {
	    my($win,$y,$x) = @_;
    	    eval q(($y = ($win)?($win)-> &_pary: &ERR, $x = ($win)?($win)-> &_parx: &ERR));
	}' unless defined(&getparyx);
    }
    if(!defined(&HAVE_WSYNCUP)) {
	undef(&wsyncup) if defined(&wsyncup);
	eval 'sub wsyncup {
	    my($win) = @_;
    	    eval q();
	}' unless defined(&wsyncup);
    }
    if(!defined(&HAVE_WCURSYNCUP)) {
	undef(&wcursyncup) if defined(&wcursyncup);
	eval 'sub wcursyncup {
	    my($win) = @_;
    	    eval q();
	}' unless defined(&wcursyncup);
    }
    if(!(defined(&HAVE_GETBEGX)  && defined(&HAVE_GETBEGY))) {
	undef(&getbegx) if defined(&getbegx);
	undef(&getbegy) if defined(&getbegy);
	eval 'sub getbegx {
	    my($win) = @_;
    	    eval q( &dlg_getbegx($win));
	}' unless defined(&getbegx);
	eval 'sub getbegy {
	    my($win) = @_;
    	    eval q( &dlg_getbegy($win));
	}' unless defined(&getbegy);
    }
    if(!(defined(&HAVE_GETCURX)  && defined(&HAVE_GETCURY))) {
	undef(&getcurx) if defined(&getcurx);
	undef(&getcury) if defined(&getcury);
	eval 'sub getcurx {
	    my($win) = @_;
    	    eval q( &dlg_getcurx($win));
	}' unless defined(&getcurx);
	eval 'sub getcury {
	    my($win) = @_;
    	    eval q( &dlg_getcury($win));
	}' unless defined(&getcury);
    }
    if(!(defined(&HAVE_GETMAXX)  && defined(&HAVE_GETMAXY))) {
	undef(&getmaxx) if defined(&getmaxx);
	undef(&getmaxy) if defined(&getmaxy);
	eval 'sub getmaxx {
	    my($win) = @_;
    	    eval q( &dlg_getmaxx($win));
	}' unless defined(&getmaxx);
	eval 'sub getmaxy {
	    my($win) = @_;
    	    eval q( &dlg_getmaxy($win));
	}' unless defined(&getmaxy);
    }
    if(!(defined(&HAVE_GETPARX)  && defined(&HAVE_GETPARY))) {
	undef(&getparx) if defined(&getparx);
	undef(&getpary) if defined(&getpary);
	eval 'sub getparx {
	    my($win) = @_;
    	    eval q( &dlg_getparx($win));
	}' unless defined(&getparx);
	eval 'sub getpary {
	    my($win) = @_;
    	    eval q( &dlg_getpary($win));
	}' unless defined(&getpary);
    }
    if(!(defined(&HAVE_WGETPARENT)  && defined(&HAVE_WINDOW__PARENT))) {
	undef(&wgetparent) if defined(&wgetparent);
	eval 'sub wgetparent {
	    my($win) = @_;
    	    eval q( &dlg_wgetparent($win));
	}' unless defined(&wgetparent);
    }
 elsif(!defined(&HAVE_WGETPARENT)  && defined(&HAVE_WINDOW__PARENT)) {
	undef(&wgetparent) if defined(&wgetparent);
	eval 'sub wgetparent {
	    my($win) = @_;
    	    eval q((($win) ? ($win)-> &_parent : 0));
	}' unless defined(&wgetparent);
    }
    if(defined(&PDCURSES)) {
	eval 'sub dlg_attrset {
	    my($w,$a) = @_;
    	    eval q(( &void)  &wattrset(($w), ($a)));
	}' unless defined(&dlg_attrset);
	eval 'sub dlg_attron {
	    my($w,$a) = @_;
    	    eval q(( &void)  &wattron(($w), ($a)));
	}' unless defined(&dlg_attron);
	eval 'sub dlg_attroff {
	    my($w,$a) = @_;
    	    eval q(( &void)  &wattroff(($w), ($a)));
	}' unless defined(&dlg_attroff);
    } else {
	eval 'sub dlg_attrset {
	    my($w,$a) = @_;
    	    eval q(( &void)  &wattrset(, ($a)));
	}' unless defined(&dlg_attrset);
	eval 'sub dlg_attron {
	    my($w,$a) = @_;
    	    eval q(( &void)  &wattron(, ($a)));
	}' unless defined(&dlg_attron);
	eval 'sub dlg_attroff {
	    my($w,$a) = @_;
    	    eval q(( &void)  &wattroff(, ($a)));
	}' unless defined(&dlg_attroff);
    }
    unless(defined(&isblank)) {
	eval 'sub isblank {
	    my($c) = @_;
    	    eval q((($c) == ord(\' \') || ($c) ==  &TAB));
	}' unless defined(&isblank);
    }
    eval 'sub MAX_LEN () {2048;}' unless defined(&MAX_LEN);
    eval 'sub BUF_SIZE () {(10*1024);}' unless defined(&BUF_SIZE);
    undef(&MIN) if defined(&MIN);
    eval 'sub MIN {
        my($x,$y) = @_;
	    eval q((($x) < ($y) ? ($x) : ($y)));
    }' unless defined(&MIN);
    undef(&MAX) if defined(&MAX);
    eval 'sub MAX {
        my($x,$y) = @_;
	    eval q((($x) > ($y) ? ($x) : ($y)));
    }' unless defined(&MAX);
    eval 'sub UCH {
        my($ch) = @_;
	    eval q((($ch)));
    }' unless defined(&UCH);
    eval 'sub assert_ptr {
        my($ptr,$msg) = @_;
	    eval q( &if (($ptr) == 0)  &dlg_exiterr(\\"cannot allocate memory in \\" $msg));
    }' unless defined(&assert_ptr);
    eval 'sub dlg_malloc {
        my($t,$n) = @_;
	    eval q(($t *)  &malloc(($n) * $sizeof{$t}));
    }' unless defined(&dlg_malloc);
    eval 'sub dlg_calloc {
        my($t,$n) = @_;
	    eval q(($t *)  &calloc(($n), $sizeof{$t}));
    }' unless defined(&dlg_calloc);
    eval 'sub dlg_realloc {
        my($t,$n,$p) = @_;
	    eval q(($t *)  &realloc(($p), ($n) * $sizeof{$t}));
    }' unless defined(&dlg_realloc);
    eval 'sub TableSize {
        my($name) = @_;
	    eval q(($sizeof{$name}/$sizeof{($name)[0]}));
    }' unless defined(&TableSize);
    eval 'sub resizeit {
        my($name, $NAME) = @_;
	    eval q($name = (($NAME >=  &old_$NAME) ? ($NAME - ( &old_$NAME -  &old_$name)) :  &old_$name));
    }' unless defined(&resizeit);
    eval 'sub AddLastKey () {
        eval q( &if ( ($dialog_vars->{last_key})) {  &if ( &dlg_need_separator())  &dlg_add_separator();  &dlg_add_last_key(-1); });
    }' unless defined(&AddLastKey);
    if(defined(&NO_LEAKS)) {
	if(defined(&NCURSES_VERSION)) {
	    if(defined(&HAVE_EXIT_CURSES)) {
	    }
 elsif(defined(&HAVE__NC_FREE_AND_EXIT)) {
		eval 'sub exit_curses {
		    my($code) = @_;
    		    eval q( &_nc_free_and_exit($code));
		}' unless defined(&exit_curses);
	    }
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
