require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_FCNTL_H_)) {
    eval 'sub _SYS_FCNTL_H_ () {1;}' unless defined(&_SYS_FCNTL_H_);
    require 'sys/cdefs.ph';
    unless(defined(&_SYS_TYPES_H_)) {
	require 'sys/types.ph';
    }
    eval 'sub O_RDONLY () {0x;}' unless defined(&O_RDONLY);
    eval 'sub O_WRONLY () {0x1;}' unless defined(&O_WRONLY);
    eval 'sub O_RDWR () {0x2;}' unless defined(&O_RDWR);
    eval 'sub O_ACCMODE () {0x3;}' unless defined(&O_ACCMODE);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub FREAD () {0x1;}' unless defined(&FREAD);
	eval 'sub FWRITE () {0x2;}' unless defined(&FWRITE);
    }
    eval 'sub O_NONBLOCK () {0x4;}' unless defined(&O_NONBLOCK);
    eval 'sub O_APPEND () {0x8;}' unless defined(&O_APPEND);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub O_SHLOCK () {0x10;}' unless defined(&O_SHLOCK);
	eval 'sub O_EXLOCK () {0x20;}' unless defined(&O_EXLOCK);
	eval 'sub O_ASYNC () {0x40;}' unless defined(&O_ASYNC);
	eval 'sub O_FSYNC () {0x80;}' unless defined(&O_FSYNC);
    }
    eval 'sub O_SYNC () {0x80;}' unless defined(&O_SYNC);
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : undef) >= 200809) {
	eval 'sub O_NOFOLLOW () {0x100;}' unless defined(&O_NOFOLLOW);
    }
    eval 'sub O_CREAT () {0x200;}' unless defined(&O_CREAT);
    eval 'sub O_TRUNC () {0x400;}' unless defined(&O_TRUNC);
    eval 'sub O_EXCL () {0x800;}' unless defined(&O_EXCL);
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	eval 'sub FMARK () {0x1000;}' unless defined(&FMARK);
	eval 'sub FDEFER () {0x2000;}' unless defined(&FDEFER);
	eval 'sub FHASLOCK () {0x4000;}' unless defined(&FHASLOCK);
    }
    eval 'sub O_NOCTTY () {0x8000;}' unless defined(&O_NOCTTY);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub O_DIRECT () {0x10000;}' unless defined(&O_DIRECT);
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : undef) >= 200809) {
	eval 'sub O_CLOEXEC () {0x20000;}' unless defined(&O_CLOEXEC);
    }
    eval 'sub O_FBLOCKING () {0x40000;}' unless defined(&O_FBLOCKING);
    eval 'sub O_FNONBLOCKING () {0x80000;}' unless defined(&O_FNONBLOCKING);
    eval 'sub O_FAPPEND () {0x100000;}' unless defined(&O_FAPPEND);
    eval 'sub O_FOFFSET () {0x200000;}' unless defined(&O_FOFFSET);
    eval 'sub O_FSYNCWRITE () {0x400000;}' unless defined(&O_FSYNCWRITE);
    eval 'sub O_FASYNCWRITE () {0x800000;}' unless defined(&O_FASYNCWRITE);
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	eval 'sub O_UNUSED24 () {0x1000000;}' unless defined(&O_UNUSED24);
	eval 'sub O_UNUSED25 () {0x2000000;}' unless defined(&O_UNUSED25);
	eval 'sub O_UNUSED26 () {0x4000000;}' unless defined(&O_UNUSED26);
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : undef) >= 200809) {
	eval 'sub O_DIRECTORY () {0x8000000;}' unless defined(&O_DIRECTORY);
    }
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	eval 'sub FREVOKED () {0x10000000;}' unless defined(&FREVOKED);
	eval 'sub FAPPENDONLY () {0x20000000;}' unless defined(&FAPPENDONLY);
	eval 'sub FOFFSETLOCK () {0x40000000;}' unless defined(&FOFFSETLOCK);
	eval 'sub FOFFSETWAKE () {0x80000000;}' unless defined(&FOFFSETWAKE);
    }
    eval 'sub O_FMASK () {( &O_FBLOCKING| &O_FNONBLOCKING| &O_FAPPEND| &O_FOFFSET|  &O_FSYNCWRITE| &O_FASYNCWRITE);}' unless defined(&O_FMASK);
    if(defined(&_KERNEL)) {
	eval 'sub FFLAGS {
	    my($oflags) = @_;
    	    eval q((($oflags) + 1));
	}' unless defined(&FFLAGS);
	eval 'sub OFLAGS {
	    my($fflags) = @_;
    	    eval q((($fflags) - 1));
	}' unless defined(&OFLAGS);
	eval 'sub FMASK () {( &FREAD| &FWRITE| &FAPPEND| &FASYNC| &FFSYNC| &FNONBLOCK|  &FAPPENDONLY| &FREVOKED| &O_DIRECT);}' unless defined(&FMASK);
	eval 'sub FCNTLFLAGS () {( &FAPPEND| &FASYNC| &FFSYNC| &FNONBLOCK| &FPOSIXSHM|  &O_DIRECT);}' unless defined(&FCNTLFLAGS);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub FAPPEND () { &O_APPEND;}' unless defined(&FAPPEND);
	eval 'sub FASYNC () { &O_ASYNC;}' unless defined(&FASYNC);
	eval 'sub FFSYNC () { &O_FSYNC;}' unless defined(&FFSYNC);
	eval 'sub FNONBLOCK () { &O_NONBLOCK;}' unless defined(&FNONBLOCK);
	eval 'sub FNDELAY () { &O_NONBLOCK;}' unless defined(&FNDELAY);
	eval 'sub O_NDELAY () { &O_NONBLOCK;}' unless defined(&O_NDELAY);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub FPOSIXSHM () { &O_NOFOLLOW;}' unless defined(&FPOSIXSHM);
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : undef) >= 200809) {
	eval 'sub AT_FDCWD () {0xfffafdcd;}' unless defined(&AT_FDCWD);
	eval 'sub AT_SYMLINK_NOFOLLOW () {1;}' unless defined(&AT_SYMLINK_NOFOLLOW);
	eval 'sub AT_REMOVEDIR () {2;}' unless defined(&AT_REMOVEDIR);
	eval 'sub AT_EACCESS () {4;}' unless defined(&AT_EACCESS);
	eval 'sub AT_SYMLINK_FOLLOW () {8;}' unless defined(&AT_SYMLINK_FOLLOW);
    }
    eval 'sub F_DUPFD () {0;}' unless defined(&F_DUPFD);
    eval 'sub F_GETFD () {1;}' unless defined(&F_GETFD);
    eval 'sub F_SETFD () {2;}' unless defined(&F_SETFD);
    eval 'sub F_GETFL () {3;}' unless defined(&F_GETFL);
    eval 'sub F_SETFL () {4;}' unless defined(&F_SETFL);
    if((defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : undef) || (defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : undef) >= 200112) {
	eval 'sub F_GETOWN () {5;}' unless defined(&F_GETOWN);
	eval 'sub F_SETOWN () {6;}' unless defined(&F_SETOWN);
    }
    eval 'sub F_GETLK () {7;}' unless defined(&F_GETLK);
    eval 'sub F_SETLK () {8;}' unless defined(&F_SETLK);
    eval 'sub F_SETLKW () {9;}' unless defined(&F_SETLKW);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub F_DUP2FD () {10;}' unless defined(&F_DUP2FD);
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : undef) >= 200809) {
	eval 'sub F_DUPFD_CLOEXEC () {17;}' unless defined(&F_DUPFD_CLOEXEC);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub F_DUP2FD_CLOEXEC () {18;}' unless defined(&F_DUP2FD_CLOEXEC);
	eval 'sub F_GETPATH () {19;}' unless defined(&F_GETPATH);
    }
    eval 'sub FD_CLOEXEC () {1;}' unless defined(&FD_CLOEXEC);
    eval 'sub F_RDLCK () {1;}' unless defined(&F_RDLCK);
    eval 'sub F_UNLCK () {2;}' unless defined(&F_UNLCK);
    eval 'sub F_WRLCK () {3;}' unless defined(&F_WRLCK);
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	eval 'sub F_WAIT () {0x10;}' unless defined(&F_WAIT);
	eval 'sub F_UNUSED020 () {0x20;}' unless defined(&F_UNUSED020);
	eval 'sub F_POSIX () {0x40;}' unless defined(&F_POSIX);
	eval 'sub F_NOEND () {0x80;}' unless defined(&F_NOEND);
    }
    if(defined(&_KERNEL)) {
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub LOCK_SH () {0x1;}' unless defined(&LOCK_SH);
	eval 'sub LOCK_EX () {0x2;}' unless defined(&LOCK_EX);
	eval 'sub LOCK_NB () {0x4;}' unless defined(&LOCK_NB);
	eval 'sub LOCK_UN () {0x8;}' unless defined(&LOCK_UN);
    }
    unless(defined(&SEEK_SET)) {
	eval 'sub SEEK_SET () {0;}' unless defined(&SEEK_SET);
    }
    unless(defined(&SEEK_CUR)) {
	eval 'sub SEEK_CUR () {1;}' unless defined(&SEEK_CUR);
    }
    unless(defined(&SEEK_END)) {
	eval 'sub SEEK_END () {2;}' unless defined(&SEEK_END);
    }
    unless(defined(&S_ISUID)) {
	eval 'sub S_ISUID () {0004000;}' unless defined(&S_ISUID);
    }
    unless(defined(&S_ISGID)) {
	eval 'sub S_ISGID () {0002000;}' unless defined(&S_ISGID);
    }
    unless(defined(&S_IRWXU)) {
	eval 'sub S_IRWXU () {0000700;}' unless defined(&S_IRWXU);
    }
    unless(defined(&S_IRUSR)) {
	eval 'sub S_IRUSR () {0000400;}' unless defined(&S_IRUSR);
    }
    unless(defined(&S_IWUSR)) {
	eval 'sub S_IWUSR () {0000200;}' unless defined(&S_IWUSR);
    }
    unless(defined(&S_IXUSR)) {
	eval 'sub S_IXUSR () {0000100;}' unless defined(&S_IXUSR);
    }
    unless(defined(&S_IRWXG)) {
	eval 'sub S_IRWXG () {0000070;}' unless defined(&S_IRWXG);
    }
    unless(defined(&S_IRGRP)) {
	eval 'sub S_IRGRP () {0000040;}' unless defined(&S_IRGRP);
    }
    unless(defined(&S_IWGRP)) {
	eval 'sub S_IWGRP () {0000020;}' unless defined(&S_IWGRP);
    }
    unless(defined(&S_IXGRP)) {
	eval 'sub S_IXGRP () {0000010;}' unless defined(&S_IXGRP);
    }
    unless(defined(&S_IRWXO)) {
	eval 'sub S_IRWXO () {0000007;}' unless defined(&S_IRWXO);
    }
    unless(defined(&S_IROTH)) {
	eval 'sub S_IROTH () {0000004;}' unless defined(&S_IROTH);
    }
    unless(defined(&S_IWOTH)) {
	eval 'sub S_IWOTH () {0000002;}' unless defined(&S_IWOTH);
    }
    unless(defined(&S_IXOTH)) {
	eval 'sub S_IXOTH () {0000001;}' unless defined(&S_IXOTH);
    }
    if(!defined(&_KERNEL)  && (defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : undef) >= 200112) {
	eval 'sub POSIX_FADV_NORMAL () {0;}' unless defined(&POSIX_FADV_NORMAL);
	eval 'sub POSIX_FADV_SEQUENTIAL () {1;}' unless defined(&POSIX_FADV_SEQUENTIAL);
	eval 'sub POSIX_FADV_RANDOM () {2;}' unless defined(&POSIX_FADV_RANDOM);
	eval 'sub POSIX_FADV_WILLNEED () {3;}' unless defined(&POSIX_FADV_WILLNEED);
	eval 'sub POSIX_FADV_DONTNEED () {4;}' unless defined(&POSIX_FADV_DONTNEED);
	eval 'sub POSIX_FADV_NOREUSE () {5;}' unless defined(&POSIX_FADV_NOREUSE);
    }
    if(!defined(&_KERNEL) || defined(&_KERNEL_VIRTUAL)) {
	if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : undef) >= 200809) {
	}
	if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	}
	if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : undef) >= 200112) {
	}
    }
}
1;
