require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CPU_ASMACROS_H_)) {
    eval 'sub _CPU_ASMACROS_H_ () {1;}' unless defined(&_CPU_ASMACROS_H_);
    require 'sys/cdefs.ph';
    require 'machine/specialreg.ph';
    eval 'sub CNAME {
        my($csym) = @_;
	    eval q($csym);
    }' unless defined(&CNAME);
    eval 'sub ALIGN_DATA () {. &p2align 3;}' unless defined(&ALIGN_DATA);
    eval 'sub ALIGN_TEXT () {. &p2align 4,0x90;}' unless defined(&ALIGN_TEXT);
    eval 'sub SUPERALIGN_TEXT () {. &p2align 4,0x90;}' unless defined(&SUPERALIGN_TEXT);
    eval 'sub GEN_ENTRY {
        my($name) = @_;
	    eval q( &ALIGN_TEXT; . &globl  &CNAME($name); . &type  &CNAME($name),@ &function;  &CNAME($name):);
    }' unless defined(&GEN_ENTRY);
    eval 'sub NON_GPROF_ENTRY {
        my($name) = @_;
	    eval q( &GEN_ENTRY($name));
    }' unless defined(&NON_GPROF_ENTRY);
    eval 'sub NON_GPROF_RET () {. &byte 0xc3;}' unless defined(&NON_GPROF_RET);
    eval 'sub END {
        my($name) = @_;
	    eval q(. &size $name, . - $name);
    }' unless defined(&END);
    eval 'sub ALTENTRY {
        my($name) = @_;
	    eval q( &GEN_ENTRY($name));
    }' unless defined(&ALTENTRY);
    eval 'sub CROSSJUMP {
        my($jtrue, $label, $jfalse) = @_;
	    eval q($jtrue $label);
    }' unless defined(&CROSSJUMP);
    eval 'sub CROSSJUMPTARGET {
        my($label) = @_;
	    eval q();
    }' unless defined(&CROSSJUMPTARGET);
    eval 'sub ENTRY {
        my($name) = @_;
	    eval q( &GEN_ENTRY($name));
    }' unless defined(&ENTRY);
    eval 'sub FAKE_MCOUNT {
        my($caller) = @_;
	    eval q();
    }' unless defined(&FAKE_MCOUNT);
    eval 'sub MCOUNT () {1;}' unless defined(&MCOUNT);
    eval 'sub MCOUNT_LABEL {
        my($name) = @_;
	    eval q();
    }' unless defined(&MCOUNT_LABEL);
    eval 'sub MEXITCOUNT () {1;}' unless defined(&MEXITCOUNT);
    if(defined(&LOCORE)) {
	eval 'sub IDTVEC {
	    my($name) = @_;
    	    eval q( &ALIGN_TEXT; . &globl  &__CONCAT( &X,$name); . &type  &__CONCAT( &X,$name),@ &function;  &__CONCAT( &X,$name):);
	}' unless defined(&IDTVEC);
	eval 'sub KMMUENTER_CORE () { &testq $ &PCB_ISOMMU, &PCPU( &trampoline)+ &TR_PCB_FLAGS ;  &je 40 &f ;  &movq  &PCPU( &trampoline)+ &TR_PCB_CR3,% &rcx ;  &movq % &rcx,% &cr3 ; 40:  &movl  &PCPU( &trampoline)+ &TR_PCB_SPEC_CTRL,% &edx ;  &testq % &rdx, % &rdx ;  &je 43 &f ;  &movq % &rax,  &PCPU( &trampoline)+ &TR_RAX ;  &testq $ &SPEC_CTRL_DUMMY_ENABLE,% &rdx ;  &je 41 &f ;  &movq % &rdx, % &rax ;  &andq $ &SPEC_CTRL_IBRS| &SPEC_CTRL_STIBP, % &rax ;  &movq $ &MSR_SPEC_CTRL,% &rcx ;  &xorl % &edx,% &edx ;  &wrmsr ;  &movl  &PCPU( &trampoline)+ &TR_PCB_SPEC_CTRL,% &edx ; 41:  &testq $ &SPEC_CTRL_DUMMY_IBPB,% &rdx ;  &je 42 &f ;  &movl $ &MSR_PRED_CMD,% &ecx ;  &movl $1,% &eax ;  &xorl % &edx,% &edx ;  &wrmsr ; 42:  &movq  &PCPU( &trampoline)+ &TR_RAX, % &rax ; 43:;}' unless defined(&KMMUENTER_CORE);
	eval 'sub KMMUENTER_TFRIP () { &subq $ &TR_RIP, % &rsp ;  &movq % &rcx,  &TR_RCX(% &rsp) ;  &movq % &rdx,  &TR_RDX(% &rsp) ;  &KMMUENTER_CORE ;  &movq % &rsp, % &rcx ;  &movq  &PCPU( &trampoline)+ &TR_PCB_RSP,% &rsp ;  &movq  &TR_SS(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_RSP(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_RFLAGS(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_CS(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_RIP(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_RDX(% &rcx), % &rdx ;  &movq  &TR_RCX(% &rcx), % &rcx;}' unless defined(&KMMUENTER_TFRIP);
	eval 'sub KMMUENTER_TFERR () { &subq $ &TR_ERR, % &rsp ;  &movq % &rcx,  &TR_RCX(% &rsp) ;  &movq % &rdx,  &TR_RDX(% &rsp) ;  &KMMUENTER_CORE ;  &movq % &rsp, % &rcx ;  &movq  &PCPU( &trampoline)+ &TR_PCB_RSP,% &rsp ;  &movq  &TR_SS(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_RSP(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_RFLAGS(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_CS(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_RIP(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_ERR(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_RDX(% &rcx), % &rdx ;  &movq  &TR_RCX(% &rcx), % &rcx;}' unless defined(&KMMUENTER_TFERR);
	eval 'sub KMMUENTER_TFERR_SAVECR2 () { &subq $ &TR_ERR, % &rsp ;  &movq % &rcx,  &TR_RCX(% &rsp) ;  &movq % &rdx,  &TR_RDX(% &rsp) ;  &movq % &cr2, % &rcx ;  &movq % &rcx,  &PCPU( &trampoline)+ &TR_CR2 ;  &KMMUENTER_CORE ;  &movq % &rsp, % &rcx ;  &movq  &PCPU( &trampoline)+ &TR_PCB_RSP,% &rsp ;  &movq  &TR_SS(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_RSP(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_RFLAGS(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_CS(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_RIP(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_ERR(% &rcx), % &rdx ;  &pushq % &rdx ;  &movq  &TR_RDX(% &rcx), % &rdx ;  &movq  &TR_RCX(% &rcx), % &rcx;}' unless defined(&KMMUENTER_TFERR_SAVECR2);
	eval 'sub KMMUENTER_SYSCALL () { &movq % &rcx,  &PCPU( &trampoline)+ &TR_RCX ;  &movq % &rdx,  &PCPU( &trampoline)+ &TR_RDX ;  &KMMUENTER_CORE ;  &movq  &PCPU( &trampoline)+ &TR_RDX, % &rdx ;  &movq  &PCPU( &trampoline)+ &TR_RCX, % &rcx;}' unless defined(&KMMUENTER_SYSCALL);
	eval 'sub KMMUEXIT_CORE () { &testl $ &SPEC_CTRL_DUMMY_ENABLE| &SPEC_CTRL_MDS_ENABLE,  &PCPU( &trampoline)+ &TR_PCB_SPEC_CTRL+4;  &je 43 &f ;  &movq % &rax,  &PCPU( &trampoline)+ &TR_RAX ;  &movl  &PCPU( &trampoline)+ &TR_PCB_SPEC_CTRL+4, % &eax ;  &testq $ &SPEC_CTRL_MDS_ENABLE, % &rax ;  &je 41 &f ;  &movq $ &GSEL( &GDATA_SEL,  &SEL_KPL),  &PCPU( &trampoline)+ &TR_RCX ;  &verw  &PCPU( &trampoline)+ &TR_RCX ; 41:  &testq $ &SPEC_CTRL_DUMMY_ENABLE, % &rax ;  &je 42 &f ;  &movq % &rcx,  &PCPU( &trampoline)+ &TR_RCX ;  &movq % &rdx,  &PCPU( &trampoline)+ &TR_RDX ;  &andq $ &SPEC_CTRL_IBRS| &SPEC_CTRL_STIBP, % &rax ;  &movq $ &MSR_SPEC_CTRL,% &rcx ;  &xorl % &edx,% &edx ;  &wrmsr ;  &movq  &PCPU( &trampoline)+ &TR_RDX, % &rdx ;  &movq  &PCPU( &trampoline)+ &TR_RCX, % &rcx ; 42:  &movq  &PCPU( &trampoline)+ &TR_RAX, % &rax ; 43:;}' unless defined(&KMMUEXIT_CORE);
	eval 'sub KMMUEXIT () { &addq $ &TF_RIP,% &rsp ;  &KMMUEXIT_CORE ;  &testq $ &PCB_ISOMMU, &PCPU( &trampoline)+ &TR_PCB_FLAGS ;  &je 50 &f ;  &movq % &rcx,  &PCPU( &trampoline)+ &TR_ERR ;  &popq % &rcx ;  &movq % &rcx,  &PCPU( &trampoline)+ &TR_RIP ;  &popq % &rcx ;  &movq % &rcx,  &PCPU( &trampoline)+ &TR_CS ;  &popq % &rcx ;  &movq % &rcx,  &PCPU( &trampoline)+ &TR_RFLAGS ;  &popq % &rcx ;  &movq % &rcx,  &PCPU( &trampoline)+ &TR_RSP ;  &popq % &rcx ;  &movq % &rcx,  &PCPU( &trampoline)+ &TR_SS ;  &movq % &gs:0,% &rcx ;  &addq $ &GD_TRAMPOLINE+ &TR_ERR,% &rcx ;  &movq % &rcx,% &rsp ;  &movq  &PCPU( &trampoline)+ &TR_PCB_CR3_ISO,% &rcx ;  &movq % &rcx,% &cr3 ;  &popq % &rcx ; 50:;}' unless defined(&KMMUEXIT);
	eval 'sub KMMUEXIT_SYSCALL () { &KMMUEXIT_CORE ;  &testq $ &PCB_ISOMMU, &PCPU( &trampoline)+ &TR_PCB_FLAGS ;  &je 50 &f ;  &movq % &rcx,  &PCPU( &trampoline)+ &TR_RCX ;  &movq  &PCPU( &trampoline)+ &TR_PCB_CR3_ISO,% &rcx ;  &movq % &rcx,% &cr3 ;  &movq  &PCPU( &trampoline)+ &TR_RCX, % &rcx ; 50:;}' unless defined(&KMMUEXIT_SYSCALL);
	eval 'sub PUSH_FRAME_REGS () { &movq % &rdi, &TF_RDI(% &rsp) ;  &movq % &rsi, &TF_RSI(% &rsp) ;  &movq % &rdx, &TF_RDX(% &rsp) ;  &movq % &rcx, &TF_RCX(% &rsp) ;  &movq % &r8, &TF_R8(% &rsp) ;  &movq % &r9, &TF_R9(% &rsp) ;  &movq % &rax, &TF_RAX(% &rsp) ;  &movq % &rbx, &TF_RBX(% &rsp) ;  &movq % &rbp, &TF_RBP(% &rsp) ;  &movq % &r10, &TF_R10(% &rsp) ;  &movq % &r11, &TF_R11(% &rsp) ;  &movq % &r12, &TF_R12(% &rsp) ;  &movq % &r13, &TF_R13(% &rsp) ;  &movq % &r14, &TF_R14(% &rsp) ;  &movq % &r15, &TF_R15(% &rsp) ;  &xorq % &rax,% &rax ;  &movq % &rax,% &rbx ;  &movq % &rax,% &rcx ;  &movq % &rax,% &rdx ;  &movq % &rax,% &rdi ;  &movq % &rax,% &rsi ;  &movq % &rax,% &rbp ;  &movq % &rax,% &r8 ;  &movq % &rax,% &r9 ;  &movq % &rax,% &r10 ;  &movq % &rax,% &r11 ;  &movq % &rax,% &r12 ;  &movq % &rax,% &r13 ;  &movq % &rax,% &r14 ;  &movq % &rax,% &r15;}' unless defined(&PUSH_FRAME_REGS);
	eval 'sub PUSH_FRAME_TFRIP () { &testb $ &SEL_RPL_MASK, &TF_CS- &TF_RIP(% &rsp) ;  &jz 1 &f ;  &swapgs ;  &KMMUENTER_TFRIP ; 1:  &subq $ &TF_RIP,% &rsp ;  &PUSH_FRAME_REGS ;  &SMAP_CLOSE;}' unless defined(&PUSH_FRAME_TFRIP);
	eval 'sub PUSH_FRAME_TFERR () { &testb $ &SEL_RPL_MASK, &TF_CS- &TF_ERR(% &rsp) ;  &jz 1 &f ;  &swapgs ;  &KMMUENTER_TFERR ; 1:  &subq $ &TF_ERR,% &rsp ;  &PUSH_FRAME_REGS ;  &SMAP_CLOSE;}' unless defined(&PUSH_FRAME_TFERR);
	eval 'sub PUSH_FRAME_TFERR_SAVECR2 () { &testb $ &SEL_RPL_MASK, &TF_CS- &TF_ERR(% &rsp) ;  &jz 1 &f ;  &swapgs ;  &KMMUENTER_TFERR_SAVECR2 ;  &subq $ &TF_ERR,% &rsp ;  &PUSH_FRAME_REGS ;  &movq  &PCPU( &trampoline)+ &TR_CR2, % &r10 ;  &jmp 2 &f ; 1:  &subq $ &TF_ERR,% &rsp ;  &PUSH_FRAME_REGS ;  &movq % &cr2, % &r10 ; 2:  &movq % &r10,  &TF_ADDR(% &rsp) ;  &SMAP_CLOSE;}' unless defined(&PUSH_FRAME_TFERR_SAVECR2);
	eval 'sub POP_FRAME {
	    my($lastinsn) = @_;
    	    eval q( &movq  &TF_RDI(% &rsp),% &rdi ;  &movq  &TF_RSI(% &rsp),% &rsi ;  &movq  &TF_RDX(% &rsp),% &rdx ;  &movq  &TF_RCX(% &rsp),% &rcx ;  &movq  &TF_R8(% &rsp),% &r8 ;  &movq  &TF_R9(% &rsp),% &r9 ;  &movq  &TF_RAX(% &rsp),% &rax ;  &movq  &TF_RBX(% &rsp),% &rbx ;  &movq  &TF_RBP(% &rsp),% &rbp ;  &movq  &TF_R10(% &rsp),% &r10 ;  &movq  &TF_R11(% &rsp),% &r11 ;  &movq  &TF_R12(% &rsp),% &r12 ;  &movq  &TF_R13(% &rsp),% &r13 ;  &movq  &TF_R14(% &rsp),% &r14 ;  &movq  &TF_R15(% &rsp),% &r15 ;  &cli ;  &testb $ &SEL_RPL_MASK, &TF_CS(% &rsp) ;  &jz 1 &f ;  &KMMUEXIT ;  &swapgs ;  &jmp 2 &f ; 1:  &addq $ &TF_RIP,% &rsp ; 2: $lastinsn);
	}' unless defined(&POP_FRAME);
	eval 'sub PCPU {
	    my($member) = @_;
    	    eval q(% &gs: &gd_  $member);
	}' unless defined(&PCPU);
	eval 'sub PCPU_E8 {
	    my($member,$idx) = @_;
    	    eval q(% &gs: &gd_  $member(,$idx,8));
	}' unless defined(&PCPU_E8);
	eval 'sub PCPU_ADDR {
	    my($member, $reg) = @_;
    	    eval q( &movq % &gs: &PC_PRVSPACE, $reg ;  &addq $ &PC_  $member, $reg);
	}' unless defined(&PCPU_ADDR);
	eval 'sub SMAP_OPEN () {. &globl  &__start_set_smap_open ; . &globl  &__stop_set_smap_open ; 60:  &nop % &eax ; . &section  &set_smap_open,"aw" ; . &quad 60 &b ; . &previous;}' unless defined(&SMAP_OPEN);
	eval 'sub SMAP_CLOSE () {. &globl  &__start_set_smap_close ; . &globl  &__stop_set_smap_close ; 60:  &nop % &eax ; . &section  &set_smap_close,"aw" ; . &quad 60 &b ; . &previous;}' unless defined(&SMAP_CLOSE);
    }
}
1;
