require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CPU_BUS_DMA_H_)) {
    eval 'sub _CPU_BUS_DMA_H_ () {1;}' unless defined(&_CPU_BUS_DMA_H_);
    require 'machine/cpufunc.ph';
    eval 'sub BUS_SPACE_MAXSIZE_24BIT () {0xffffff;}' unless defined(&BUS_SPACE_MAXSIZE_24BIT);
    eval 'sub BUS_SPACE_MAXSIZE_32BIT () {0xffffffff;}' unless defined(&BUS_SPACE_MAXSIZE_32BIT);
    eval 'sub BUS_SPACE_MAXSIZE () {(64* 1024);}' unless defined(&BUS_SPACE_MAXSIZE);
    eval 'sub BUS_SPACE_MAXADDR_24BIT () {0xffffff;}' unless defined(&BUS_SPACE_MAXADDR_24BIT);
    eval 'sub BUS_SPACE_MAXADDR_32BIT () {0xffffffff;}' unless defined(&BUS_SPACE_MAXADDR_32BIT);
    eval 'sub BUS_SPACE_MAXADDR () {0xffffffffffffffff;}' unless defined(&BUS_SPACE_MAXADDR);
    eval 'sub BUS_SPACE_UNRESTRICTED () {(~0);}' unless defined(&BUS_SPACE_UNRESTRICTED);
    eval 'sub X86_64_BUS_SPACE_IO () {0;}' unless defined(&X86_64_BUS_SPACE_IO);
    eval 'sub X86_64_BUS_SPACE_MEM () {1;}' unless defined(&X86_64_BUS_SPACE_MEM);
    eval 'sub bus_space_subregion {
        my($__unused,$bsh,$offset,$__unused,$nbshp) = @_;
	    eval q({ *$nbshp = $bsh + $offset; (0); });
    }' unless defined(&bus_space_subregion);
    eval 'sub bus_space_kva {
        my($tag,$handle,$offset) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO) (( &void *)0); (( &void *)($handle + $offset)); });
    }' unless defined(&bus_space_kva);
    eval 'sub bus_space_free {
        my($__unused,$__unused,$__unused) = @_;
	    eval q({ });
    }' unless defined(&bus_space_free);
    eval 'sub bus_space_read_1 {
        my($tag,$handle,$offset) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO) ( &inb($handle + $offset)); (*( &volatile  &u_int8_t *)($handle + $offset)); });
    }' unless defined(&bus_space_read_1);
    eval 'sub bus_space_read_2 {
        my($tag,$handle,$offset) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO) ( &inw($handle + $offset)); (*( &volatile  &u_int16_t *)($handle + $offset)); });
    }' unless defined(&bus_space_read_2);
    eval 'sub bus_space_read_4 {
        my($tag,$handle,$offset) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO) ( &inl($handle + $offset)); (*( &volatile  &u_int32_t *)($handle + $offset)); });
    }' unless defined(&bus_space_read_4);
    if(defined(&_KERNEL)) {
	eval 'sub bus_space_read_8 {
	    my($tag,$handle,$offset) = @_;
    	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &panic(\\"bus_space_read_8: illegal on I/O space\\"); (*( &volatile  &u_int64_t *)($handle + $offset)); });
	}' unless defined(&bus_space_read_8);
    }
    eval 'sub bus_space_read_multi_1 {
        my($tag,$bsh,$offset,$addr,$count) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &insb($bsh + $offset, $addr, $count);  &else {  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n		1:	movb (%2),%%al				\\\\n			stosb					\\\\n			loop 1b\\" : \\"=D\\" ($addr), \\"=c\\" ($count) : \\"r\\" ($bsh + $offset), \\"0\\" ($addr), \\"1\\" ($count) : \\"%eax\\", \\"memory\\"); } });
    }' unless defined(&bus_space_read_multi_1);
    eval 'sub bus_space_read_multi_2 {
        my($tag,$bsh,$offset,$addr,$count) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &insw($bsh + $offset, $addr, $count);  &else {  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n		1:	movw (%2),%%ax				\\\\n			stosw					\\\\n			loop 1b\\" : \\"=D\\" ($addr), \\"=c\\" ($count) : \\"r\\" ($bsh + $offset), \\"0\\" ($addr), \\"1\\" ($count) : \\"%eax\\", \\"memory\\"); } });
    }' unless defined(&bus_space_read_multi_2);
    eval 'sub bus_space_read_multi_4 {
        my($tag,$bsh,$offset,$addr,$count) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &insl($bsh + $offset, $addr, $count);  &else {  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n		1:	movl (%2),%%eax				\\\\n			stosl					\\\\n			loop 1b\\" : \\"=D\\" ($addr), \\"=c\\" ($count) : \\"r\\" ($bsh + $offset), \\"0\\" ($addr), \\"1\\" ($count) : \\"%eax\\", \\"memory\\"); } });
    }' unless defined(&bus_space_read_multi_4);
    if(0) {
	eval 'sub bus_space_read_multi_8 () {!!!  &bus_space_read_multi_8  &unimplemented !!!;}' unless defined(&bus_space_read_multi_8);
    }
    eval 'sub bus_space_read_region_1 {
        my($tag,$bsh,$offset,$addr,$count) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO) { \'int\'  &_port_ = $bsh + $offset;  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n		1:	inb %w2,%%al				\\\\n			stosb					\\\\n			incl %2					\\\\n			loop 1b\\" : \\"=D\\" ($addr), \\"=c\\" ($count), \\"=d\\" ( &_port_) : \\"0\\" ($addr), \\"1\\" ($count), \\"2\\" ( &_port_) : \\"%eax\\", \\"memory\\", \\"cc\\"); }  &else {  &bus_space_handle_t  &_port_ = $bsh + $offset;  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n			repne					\\\\n			movsb\\" : \\"=D\\" ($addr), \\"=c\\" ($count), \\"=S\\" ( &_port_) : \\"0\\" ($addr), \\"1\\" ($count), \\"2\\" ( &_port_) : \\"memory\\", \\"cc\\"); } });
    }' unless defined(&bus_space_read_region_1);
    eval 'sub bus_space_read_region_2 {
        my($tag,$bsh,$offset,$addr,$count) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO) { \'int\'  &_port_ = $bsh + $offset;  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n		1:	inw %w2,%%ax				\\\\n			stosw					\\\\n			addl $2,%2				\\\\n			loop 1b\\" : \\"=D\\" ($addr), \\"=c\\" ($count), \\"=d\\" ( &_port_) : \\"0\\" ($addr), \\"1\\" ($count), \\"2\\" ( &_port_) : \\"%eax\\", \\"memory\\", \\"cc\\"); }  &else {  &bus_space_handle_t  &_port_ = $bsh + $offset;  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n			repne					\\\\n			movsw\\" : \\"=D\\" ($addr), \\"=c\\" ($count), \\"=S\\" ( &_port_) : \\"0\\" ($addr), \\"1\\" ($count), \\"2\\" ( &_port_) : \\"memory\\", \\"cc\\"); } });
    }' unless defined(&bus_space_read_region_2);
    eval 'sub bus_space_read_region_4 {
        my($tag,$bsh,$offset,$addr,$count) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO) { \'int\'  &_port_ = $bsh + $offset;  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n		1:	inl %w2,%%eax				\\\\n			stosl					\\\\n			addl $4,%2				\\\\n			loop 1b\\" : \\"=D\\" ($addr), \\"=c\\" ($count), \\"=d\\" ( &_port_) : \\"0\\" ($addr), \\"1\\" ($count), \\"2\\" ( &_port_) : \\"%eax\\", \\"memory\\", \\"cc\\"); }  &else {  &bus_space_handle_t  &_port_ = $bsh + $offset;  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n			repne					\\\\n			movsl\\" : \\"=D\\" ($addr), \\"=c\\" ($count), \\"=S\\" ( &_port_) : \\"0\\" ($addr), \\"1\\" ($count), \\"2\\" ( &_port_) : \\"memory\\", \\"cc\\"); } });
    }' unless defined(&bus_space_read_region_4);
    if(0) {
	eval 'sub bus_space_read_region_8 () {!!!  &bus_space_read_region_8  &unimplemented !!!;}' unless defined(&bus_space_read_region_8);
    }
    eval 'sub bus_space_write_1 {
        my($tag,$bsh,$offset,$value) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &outb($bsh + $offset, $value);  &else *( &volatile  &u_int8_t *)($bsh + $offset) = $value; });
    }' unless defined(&bus_space_write_1);
    eval 'sub bus_space_write_2 {
        my($tag,$bsh,$offset,$value) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &outw($bsh + $offset, $value);  &else *( &volatile  &u_int16_t *)($bsh + $offset) = $value; });
    }' unless defined(&bus_space_write_2);
    eval 'sub bus_space_write_4 {
        my($tag,$bsh,$offset,$value) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &outl($bsh + $offset, $value);  &else *( &volatile  &u_int32_t *)($bsh + $offset) = $value; });
    }' unless defined(&bus_space_write_4);
    if(defined(&_KERNEL)) {
	eval 'sub bus_space_write_8 {
	    my($tag,$bsh,$offset,$value) = @_;
    	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &panic(\\"bus_space_write_8: illegal on I/O space\\"); *( &volatile  &u_int64_t *)($bsh + $offset) = $value; });
	}' unless defined(&bus_space_write_8);
    }
    eval 'sub bus_space_write_multi_1 {
        my($tag,$bsh,$offset,$addr,$count) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &outsb($bsh + $offset, $addr, $count);  &else {  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n		1:	lodsb					\\\\n			movb %%al,(%2)				\\\\n			loop 1b\\" : \\"=S\\" ($addr), \\"=c\\" ($count) : \\"r\\" ($bsh + $offset), \\"0\\" ($addr), \\"1\\" ($count) : \\"%eax\\", \\"memory\\", \\"cc\\"); } });
    }' unless defined(&bus_space_write_multi_1);
    eval 'sub bus_space_write_multi_2 {
        my($tag,$bsh,$offset,$addr,$count) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &outsw($bsh + $offset, $addr, $count);  &else {  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n		1:	lodsw					\\\\n			movw %%ax,(%2)				\\\\n			loop 1b\\" : \\"=S\\" ($addr), \\"=c\\" ($count) : \\"r\\" ($bsh + $offset), \\"0\\" ($addr), \\"1\\" ($count) : \\"%eax\\", \\"memory\\", \\"cc\\"); } });
    }' unless defined(&bus_space_write_multi_2);
    eval 'sub bus_space_write_multi_4 {
        my($tag,$bsh,$offset,$addr,$count) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &outsl($bsh + $offset, $addr, $count);  &else {  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n		1:	lodsl					\\\\n			movl %%eax,(%2)				\\\\n			loop 1b\\" : \\"=S\\" ($addr), \\"=c\\" ($count) : \\"r\\" ($bsh + $offset), \\"0\\" ($addr), \\"1\\" ($count) : \\"%eax\\", \\"memory\\", \\"cc\\"); } });
    }' unless defined(&bus_space_write_multi_4);
    if(0) {
	eval 'sub bus_space_write_multi_8 {
	    my($t, $h, $o, $a, $c) = @_;
    	    eval q(!!!  &bus_space_write_multi_8  &unimplemented !!!);
	}' unless defined(&bus_space_write_multi_8);
    }
    eval 'sub bus_space_write_region_1 {
        my($tag,$bsh,$offset,$addr,$count) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO) { \'int\'  &_port_ = $bsh + $offset;  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n		1:	lodsb					\\\\n			outb %%al,%w0				\\\\n			incl %0					\\\\n			loop 1b\\" : \\"=d\\" ( &_port_), \\"=S\\" ($addr), \\"=c\\" ($count) : \\"0\\" ( &_port_), \\"1\\" ($addr), \\"2\\" ($count) : \\"%eax\\", \\"memory\\", \\"cc\\"); }  &else {  &bus_space_handle_t  &_port_ = $bsh + $offset;  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n			repne					\\\\n			movsb\\" : \\"=D\\" ( &_port_), \\"=S\\" ($addr), \\"=c\\" ($count) : \\"0\\" ( &_port_), \\"1\\" ($addr), \\"2\\" ($count) : \\"memory\\", \\"cc\\"); } });
    }' unless defined(&bus_space_write_region_1);
    eval 'sub bus_space_write_region_2 {
        my($tag,$bsh,$offset,$addr,$count) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO) { \'int\'  &_port_ = $bsh + $offset;  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n		1:	lodsw					\\\\n			outw %%ax,%w0				\\\\n			addl $2,%0				\\\\n			loop 1b\\" : \\"=d\\" ( &_port_), \\"=S\\" ($addr), \\"=c\\" ($count) : \\"0\\" ( &_port_), \\"1\\" ($addr), \\"2\\" ($count) : \\"%eax\\", \\"memory\\", \\"cc\\"); }  &else {  &bus_space_handle_t  &_port_ = $bsh + $offset;  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n			repne					\\\\n			movsw\\" : \\"=D\\" ( &_port_), \\"=S\\" ($addr), \\"=c\\" ($count) : \\"0\\" ( &_port_), \\"1\\" ($addr), \\"2\\" ($count) : \\"memory\\", \\"cc\\"); } });
    }' unless defined(&bus_space_write_region_2);
    eval 'sub bus_space_write_region_4 {
        my($tag,$bsh,$offset,$addr,$count) = @_;
	    eval q({  &if ($tag ==  &X86_64_BUS_SPACE_IO) { \'int\'  &_port_ = $bsh + $offset;  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n		1:	lodsl					\\\\n			outl %%eax,%w0				\\\\n			addl $4,%0				\\\\n			loop 1b\\" : \\"=d\\" ( &_port_), \\"=S\\" ($addr), \\"=c\\" ($count) : \\"0\\" ( &_port_), \\"1\\" ($addr), \\"2\\" ($count) : \\"%eax\\", \\"memory\\", \\"cc\\"); }  &else {  &bus_space_handle_t  &_port_ = $bsh + $offset;  &__asm  &__volatile(\\"				\\\\n			cld					\\\\n			repne					\\\\n			movsl\\" : \\"=D\\" ( &_port_), \\"=S\\" ($addr), \\"=c\\" ($count) : \\"0\\" ( &_port_), \\"1\\" ($addr), \\"2\\" ($count) : \\"memory\\", \\"cc\\"); } });
    }' unless defined(&bus_space_write_region_4);
    if(0) {
	eval 'sub bus_space_write_region_8 () {!!!  &bus_space_write_region_8  &unimplemented !!!;}' unless defined(&bus_space_write_region_8);
    }
    eval 'sub bus_space_set_multi_1 {
        my($tag,$bsh,$offset,$value,$count) = @_;
	    eval q({  &bus_space_handle_t  &addr = $bsh + $offset;  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &while ($count--)  &outb( &addr, $value);  &else  &while ($count--) *( &volatile  &u_int8_t *)( &addr) = $value; });
    }' unless defined(&bus_space_set_multi_1);
    eval 'sub bus_space_set_multi_2 {
        my($tag,$bsh,$offset,$value,$count) = @_;
	    eval q({  &bus_space_handle_t  &addr = $bsh + $offset;  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &while ($count--)  &outw( &addr, $value);  &else  &while ($count--) *( &volatile  &u_int16_t *)( &addr) = $value; });
    }' unless defined(&bus_space_set_multi_2);
    eval 'sub bus_space_set_multi_4 {
        my($tag,$bsh,$offset,$value,$count) = @_;
	    eval q({  &bus_space_handle_t  &addr = $bsh + $offset;  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &while ($count--)  &outl( &addr, $value);  &else  &while ($count--) *( &volatile  &u_int32_t *)( &addr) = $value; });
    }' unless defined(&bus_space_set_multi_4);
    if(0) {
	eval 'sub bus_space_set_multi_8 () {!!!  &bus_space_set_multi_8  &unimplemented !!!;}' unless defined(&bus_space_set_multi_8);
    }
    eval 'sub bus_space_set_region_1 {
        my($tag,$bsh,$offset,$value,$count) = @_;
	    eval q({  &bus_space_handle_t  &addr = $bsh + $offset;  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &for (; $count != 0; $count--,  &addr++)  &outb( &addr, $value);  &else  &for (; $count != 0; $count--,  &addr++) *( &volatile  &u_int8_t *)( &addr) = $value; });
    }' unless defined(&bus_space_set_region_1);
    eval 'sub bus_space_set_region_2 {
        my($tag,$bsh,$offset,$value,$count) = @_;
	    eval q({  &bus_space_handle_t  &addr = $bsh + $offset;  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &for (; $count != 0; $count--,  &addr += 2)  &outw( &addr, $value);  &else  &for (; $count != 0; $count--,  &addr += 2) *( &volatile  &u_int16_t *)( &addr) = $value; });
    }' unless defined(&bus_space_set_region_2);
    eval 'sub bus_space_set_region_4 {
        my($tag,$bsh,$offset,$value,$count) = @_;
	    eval q({  &bus_space_handle_t  &addr = $bsh + $offset;  &if ($tag ==  &X86_64_BUS_SPACE_IO)  &for (; $count != 0; $count--,  &addr += 4)  &outl( &addr, $value);  &else  &for (; $count != 0; $count--,  &addr += 4) *( &volatile  &u_int32_t *)( &addr) = $value; });
    }' unless defined(&bus_space_set_region_4);
    if(0) {
	eval 'sub bus_space_set_region_8 () {!!!  &bus_space_set_region_8  &unimplemented !!!;}' unless defined(&bus_space_set_region_8);
    }
    eval 'sub bus_space_copy_region_1 {
        my($tag,$bsh1,$off1,$bsh2,$off2,$count) = @_;
	    eval q({  &bus_space_handle_t  &addr1 = $bsh1 + $off1;  &bus_space_handle_t  &addr2 = $bsh2 + $off2;  &if ($tag ==  &X86_64_BUS_SPACE_IO) {  &if ( &addr1 >=  &addr2) {  &for (; $count != 0; $count--,  &addr1++,  &addr2++)  &outb( &addr2,  &inb( &addr1)); }  &else {  &for ( &addr1 += ($count - 1),  &addr2 += ($count - 1); $count != 0; $count--,  &addr1--,  &addr2--)  &outb( &addr2,  &inb( &addr1)); } }  &else {  &if ( &addr1 >=  &addr2) {  &for (; $count != 0; $count--,  &addr1++,  &addr2++) *( &volatile  &u_int8_t *)( &addr2) = *( &volatile  &u_int8_t *)( &addr1); }  &else {  &for ( &addr1 += ($count - 1),  &addr2 += ($count - 1); $count != 0; $count--,  &addr1--,  &addr2--) *( &volatile  &u_int8_t *)( &addr2) = *( &volatile  &u_int8_t *)( &addr1); } } });
    }' unless defined(&bus_space_copy_region_1);
    eval 'sub bus_space_copy_region_2 {
        my($tag,$bsh1,$off1,$bsh2,$off2,$count) = @_;
	    eval q({  &bus_space_handle_t  &addr1 = $bsh1 + $off1;  &bus_space_handle_t  &addr2 = $bsh2 + $off2;  &if ($tag ==  &X86_64_BUS_SPACE_IO) {  &if ( &addr1 >=  &addr2) {  &for (; $count != 0; $count--,  &addr1 += 2,  &addr2 += 2)  &outw( &addr2,  &inw( &addr1)); }  &else {  &for ( &addr1 += 2* ($count - 1),  &addr2 += 2* ($count - 1); $count != 0; $count--,  &addr1 -= 2,  &addr2 -= 2)  &outw( &addr2,  &inw( &addr1)); } }  &else {  &if ( &addr1 >=  &addr2) {  &for (; $count != 0; $count--,  &addr1 += 2,  &addr2 += 2) *( &volatile  &u_int16_t *)( &addr2) = *( &volatile  &u_int16_t *)( &addr1); }  &else {  &for ( &addr1 += 2* ($count - 1),  &addr2 += 2* ($count - 1); $count != 0; $count--,  &addr1 -= 2,  &addr2 -= 2) *( &volatile  &u_int16_t *)( &addr2) = *( &volatile  &u_int16_t *)( &addr1); } } });
    }' unless defined(&bus_space_copy_region_2);
    eval 'sub bus_space_copy_region_4 {
        my($tag,$bsh1,$off1,$bsh2,$off2,$count) = @_;
	    eval q({  &bus_space_handle_t  &addr1 = $bsh1 + $off1;  &bus_space_handle_t  &addr2 = $bsh2 + $off2;  &if ($tag ==  &X86_64_BUS_SPACE_IO) {  &if ( &addr1 >=  &addr2) {  &for (; $count != 0; $count--,  &addr1 += 4,  &addr2 += 4)  &outl( &addr2,  &inl( &addr1)); }  &else {  &for ( &addr1 += 4* ($count - 1),  &addr2 += 4* ($count - 1); $count != 0; $count--,  &addr1 -= 4,  &addr2 -= 4)  &outl( &addr2,  &inl( &addr1)); } }  &else {  &if ( &addr1 >=  &addr2) {  &for (; $count != 0; $count--,  &addr1 += 4,  &addr2 += 4) *( &volatile  &u_int32_t *)( &addr2) = *( &volatile  &u_int32_t *)( &addr1); }  &else {  &for ( &addr1 += 4* ($count - 1),  &addr2 += 4* ($count - 1); $count != 0; $count--,  &addr1 -= 4,  &addr2 -= 4) *( &volatile  &u_int32_t *)( &addr2) = *( &volatile  &u_int32_t *)( &addr1); } } });
    }' unless defined(&bus_space_copy_region_4);
    if(0) {
	eval 'sub bus_space_copy_region_8 () {!!!  &bus_space_copy_region_8  &unimplemented !!!;}' unless defined(&bus_space_copy_region_8);
    }
    eval 'sub BUS_SPACE_BARRIER_READ () {0x1;}' unless defined(&BUS_SPACE_BARRIER_READ);
    eval 'sub BUS_SPACE_BARRIER_WRITE () {0x2;}' unless defined(&BUS_SPACE_BARRIER_WRITE);
    eval 'sub bus_space_barrier {
        my($__unused,$__unused,$__unused,$__unused,$flags) = @_;
	    eval q({  &if ($flags &  &BUS_SPACE_BARRIER_READ)  &__asm  &__volatile(\\"lock; addl $0,0(%%rsp)\\" : : : \\"memory\\");  &else  &__asm  &__volatile(\\"\\" : : : \\"memory\\"); });
    }' unless defined(&bus_space_barrier);
    eval 'sub bus_space_read_stream_1 {
        my($t, $h, $o) = @_;
	    eval q( &bus_space_read_1(($t), ($h), ($o)));
    }' unless defined(&bus_space_read_stream_1);
    eval 'sub bus_space_read_stream_2 {
        my($t, $h, $o) = @_;
	    eval q( &bus_space_read_2(($t), ($h), ($o)));
    }' unless defined(&bus_space_read_stream_2);
    eval 'sub bus_space_read_stream_4 {
        my($t, $h, $o) = @_;
	    eval q( &bus_space_read_4(($t), ($h), ($o)));
    }' unless defined(&bus_space_read_stream_4);
    eval 'sub bus_space_read_multi_stream_1 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &bus_space_read_multi_1(($t), ($h), ($o), ($a), ($c)));
    }' unless defined(&bus_space_read_multi_stream_1);
    eval 'sub bus_space_read_multi_stream_2 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &bus_space_read_multi_2(($t), ($h), ($o), ($a), ($c)));
    }' unless defined(&bus_space_read_multi_stream_2);
    eval 'sub bus_space_read_multi_stream_4 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &bus_space_read_multi_4(($t), ($h), ($o), ($a), ($c)));
    }' unless defined(&bus_space_read_multi_stream_4);
    eval 'sub bus_space_write_stream_1 {
        my($t, $h, $o, $v) = @_;
	    eval q( &bus_space_write_1(($t), ($h), ($o), ($v)));
    }' unless defined(&bus_space_write_stream_1);
    eval 'sub bus_space_write_stream_2 {
        my($t, $h, $o, $v) = @_;
	    eval q( &bus_space_write_2(($t), ($h), ($o), ($v)));
    }' unless defined(&bus_space_write_stream_2);
    eval 'sub bus_space_write_stream_4 {
        my($t, $h, $o, $v) = @_;
	    eval q( &bus_space_write_4(($t), ($h), ($o), ($v)));
    }' unless defined(&bus_space_write_stream_4);
    eval 'sub bus_space_write_multi_stream_1 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &bus_space_write_multi_1(($t), ($h), ($o), ($a), ($c)));
    }' unless defined(&bus_space_write_multi_stream_1);
    eval 'sub bus_space_write_multi_stream_2 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &bus_space_write_multi_2(($t), ($h), ($o), ($a), ($c)));
    }' unless defined(&bus_space_write_multi_stream_2);
    eval 'sub bus_space_write_multi_stream_4 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &bus_space_write_multi_4(($t), ($h), ($o), ($a), ($c)));
    }' unless defined(&bus_space_write_multi_stream_4);
    eval 'sub bus_space_set_multi_stream_1 {
        my($t, $h, $o, $v, $c) = @_;
	    eval q( &bus_space_set_multi_1(($t), ($h), ($o), ($v), ($c)));
    }' unless defined(&bus_space_set_multi_stream_1);
    eval 'sub bus_space_set_multi_stream_2 {
        my($t, $h, $o, $v, $c) = @_;
	    eval q( &bus_space_set_multi_2(($t), ($h), ($o), ($v), ($c)));
    }' unless defined(&bus_space_set_multi_stream_2);
    eval 'sub bus_space_set_multi_stream_4 {
        my($t, $h, $o, $v, $c) = @_;
	    eval q( &bus_space_set_multi_4(($t), ($h), ($o), ($v), ($c)));
    }' unless defined(&bus_space_set_multi_stream_4);
    eval 'sub bus_space_read_region_stream_1 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &bus_space_read_region_1(($t), ($h), ($o), ($a), ($c)));
    }' unless defined(&bus_space_read_region_stream_1);
    eval 'sub bus_space_read_region_stream_2 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &bus_space_read_region_2(($t), ($h), ($o), ($a), ($c)));
    }' unless defined(&bus_space_read_region_stream_2);
    eval 'sub bus_space_read_region_stream_4 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &bus_space_read_region_4(($t), ($h), ($o), ($a), ($c)));
    }' unless defined(&bus_space_read_region_stream_4);
    eval 'sub bus_space_write_region_stream_1 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &bus_space_write_region_1(($t), ($h), ($o), ($a), ($c)));
    }' unless defined(&bus_space_write_region_stream_1);
    eval 'sub bus_space_write_region_stream_2 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &bus_space_write_region_2(($t), ($h), ($o), ($a), ($c)));
    }' unless defined(&bus_space_write_region_stream_2);
    eval 'sub bus_space_write_region_stream_4 {
        my($t, $h, $o, $a, $c) = @_;
	    eval q( &bus_space_write_region_4(($t), ($h), ($o), ($a), ($c)));
    }' unless defined(&bus_space_write_region_stream_4);
    eval 'sub bus_space_set_region_stream_1 {
        my($t, $h, $o, $v, $c) = @_;
	    eval q( &bus_space_set_region_1(($t), ($h), ($o), ($v), ($c)));
    }' unless defined(&bus_space_set_region_stream_1);
    eval 'sub bus_space_set_region_stream_2 {
        my($t, $h, $o, $v, $c) = @_;
	    eval q( &bus_space_set_region_2(($t), ($h), ($o), ($v), ($c)));
    }' unless defined(&bus_space_set_region_stream_2);
    eval 'sub bus_space_set_region_stream_4 {
        my($t, $h, $o, $v, $c) = @_;
	    eval q( &bus_space_set_region_4(($t), ($h), ($o), ($v), ($c)));
    }' unless defined(&bus_space_set_region_stream_4);
    eval 'sub bus_space_copy_region_stream_1 {
        my($t, $h1, $o1, $h2, $o2, $c) = @_;
	    eval q( &bus_space_copy_region_1(($t), ($h1), ($o1), ($h2), ($o2), ($c)));
    }' unless defined(&bus_space_copy_region_stream_1);
    eval 'sub bus_space_copy_region_stream_2 {
        my($t, $h1, $o1, $h2, $o2, $c) = @_;
	    eval q( &bus_space_copy_region_2(($t), ($h1), ($o1), ($h2), ($o2), ($c)));
    }' unless defined(&bus_space_copy_region_stream_2);
    eval 'sub bus_space_copy_region_stream_4 {
        my($t, $h1, $o1, $h2, $o2, $c) = @_;
	    eval q( &bus_space_copy_region_4(($t), ($h1), ($o1), ($h2), ($o2), ($c)));
    }' unless defined(&bus_space_copy_region_stream_4);
}
1;
