require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CPU_CPUMASK_H_)) {
    eval 'sub _CPU_CPUMASK_H_ () {1;}' unless defined(&_CPU_CPUMASK_H_);
    require 'machine/stdint.ph';
    if(defined(&_KERNEL)) {
	require 'cpu/atomic.ph';
    }
    eval 'sub CPUMASK_ELEMENTS () {4;}' unless defined(&CPUMASK_ELEMENTS);
    eval 'sub CPUMASK_INITIALIZER_ALLONES () {{ . &ary = { ( &__uint64_t)-1, ( &__uint64_t)-1, ( &__uint64_t)-1, ( &__uint64_t)-1} };}' unless defined(&CPUMASK_INITIALIZER_ALLONES);
    eval 'sub CPUMASK_INITIALIZER_ONLYONE () {{ . &ary = { 1, 0, 0, 0} };}' unless defined(&CPUMASK_INITIALIZER_ONLYONE);
    eval 'sub CPUMASK_SIMPLE {
        my($cpu) = @_;
	    eval q((( &__uint64_t)1<< ($cpu)));
    }' unless defined(&CPUMASK_SIMPLE);
    eval 'sub CPUMASK_ADDR {
        my($mask, $cpu) = @_;
	    eval q((($mask). $ary[(($cpu) >> 6) & 3]));
    }' unless defined(&CPUMASK_ADDR);
    eval 'sub BSRCPUMASK {
        my($val) = @_;
	    eval q((($val). $ary[3] ? 192+  &bsrq(($val). $ary[3]) : (($val). $ary[2] ? 128+  &bsrq(($val). $ary[2]) : (($val). $ary[1] ? 64+  &bsrq(($val). $ary[1]) :  &bsrq(($val). $ary[0])))));
    }' unless defined(&BSRCPUMASK);
    eval 'sub BSFCPUMASK {
        my($val) = @_;
	    eval q((($val). $ary[0] ?  &bsfq(($val). $ary[0]) : (($val). $ary[1] ? 64+  &bsfq(($val). $ary[1]) : (($val). $ary[2] ? 128+  &bsfq(($val). $ary[2]) : 192+  &bsfq(($val). $ary[3])))));
    }' unless defined(&BSFCPUMASK);
    eval 'sub CPUMASK_CMPMASKEQ {
        my($val1, $val2) = @_;
	    eval q((($val1). $ary[0] == ($val2). $ary[0]  && ($val1). $ary[1] == ($val2). $ary[1]  && ($val1). $ary[2] == ($val2). $ary[2]  && ($val1). $ary[3] == ($val2). $ary[3]));
    }' unless defined(&CPUMASK_CMPMASKEQ);
    eval 'sub CPUMASK_CMPMASKNEQ {
        my($val1, $val2) = @_;
	    eval q((($val1). $ary[0] != ($val2). $ary[0] || ($val1). $ary[1] != ($val2). $ary[1] || ($val1). $ary[2] != ($val2). $ary[2] || ($val1). $ary[3] != ($val2). $ary[3]));
    }' unless defined(&CPUMASK_CMPMASKNEQ);
    eval 'sub CPUMASK_ISUP {
        my($val) = @_;
	    eval q((($val). $ary[0] == 1 && ($val). $ary[1] == 0 && ($val). $ary[2] == 0 && ($val). $ary[3] == 0));
    }' unless defined(&CPUMASK_ISUP);
    eval 'sub CPUMASK_TESTZERO {
        my($val) = @_;
	    eval q((($val). $ary[0] == 0 && ($val). $ary[1] == 0 && ($val). $ary[2] == 0 && ($val). $ary[3] == 0));
    }' unless defined(&CPUMASK_TESTZERO);
    eval 'sub CPUMASK_TESTNZERO {
        my($val) = @_;
	    eval q((($val). $ary[0] != 0|| ($val). $ary[1] != 0|| ($val). $ary[2] != 0|| ($val). $ary[3] != 0));
    }' unless defined(&CPUMASK_TESTNZERO);
    eval 'sub CPUMASK_TESTBIT {
        my($val, $i) = @_;
	    eval q((($val). $ary[(($i) >> 6) & 3] &  &CPUMASK_SIMPLE(($i) & 63)));
    }' unless defined(&CPUMASK_TESTBIT);
    eval 'sub CPUMASK_TESTMASK {
        my($val1, $val2) = @_;
	    eval q(((($val1). $ary[0] & ( ($val2->{ary[0]}))) || (($val1). $ary[1] & ( ($val2->{ary[1]}))) || (($val1). $ary[2] & ( ($val2->{ary[2]}))) || (($val1). $ary[3] & ( ($val2->{ary[3]})))));
    }' unless defined(&CPUMASK_TESTMASK);
    eval 'sub CPUMASK_LOWMASK {
        my($val) = @_;
	    eval q((($val). $ary[0]));
    }' unless defined(&CPUMASK_LOWMASK);
    eval 'sub CPUMASK_ORBIT {
        my($mask, $i) = @_;
	    eval q((($mask). $ary[(($i) >> 6) & 3] |=  &CPUMASK_SIMPLE(($i) & 63)));
    }' unless defined(&CPUMASK_ORBIT);
    eval 'sub CPUMASK_ANDBIT {
        my($mask, $i) = @_;
	    eval q((($mask). $ary[(($i) >> 6) & 3] &=  &CPUMASK_SIMPLE(($i) & 63)));
    }' unless defined(&CPUMASK_ANDBIT);
    eval 'sub CPUMASK_NANDBIT {
        my($mask, $i) = @_;
	    eval q((($mask). $ary[(($i) >> 6) & 3] &= ~ &CPUMASK_SIMPLE(($i) & 63)));
    }' unless defined(&CPUMASK_NANDBIT);
    eval 'sub CPUMASK_ASSZERO {
        my($mask) = @_;
	    eval q( &do { ($mask). $ary[0] = 0; ($mask). $ary[1] = 0; ($mask). $ary[2] = 0; ($mask). $ary[3] = 0; }  &while(0));
    }' unless defined(&CPUMASK_ASSZERO);
    eval 'sub CPUMASK_ASSALLONES {
        my($mask) = @_;
	    eval q( &do { ($mask). $ary[0] = ( &__uint64_t)-1; ($mask). $ary[1] = ( &__uint64_t)-1; ($mask). $ary[2] = ( &__uint64_t)-1; ($mask). $ary[3] = ( &__uint64_t)-1; }  &while(0));
    }' unless defined(&CPUMASK_ASSALLONES);
    eval 'sub CPUMASK_ASSBIT {
        my($mask, $i) = @_;
	    eval q( &do {  &CPUMASK_ASSZERO($mask);  &CPUMASK_ORBIT($mask, $i); }  &while(0));
    }' unless defined(&CPUMASK_ASSBIT);
    eval 'sub CPUMASK_ASSBMASK {
        my($mask, $i) = @_;
	    eval q( &do {  &if ($i < 64) { ($mask). $ary[0] =  &CPUMASK_SIMPLE($i) - 1; ($mask). $ary[1] = 0; ($mask). $ary[2] = 0; ($mask). $ary[3] = 0; }  &else  &if ($i < 128) { ($mask). $ary[0] = ( &__uint64_t)-1; ($mask). $ary[1] =  &CPUMASK_SIMPLE(($i) - 64) - 1; ($mask). $ary[2] = 0; ($mask). $ary[3] = 0; }  &else  &if ($i < 192) { ($mask). $ary[0] = ( &__uint64_t)-1; ($mask). $ary[1] = ( &__uint64_t)-1; ($mask). $ary[2] =  &CPUMASK_SIMPLE(($i) - 128) - 1; ($mask). $ary[3] = 0; }  &else { ($mask). $ary[0] = ( &__uint64_t)-1; ($mask). $ary[1] = ( &__uint64_t)-1; ($mask). $ary[2] = ( &__uint64_t)-1; ($mask). $ary[3] =  &CPUMASK_SIMPLE(($i) - 192) - 1; } }  &while(0));
    }' unless defined(&CPUMASK_ASSBMASK);
    eval 'sub CPUMASK_ASSNBMASK {
        my($mask, $i) = @_;
	    eval q( &do {  &if ($i < 64) { ($mask). $ary[0] = ~( &CPUMASK_SIMPLE($i) - 1); ($mask). $ary[1] = ( &__uint64_t)-1; ($mask). $ary[2] = ( &__uint64_t)-1; ($mask). $ary[3] = ( &__uint64_t)-1; }  &else  &if ($i < 128) { ($mask). $ary[0] = 0; ($mask). $ary[1] = ~( &CPUMASK_SIMPLE(($i) - 64) - 1); ($mask). $ary[2] = ( &__uint64_t)-1; ($mask). $ary[3] = ( &__uint64_t)-1; }  &else  &if ($i < 192) { ($mask). $ary[0] = 0; ($mask). $ary[1] = 0; ($mask). $ary[2] = ~( &CPUMASK_SIMPLE(($i) - 128) - 1); ($mask). $ary[3] = ( &__uint64_t)-1; }  &else { ($mask). $ary[0] = 0; ($mask). $ary[1] = 0; ($mask). $ary[2] = 0; ($mask). $ary[3] = ~( &CPUMASK_SIMPLE(($i) - 192) - 1); } }  &while(0));
    }' unless defined(&CPUMASK_ASSNBMASK);
    eval 'sub CPUMASK_ANDMASK {
        my($mask, $val) = @_;
	    eval q( &do { ($mask). $ary[0] &= ($val). $ary[0]; ($mask). $ary[1] &= ($val). $ary[1]; ($mask). $ary[2] &= ($val). $ary[2]; ($mask). $ary[3] &= ($val). $ary[3]; }  &while(0));
    }' unless defined(&CPUMASK_ANDMASK);
    eval 'sub CPUMASK_NANDMASK {
        my($mask, $val) = @_;
	    eval q( &do { ($mask). $ary[0] &= ~($val). $ary[0]; ($mask). $ary[1] &= ~($val). $ary[1]; ($mask). $ary[2] &= ~($val). $ary[2]; ($mask). $ary[3] &= ~($val). $ary[3]; }  &while(0));
    }' unless defined(&CPUMASK_NANDMASK);
    eval 'sub CPUMASK_ORMASK {
        my($mask, $val) = @_;
	    eval q( &do { ($mask). $ary[0] |= ($val). $ary[0]; ($mask). $ary[1] |= ($val). $ary[1]; ($mask). $ary[2] |= ($val). $ary[2]; ($mask). $ary[3] |= ($val). $ary[3]; }  &while(0));
    }' unless defined(&CPUMASK_ORMASK);
    eval 'sub CPUMASK_XORMASK {
        my($mask, $val) = @_;
	    eval q( &do { ($mask). $ary[0] ^= ($val). $ary[0]; ($mask). $ary[1] ^= ($val). $ary[1]; ($mask). $ary[2] ^= ($val). $ary[2]; ($mask). $ary[3] ^= ($val). $ary[3]; }  &while(0));
    }' unless defined(&CPUMASK_XORMASK);
    eval 'sub CPUMASK_INVMASK {
        my($mask) = @_;
	    eval q( &do { ($mask). $ary[0] ^= -1; ($mask). $ary[1] ^= -1; ($mask). $ary[2] ^= -1; ($mask). $ary[3] ^= -1; }  &while(0));
    }' unless defined(&CPUMASK_INVMASK);
    unless(defined(&_KERNEL)) {
	eval 'sub __CPU_SETSIZE () {(($sizeof{ &cpumask_t} * 8));}' unless defined(&__CPU_SETSIZE);
	eval 'sub __CPU_COUNT {
	    my($set) = @_;
    	    eval q((  &__builtin_popcountl(($set)-> $ary[0]) +  &__builtin_popcountl(($set)-> $ary[1]) +  &__builtin_popcountl(($set)-> $ary[2]) +  &__builtin_popcountl(($set)-> $ary[3])));
	}' unless defined(&__CPU_COUNT);
	eval 'sub __CPU_CLR {
	    my($cpu, $set) = @_;
    	    eval q( &CPUMASK_NANDBIT(*$set, $cpu));
	}' unless defined(&__CPU_CLR);
	eval 'sub __CPU_EQUAL {
	    my($set1, $set2) = @_;
    	    eval q( &CPUMASK_CMPMASKEQ(*$set1, *$set2));
	}' unless defined(&__CPU_EQUAL);
	eval 'sub __CPU_ISSET {
	    my($cpu, $set) = @_;
    	    eval q( &CPUMASK_TESTBIT(*$set, $cpu));
	}' unless defined(&__CPU_ISSET);
	eval 'sub __CPU_SET {
	    my($cpu, $set) = @_;
    	    eval q( &CPUMASK_ORBIT(*$set, $cpu));
	}' unless defined(&__CPU_SET);
	eval 'sub __CPU_ZERO {
	    my($set) = @_;
    	    eval q( &CPUMASK_ASSZERO(*$set));
	}' unless defined(&__CPU_ZERO);
	eval 'sub __CPU_AND {
	    my($dst, $set1, $set2) = @_;
    	    eval q( &do {  &if ($dst == $set1) {  &CPUMASK_ANDMASK(*$dst, *$set2); }  &else { *$dst = *$set2;  &CPUMASK_ANDMASK(*$dst, *$set1); } }  &while (0));
	}' unless defined(&__CPU_AND);
	eval 'sub __CPU_OR {
	    my($dst, $set1, $set2) = @_;
    	    eval q( &do {  &if ($dst == $set1) {  &CPUMASK_ORMASK(*$dst, *$set2); }  &else { *$dst = *$set2;  &CPUMASK_ORMASK(*$dst, *$set1); } }  &while (0));
	}' unless defined(&__CPU_OR);
	eval 'sub __CPU_XOR {
	    my($dst, $set1, $set2) = @_;
    	    eval q( &do {  &if ($dst == $set1) {  &CPUMASK_XORMASK(*$dst, *$set2); }  &else { *$dst = *$set2;  &CPUMASK_XORMASK(*$dst, *$set1); } }  &while (0));
	}' unless defined(&__CPU_XOR);
    }
    if(defined(&_KERNEL)) {
	eval 'sub ATOMIC_CPUMASK_ORBIT {
	    my($mask, $i) = @_;
    	    eval q( &atomic_set_cpumask(($mask). $ary[(($i) >> 6) & 3],  &CPUMASK_SIMPLE(($i) & 63)));
	}' unless defined(&ATOMIC_CPUMASK_ORBIT);
	eval 'sub ATOMIC_CPUMASK_NANDBIT {
	    my($mask, $i) = @_;
    	    eval q( &atomic_clear_cpumask(($mask). $ary[(($i) >> 6) & 3],  &CPUMASK_SIMPLE(($i) & 63)));
	}' unless defined(&ATOMIC_CPUMASK_NANDBIT);
	eval 'sub ATOMIC_CPUMASK_TESTANDSET {
	    my($mask, $i) = @_;
    	    eval q( &atomic_testandset_long(($mask). $ary[(($i) >> 6) & 3], ($i)));
	}' unless defined(&ATOMIC_CPUMASK_TESTANDSET);
	eval 'sub ATOMIC_CPUMASK_TESTANDCLR {
	    my($mask, $i) = @_;
    	    eval q( &atomic_testandclear_long(($mask). $ary[(($i) >> 6) & 3], ($i)));
	}' unless defined(&ATOMIC_CPUMASK_TESTANDCLR);
	eval 'sub ATOMIC_CPUMASK_ORMASK {
	    my($mask, $val) = @_;
    	    eval q( &do {  &atomic_set_cpumask(($mask). $ary[0], ($val). $ary[0]);  &atomic_set_cpumask(($mask). $ary[1], ($val). $ary[1]);  &atomic_set_cpumask(($mask). $ary[2], ($val). $ary[2]);  &atomic_set_cpumask(($mask). $ary[3], ($val). $ary[3]); }  &while(0));
	}' unless defined(&ATOMIC_CPUMASK_ORMASK);
	eval 'sub ATOMIC_CPUMASK_NANDMASK {
	    my($mask, $val) = @_;
    	    eval q( &do {  &atomic_clear_cpumask(($mask). $ary[0], ($val). $ary[0]);  &atomic_clear_cpumask(($mask). $ary[1], ($val). $ary[1]);  &atomic_clear_cpumask(($mask). $ary[2], ($val). $ary[2]);  &atomic_clear_cpumask(($mask). $ary[3], ($val). $ary[3]); }  &while(0));
	}' unless defined(&ATOMIC_CPUMASK_NANDMASK);
	eval 'sub ATOMIC_CPUMASK_COPY {
	    my($mask, $val) = @_;
    	    eval q( &do {  &atomic_store_rel_cpumask(($mask). $ary[0], ($val). $ary[0]);  &atomic_store_rel_cpumask(($mask). $ary[1], ($val). $ary[1]);  &atomic_store_rel_cpumask(($mask). $ary[2], ($val). $ary[2]);  &atomic_store_rel_cpumask(($mask). $ary[3], ($val). $ary[3]); }  &while(0));
	}' unless defined(&ATOMIC_CPUMASK_COPY);
    }
}
1;
