require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CPU_ENDIAN_H_)) {
    eval 'sub _CPU_ENDIAN_H_ () {1;}' unless defined(&_CPU_ENDIAN_H_);
    require 'sys/cdefs.ph';
    require 'machine/stdint.ph';
    eval 'sub _LITTLE_ENDIAN () {1234;}' unless defined(&_LITTLE_ENDIAN);
    eval 'sub _BIG_ENDIAN () {4321;}' unless defined(&_BIG_ENDIAN);
    eval 'sub _PDP_ENDIAN () {3412;}' unless defined(&_PDP_ENDIAN);
    eval 'sub _BYTE_ORDER () { &_LITTLE_ENDIAN;}' unless defined(&_BYTE_ORDER);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub LITTLE_ENDIAN () { &_LITTLE_ENDIAN;}' unless defined(&LITTLE_ENDIAN);
	eval 'sub BIG_ENDIAN () { &_BIG_ENDIAN;}' unless defined(&BIG_ENDIAN);
	eval 'sub PDP_ENDIAN () { &_PDP_ENDIAN;}' unless defined(&PDP_ENDIAN);
	eval 'sub BYTE_ORDER () { &_BYTE_ORDER;}' unless defined(&BYTE_ORDER);
    }
    if(defined(&__GNUC__)) {
	eval 'sub __word_swap_int_var {
	    my($x) = @_;
    	    eval q( &__extension__ ({  &__uint32_t  &__X = ($x);  &__asm (\\"rorl $16, %0\\" : \\"+r\\" ( &__X));  &__X; }));
	}' unless defined(&__word_swap_int_var);
	if(defined(&__OPTIMIZE__)) {
	    eval 'sub __word_swap_int_const {
	        my($x) = @_;
    		eval q((((($x) & 0xffff0000) >> 16) | ((($x) & 0xffff) << 16)));
	    }' unless defined(&__word_swap_int_const);
	    eval 'sub __word_swap_int {
	        my($x) = @_;
    		eval q(( &__builtin_constant_p($x) ?  &__word_swap_int_const($x) :  &__word_swap_int_var($x)));
	    }' unless defined(&__word_swap_int);
	} else {
	    eval 'sub __word_swap_int {
	        my($x) = @_;
    		eval q( &__word_swap_int_var($x));
	    }' unless defined(&__word_swap_int);
	}
	eval 'sub __byte_swap_int_var {
	    my($x) = @_;
    	    eval q( &__extension__ ({  &__uint32_t  &__X = ($x);  &__asm (\\"bswap %0\\" : \\"+r\\" ( &__X));  &__X; }));
	}' unless defined(&__byte_swap_int_var);
	if(defined(&__OPTIMIZE__)) {
	    eval 'sub __byte_swap_int_const {
	        my($x) = @_;
    		eval q((((($x) & 0xff000000) >> 24) | ((($x) & 0xff0000) >> 8) | ((($x) & 0xff00) << 8) | ((($x) & 0xff) << 24)));
	    }' unless defined(&__byte_swap_int_const);
	    eval 'sub __byte_swap_int {
	        my($x) = @_;
    		eval q(( &__builtin_constant_p($x) ?  &__byte_swap_int_const($x) :  &__byte_swap_int_var($x)));
	    }' unless defined(&__byte_swap_int);
	} else {
	    eval 'sub __byte_swap_int {
	        my($x) = @_;
    		eval q( &__byte_swap_int_var($x));
	    }' unless defined(&__byte_swap_int);
	}
	eval 'sub __byte_swap_long_var {
	    my($x) = @_;
    	    eval q( &__extension__ ({  &__uint64_t  &__X = ($x);  &__asm (\\"bswap %0\\" : \\"+r\\" ( &__X));  &__X; }));
	}' unless defined(&__byte_swap_long_var);
	eval 'sub __byte_swap_long_const {
	    my($x) = @_;
    	    eval q(((($x >> 56) | (($x >> 40) & 0xff00) | (($x >> 24) & 0xff0000) | (($x >> 8) & 0xff000000) | (($x << 8) & (( &__uint64_t)0xff << 32)) | (($x << 24) & (( &__uint64_t)0xff << 40)) | (($x << 40) & (( &__uint64_t)0xff << 48)) | (($x << 56)))));
	}' unless defined(&__byte_swap_long_const);
	if(defined(&__i386__)) {
	    eval 'sub __byte_swap_long {
	        my($x) = @_;
    		eval q( &__byte_swap_long_const($x));
	    }' unless defined(&__byte_swap_long);
	} else {
	    if(defined(&__OPTIMIZE__)) {
		eval 'sub __byte_swap_long {
		    my($x) = @_;
    		    eval q(( &__builtin_constant_p($x) ?  &__byte_swap_long_const($x) :  &__byte_swap_long_var($x)));
		}' unless defined(&__byte_swap_long);
	    } else {
		eval 'sub __byte_swap_long {
		    my($x) = @_;
    		    eval q( &__byte_swap_long_var($x));
		}' unless defined(&__byte_swap_long);
	    }
	}
	eval 'sub __byte_swap_word_var {
	    my($x) = @_;
    	    eval q( &__extension__ ({  &__uint16_t  &__X = ($x);  &__asm (\\"xchgb %h0, %b0\\" : \\"+Q\\" ( &__X));  &__X; }));
	}' unless defined(&__byte_swap_word_var);
	if(defined(&__OPTIMIZE__)) {
	    eval 'sub __byte_swap_word_const {
	        my($x) = @_;
    		eval q((((($x) & 0xff00) >> 8) | ((($x) & 0xff) << 8)));
	    }' unless defined(&__byte_swap_word_const);
	    eval 'sub __byte_swap_word {
	        my($x) = @_;
    		eval q(( &__builtin_constant_p($x) ?  &__byte_swap_word_const($x) :  &__byte_swap_word_var($x)));
	    }' unless defined(&__byte_swap_word);
	} else {
	    eval 'sub __byte_swap_word {
	        my($x) = @_;
    		eval q( &__byte_swap_word_var($x));
	    }' unless defined(&__byte_swap_word);
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __bswap64 {
	    my($_x) = @_;
    	    eval q({ });
	}' unless defined(&__bswap64);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __bswap32 {
	    my($_x) = @_;
    	    eval q({ });
	}' unless defined(&__bswap32);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __bswap16 {
	    my($_x) = @_;
    	    eval q({ });
	}' unless defined(&__bswap16);
	eval 'sub __htonl {
	    my($x) = @_;
    	    eval q( &__bswap32($x));
	}' unless defined(&__htonl);
	eval 'sub __htons {
	    my($x) = @_;
    	    eval q( &__bswap16($x));
	}' unless defined(&__htons);
	eval 'sub __ntohl {
	    my($x) = @_;
    	    eval q( &__bswap32($x));
	}' unless defined(&__ntohl);
	eval 'sub __ntohs {
	    my($x) = @_;
    	    eval q( &__bswap16($x));
	}' unless defined(&__ntohs);
    } else {
	eval 'sub _BYTEORDER_FUNC_DEFINED () {1;}' unless defined(&_BYTEORDER_FUNC_DEFINED);
    }
    unless(defined(&_KERNEL)) {
	eval 'sub __LITTLE_ENDIAN () { &_LITTLE_ENDIAN;}' unless defined(&__LITTLE_ENDIAN);
	eval 'sub __BIG_ENDIAN () { &_BIG_ENDIAN;}' unless defined(&__BIG_ENDIAN);
	eval 'sub __PDP_ENDIAN () { &_PDP_ENDIAN;}' unless defined(&__PDP_ENDIAN);
	eval 'sub __BYTE_ORDER () { &_BYTE_ORDER;}' unless defined(&__BYTE_ORDER);
	unless(defined(&__FLOAT_WORD_ORDER)) {
	    eval 'sub __FLOAT_WORD_ORDER () { &__BYTE_ORDER;}' unless defined(&__FLOAT_WORD_ORDER);
	}
    }
}
1;
