require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_PMAP_H_)) {
    eval 'sub _MACHINE_PMAP_H_ () {1;}' unless defined(&_MACHINE_PMAP_H_);
    require 'cpu/pmap.ph';
    eval 'sub KVADDR {
        my($l4, $l3, $l2, $l1) = @_;
	    eval q(( (-1<< 47) | ( <<  &PML4SHIFT) | ( <<  &PDPSHIFT) | ( <<  &PDRSHIFT) | (($l1) <<  &PAGE_SHIFT)));
    }' unless defined(&KVADDR);
    eval 'sub UVADDR {
        my($l4, $l3, $l2, $l1) = @_;
	    eval q(( ( <<  &PML4SHIFT) | ( <<  &PDPSHIFT) | ( <<  &PDRSHIFT) | (($l1) <<  &PAGE_SHIFT)));
    }' unless defined(&UVADDR);
    eval 'sub NKPML4E () {16;}' unless defined(&NKPML4E);
    eval 'sub NUPDP_USER () {( &NPML4EPG/2);}' unless defined(&NUPDP_USER);
    eval 'sub NUPDP_TOTAL () {( &NPML4EPG);}' unless defined(&NUPDP_TOTAL);
    eval 'sub NUPD_TOTAL () {( &NPDPEPG *  &NUPDP_TOTAL);}' unless defined(&NUPD_TOTAL);
    eval 'sub NUPT_TOTAL () {( &NPDEPG *  &NUPD_TOTAL);}' unless defined(&NUPT_TOTAL);
    eval 'sub NUPTE_TOTAL () {(( &vm_pindex_t) &NPTEPG *  &NUPT_TOTAL);}' unless defined(&NUPTE_TOTAL);
    eval 'sub NUPTE_USER () {(( &vm_pindex_t) &NPTEPG *  &NPDEPG *  &NPDPEPG *  &NUPDP_USER);}' unless defined(&NUPTE_USER);
    eval 'sub NDMPML4E () {128;}' unless defined(&NDMPML4E);
    eval 'sub PML4PML4I () {( &NPML4EPG/2);}' unless defined(&PML4PML4I);
    eval 'sub KPML4I () {( &NPML4EPG- &NKPML4E);}' unless defined(&KPML4I);
    eval 'sub DMPML4I () {( &KPML4I- &NDMPML4E);}' unless defined(&DMPML4I);
    if((defined(&NKPML4E) ? &NKPML4E : undef) + (defined(&NDMPML4E) ? &NDMPML4E : undef) >= 255) {
	die("NKPML4E or NDMPML4E is too large");
    }
    eval 'sub KPDPI () {( &NPDPEPG-2);}' unless defined(&KPDPI);
    eval 'sub MPPML4I () {( &KPML4I +  &NKPML4E - 1);}' unless defined(&MPPML4I);
    eval 'sub MPPDPI () { &KPDPI;}' unless defined(&MPPDPI);
    eval 'sub MPPTDI () {( &NPDEPG-8);}' unless defined(&MPPTDI);
    eval 'sub ISA_HOLE_START () {0xa0000;}' unless defined(&ISA_HOLE_START);
    eval 'sub ISA_HOLE_LENGTH () {(0x100000- &ISA_HOLE_START);}' unless defined(&ISA_HOLE_LENGTH);
    unless(defined(&LOCORE)) {
	unless(defined(&_SYS_TYPES_H_)) {
	    require 'sys/types.ph';
	}
	unless(defined(&_SYS_CPUMASK_H_)) {
	    require 'sys/cpumask.ph';
	}
	unless(defined(&_SYS_QUEUE_H_)) {
	    require 'sys/queue.ph';
	}
	unless(defined(&_SYS_TREE_H_)) {
	    require 'sys/tree.ph';
	}
	unless(defined(&_SYS_SPINLOCK_H_)) {
	    require 'sys/spinlock.ph';
	}
	unless(defined(&_SYS_THREAD_H_)) {
	    require 'sys/thread.ph';
	}
	unless(defined(&_MACHINE_TYPES_H_)) {
	    require 'machine/types.ph';
	}
	unless(defined(&_MACHINE_PARAM_H_)) {
	    require 'machine/param.ph';
	}
	if(defined(&_KERNEL)) {
	    eval 'sub addr_PTmap () {( &KVADDR( &PML4PML4I, 0, 0, 0));}' unless defined(&addr_PTmap);
	    eval 'sub addr_PDmap () {( &KVADDR( &PML4PML4I,  &PML4PML4I, 0, 0));}' unless defined(&addr_PDmap);
	    eval 'sub addr_PDPmap () {( &KVADDR( &PML4PML4I,  &PML4PML4I,  &PML4PML4I, 0));}' unless defined(&addr_PDPmap);
	    eval 'sub addr_PML4map () {( &KVADDR( &PML4PML4I,  &PML4PML4I,  &PML4PML4I,  &PML4PML4I));}' unless defined(&addr_PML4map);
	    eval 'sub addr_PML4pml4e () {( &addr_PML4map + ( &PML4PML4I * $sizeof{ &pml4_entry_t}));}' unless defined(&addr_PML4pml4e);
	    eval 'sub PTmap () {(( &pt_entry_t *)( &addr_PTmap));}' unless defined(&PTmap);
	    eval 'sub PDmap () {(( &pd_entry_t *)( &addr_PDmap));}' unless defined(&PDmap);
	    eval 'sub PDPmap () {(( &pd_entry_t *)( &addr_PDPmap));}' unless defined(&PDPmap);
	    eval 'sub PML4map () {(( &pd_entry_t *)( &addr_PML4map));}' unless defined(&PML4map);
	    eval 'sub PML4pml4e () {(( &pd_entry_t *)( &addr_PML4pml4e));}' unless defined(&PML4pml4e);
	}
	eval 'sub MD_PAGE_FREEABLE {
	    my($m) = @_;
    	    eval q(((($m)-> &flags & ( &PG_MAPPED |  &PG_WRITEABLE)) == 0));
	}' unless defined(&MD_PAGE_FREEABLE);
	eval 'sub REGULAR_PMAP () {0;}' unless defined(&REGULAR_PMAP);
	eval 'sub EPT_PMAP () {1;}' unless defined(&EPT_PMAP);
	eval 'sub NPT_PMAP () {2;}' unless defined(&NPT_PMAP);
	eval("sub TYPE_IDX () { 0; }") unless defined(&TYPE_IDX);
	eval("sub PG_V_IDX () { 1; }") unless defined(&PG_V_IDX);
	eval("sub PG_RW_IDX () { 2; }") unless defined(&PG_RW_IDX);
	eval("sub PG_U_IDX () { 3; }") unless defined(&PG_U_IDX);
	eval("sub PG_A_IDX () { 4; }") unless defined(&PG_A_IDX);
	eval("sub PG_M_IDX () { 5; }") unless defined(&PG_M_IDX);
	eval("sub PG_PS_IDX () { 6; }") unless defined(&PG_PS_IDX);
	eval("sub PG_G_IDX () { 7; }") unless defined(&PG_G_IDX);
	eval("sub PG_W_IDX () { 8; }") unless defined(&PG_W_IDX);
	eval("sub PG_MANAGED_IDX () { 9; }") unless defined(&PG_MANAGED_IDX);
	eval("sub PG_N_IDX () { 10; }") unless defined(&PG_N_IDX);
	eval("sub PG_NX_IDX () { 11; }") unless defined(&PG_NX_IDX);
	eval("sub PG_BITS_SIZE () { 12; }") unless defined(&PG_BITS_SIZE);
	eval 'sub PROTECTION_CODES_SIZE () {8;}' unless defined(&PROTECTION_CODES_SIZE);
	eval 'sub PAT_INDEX_SIZE () {8;}' unless defined(&PAT_INDEX_SIZE);
	eval 'sub PM_PLACEMARKS () {64;}' unless defined(&PM_PLACEMARKS);
	eval 'sub PM_NOPLACEMARK () {(( &vm_pindex_t)-1);}' unless defined(&PM_NOPLACEMARK);
	eval 'sub PM_PLACEMARK_WAKEUP () {(( &vm_pindex_t)0x8000000000000000);}' unless defined(&PM_PLACEMARK_WAKEUP);
	eval 'sub PMAP_FLAG_SIMPLE () {0x1;}' unless defined(&PMAP_FLAG_SIMPLE);
	eval 'sub PMAP_EMULATE_AD_BITS () {0x2;}' unless defined(&PMAP_EMULATE_AD_BITS);
	eval 'sub PMAP_HVM () {0x4;}' unless defined(&PMAP_HVM);
	eval 'sub PMAP_SEGSHARED () {0x8;}' unless defined(&PMAP_SEGSHARED);
	eval 'sub PMAP_MULTI () {0x10;}' unless defined(&PMAP_MULTI);
	eval 'sub pmap_resident_count {
	    my($pmap) = @_;
    	    eval q((($pmap)-> ($pm_stats->{resident_count})));
	}' unless defined(&pmap_resident_count);
	eval 'sub pmap_resident_tlnw_count {
	    my($pmap) = @_;
    	    eval q((($pmap)-> ($pm_stats->{resident_count}) - ($pmap)-> ($pm_stats->{wired_count})));
	}' unless defined(&pmap_resident_tlnw_count);
	if(defined(&_KERNEL)) {
	}
	if(defined(&PMAP_DEBUG)) {
	}
	eval 'sub PV_HOLD_LOCKED () {0x80000000;}' unless defined(&PV_HOLD_LOCKED);
	eval 'sub PV_HOLD_WAITING () {0x40000000;}' unless defined(&PV_HOLD_WAITING);
	eval 'sub PV_HOLD_UNUSED2000 () {0x20000000;}' unless defined(&PV_HOLD_UNUSED2000);
	eval 'sub PV_HOLD_MASK () {0x1fffffff;}' unless defined(&PV_HOLD_MASK);
	eval 'sub PV_FLAG_UNUSED01 () {0x1;}' unless defined(&PV_FLAG_UNUSED01);
	eval 'sub PV_FLAG_UNUSED02 () {0x2;}' unless defined(&PV_FLAG_UNUSED02);
	if(defined(&_KERNEL)) {
	    unless(defined(&__VM_PAGE_T_DEFINED__)) {
		eval 'sub __VM_PAGE_T_DEFINED__ () {1;}' unless defined(&__VM_PAGE_T_DEFINED__);
	    }
	    unless(defined(&__VM_MEMATTR_T_DEFINED__)) {
		eval 'sub __VM_MEMATTR_T_DEFINED__ () {1;}' unless defined(&__VM_MEMATTR_T_DEFINED__);
	    }
	    eval 'sub pmap_emulate_ad_bits {
	        my($pmap) = @_;
    		eval q({  ($pmap->{pm_flags}) &  &PMAP_EMULATE_AD_BITS; });
	    }' unless defined(&pmap_emulate_ad_bits);
	}
    }
}
1;
