require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_CAPS_H_)) {
    eval 'sub _SYS_CAPS_H_ () {1;}' unless defined(&_SYS_CAPS_H_);
    unless(defined(&_MACHINE_STDINT_H_)) {
	require 'machine/stdint.ph';
    }
    eval 'sub __SYSCAP_EXECMASK () {(( &__syscapelm_t)0xaaaaaaaaaaaaaaaa);}' unless defined(&__SYSCAP_EXECMASK);
    eval 'sub __SYSCAP_COUNT () {256;}' unless defined(&__SYSCAP_COUNT);
    eval 'sub __SYSCAP_BITS_PER () {2;}' unless defined(&__SYSCAP_BITS_PER);
    eval 'sub __SYSCAP_BITS_MASK () {((1<<  &__SYSCAP_BITS_PER) - 1);}' unless defined(&__SYSCAP_BITS_MASK);
    eval 'sub __SYSCAP_PER_ELM () {($sizeof{ &__syscapelm_t} * 8/  &__SYSCAP_BITS_PER);}' unless defined(&__SYSCAP_PER_ELM);
    eval 'sub __SYSCAP_PER_ELM_MASK () {( &__SYSCAP_PER_ELM - 1);}' unless defined(&__SYSCAP_PER_ELM_MASK);
    eval 'sub __SYSCAP_NUMELMS () {( &__SYSCAP_COUNT /  &__SYSCAP_PER_ELM);}' unless defined(&__SYSCAP_NUMELMS);
    eval 'sub __SYSCAP_INDEX {
        my($cap) = @_;
	    eval q((($cap) /  &__SYSCAP_PER_ELM));
    }' unless defined(&__SYSCAP_INDEX);
    eval 'sub __SYSCAP_SHIFT {
        my($cap) = @_;
	    eval q(((($cap) &  &__SYSCAP_PER_ELM_MASK) *  &__SYSCAP_BITS_PER));
    }' unless defined(&__SYSCAP_SHIFT);
    eval 'sub SYSCAP_RESOURCE_EOF () {0x;}' unless defined(&SYSCAP_RESOURCE_EOF);
    if(0) {
	eval 'sub SYSCAP_RESOURCE_PATH () {0x1;}' unless defined(&SYSCAP_RESOURCE_PATH);
    }
    eval 'sub __SYSCAP_NONE () {0x;}' unless defined(&__SYSCAP_NONE);
    eval 'sub __SYSCAP_SELF () {0x1;}' unless defined(&__SYSCAP_SELF);
    eval 'sub __SYSCAP_EXEC () {0x2;}' unless defined(&__SYSCAP_EXEC);
    eval 'sub __SYSCAP_ALL () {0x3;}' unless defined(&__SYSCAP_ALL);
    eval 'sub __SYSCAP_XFLAGS () {0x7fff0000;}' unless defined(&__SYSCAP_XFLAGS);
    eval 'sub __SYSCAP_INPARENT () {0x10000;}' unless defined(&__SYSCAP_INPARENT);
    eval 'sub __SYSCAP_NULLCRED () {0x20000;}' unless defined(&__SYSCAP_NULLCRED);
    eval 'sub __SYSCAP_NOROOTTEST () {0x40000;}' unless defined(&__SYSCAP_NOROOTTEST);
    eval 'sub __SYSCAP_GROUP_0 () {0x;}' unless defined(&__SYSCAP_GROUP_0);
    eval 'sub __SYSCAP_GROUP_1 () {0x10;}' unless defined(&__SYSCAP_GROUP_1);
    eval 'sub __SYSCAP_GROUP_2 () {0x20;}' unless defined(&__SYSCAP_GROUP_2);
    eval 'sub __SYSCAP_GROUP_3 () {0x30;}' unless defined(&__SYSCAP_GROUP_3);
    eval 'sub __SYSCAP_GROUP_4 () {0x40;}' unless defined(&__SYSCAP_GROUP_4);
    eval 'sub __SYSCAP_GROUP_5 () {0x50;}' unless defined(&__SYSCAP_GROUP_5);
    eval 'sub __SYSCAP_GROUP_6 () {0x60;}' unless defined(&__SYSCAP_GROUP_6);
    eval 'sub __SYSCAP_GROUP_7 () {0x70;}' unless defined(&__SYSCAP_GROUP_7);
    eval 'sub __SYSCAP_GROUP_8 () {0x80;}' unless defined(&__SYSCAP_GROUP_8);
    eval 'sub __SYSCAP_GROUP_9 () {0x90;}' unless defined(&__SYSCAP_GROUP_9);
    eval 'sub __SYSCAP_GROUP_10 () {0xa0;}' unless defined(&__SYSCAP_GROUP_10);
    eval 'sub __SYSCAP_GROUP_11 () {0xb0;}' unless defined(&__SYSCAP_GROUP_11);
    eval 'sub __SYSCAP_GROUP_12 () {0xc0;}' unless defined(&__SYSCAP_GROUP_12);
    eval 'sub __SYSCAP_GROUP_13 () {0xd0;}' unless defined(&__SYSCAP_GROUP_13);
    eval 'sub __SYSCAP_GROUP_14 () {0xe0;}' unless defined(&__SYSCAP_GROUP_14);
    eval 'sub __SYSCAP_GROUP_15 () {0xf0;}' unless defined(&__SYSCAP_GROUP_15);
    eval 'sub __SYSCAP_GROUP_MASK () {0xf0;}' unless defined(&__SYSCAP_GROUP_MASK);
    eval 'sub __SYSCAP_GROUP_SHIFT () {4;}' unless defined(&__SYSCAP_GROUP_SHIFT);
    eval 'sub SYSCAP_ANY () {( &__SYSCAP_GROUP_0 | 0);}' unless defined(&SYSCAP_ANY);
    eval 'sub SYSCAP_RESTRICTEDROOT () {( &__SYSCAP_GROUP_0 | 1);}' unless defined(&SYSCAP_RESTRICTEDROOT);
    eval 'sub SYSCAP_SENSITIVEROOT () {( &__SYSCAP_GROUP_0 | 2);}' unless defined(&SYSCAP_SENSITIVEROOT);
    eval 'sub SYSCAP_NOEXEC () {( &__SYSCAP_GROUP_0 | 3);}' unless defined(&SYSCAP_NOEXEC);
    eval 'sub SYSCAP_NOCRED () {( &__SYSCAP_GROUP_0 | 4);}' unless defined(&SYSCAP_NOCRED);
    eval 'sub SYSCAP_NOJAIL () {( &__SYSCAP_GROUP_0 | 5);}' unless defined(&SYSCAP_NOJAIL);
    eval 'sub SYSCAP_NONET () {( &__SYSCAP_GROUP_0 | 6);}' unless defined(&SYSCAP_NONET);
    eval 'sub SYSCAP_NONET_SENSITIVE () {( &__SYSCAP_GROUP_0 | 7);}' unless defined(&SYSCAP_NONET_SENSITIVE);
    eval 'sub SYSCAP_NOVFS () {( &__SYSCAP_GROUP_0 | 8);}' unless defined(&SYSCAP_NOVFS);
    eval 'sub SYSCAP_NOVFS_SENSITIVE () {( &__SYSCAP_GROUP_0 | 9);}' unless defined(&SYSCAP_NOVFS_SENSITIVE);
    eval 'sub SYSCAP_NOMOUNT () {( &__SYSCAP_GROUP_0 | 10);}' unless defined(&SYSCAP_NOMOUNT);
    eval 'sub SYSCAP_NO11 () {( &__SYSCAP_GROUP_0 | 11);}' unless defined(&SYSCAP_NO11);
    eval 'sub SYSCAP_NO12 () {( &__SYSCAP_GROUP_0 | 12);}' unless defined(&SYSCAP_NO12);
    eval 'sub SYSCAP_NO13 () {( &__SYSCAP_GROUP_0 | 13);}' unless defined(&SYSCAP_NO13);
    eval 'sub SYSCAP_NO14 () {( &__SYSCAP_GROUP_0 | 14);}' unless defined(&SYSCAP_NO14);
    eval 'sub SYSCAP_NO15 () {( &__SYSCAP_GROUP_0 | 15);}' unless defined(&SYSCAP_NO15);
    eval 'sub SYSCAP_NODRIVER () {( &__SYSCAP_GROUP_1 | 0);}' unless defined(&SYSCAP_NODRIVER);
    eval 'sub SYSCAP_NOVM_MLOCK () {( &__SYSCAP_GROUP_1 | 1);}' unless defined(&SYSCAP_NOVM_MLOCK);
    eval 'sub SYSCAP_NOVM_RESIDENT () {( &__SYSCAP_GROUP_1 | 2);}' unless defined(&SYSCAP_NOVM_RESIDENT);
    eval 'sub SYSCAP_NOCPUCTL_WRMSR () {( &__SYSCAP_GROUP_1 | 3);}' unless defined(&SYSCAP_NOCPUCTL_WRMSR);
    eval 'sub SYSCAP_NOCPUCTL_UPDATE () {( &__SYSCAP_GROUP_1 | 4);}' unless defined(&SYSCAP_NOCPUCTL_UPDATE);
    eval 'sub SYSCAP_NOACCT () {( &__SYSCAP_GROUP_1 | 5);}' unless defined(&SYSCAP_NOACCT);
    eval 'sub SYSCAP_NOKENV_WR () {( &__SYSCAP_GROUP_1 | 6);}' unless defined(&SYSCAP_NOKENV_WR);
    eval 'sub SYSCAP_NOKLD () {( &__SYSCAP_GROUP_1 | 7);}' unless defined(&SYSCAP_NOKLD);
    eval 'sub SYSCAP_NOKERN_WR () {( &__SYSCAP_GROUP_1 | 8);}' unless defined(&SYSCAP_NOKERN_WR);
    eval 'sub SYSCAP_NOREBOOT () {( &__SYSCAP_GROUP_1 | 9);}' unless defined(&SYSCAP_NOREBOOT);
    eval 'sub SYSCAP_NOPROC_TRESPASS () {( &__SYSCAP_GROUP_2 | 0);}' unless defined(&SYSCAP_NOPROC_TRESPASS);
    eval 'sub SYSCAP_NOPROC_SETLOGIN () {( &__SYSCAP_GROUP_2 | 1);}' unless defined(&SYSCAP_NOPROC_SETLOGIN);
    eval 'sub SYSCAP_NOPROC_SETRLIMIT () {( &__SYSCAP_GROUP_2 | 2);}' unless defined(&SYSCAP_NOPROC_SETRLIMIT);
    eval 'sub SYSCAP_NOSYSCTL_WR () {( &__SYSCAP_GROUP_2 | 3);}' unless defined(&SYSCAP_NOSYSCTL_WR);
    eval 'sub SYSCAP_NOVARSYM_SYS () {( &__SYSCAP_GROUP_2 | 4);}' unless defined(&SYSCAP_NOVARSYM_SYS);
    eval 'sub SYSCAP_NOSETHOSTNAME () {( &__SYSCAP_GROUP_2 | 5);}' unless defined(&SYSCAP_NOSETHOSTNAME);
    eval 'sub SYSCAP_NOQUOTA_WR () {( &__SYSCAP_GROUP_2 | 6);}' unless defined(&SYSCAP_NOQUOTA_WR);
    eval 'sub SYSCAP_NODEBUG_UNPRIV () {( &__SYSCAP_GROUP_2 | 7);}' unless defined(&SYSCAP_NODEBUG_UNPRIV);
    eval 'sub SYSCAP_NOSETTIME () {( &__SYSCAP_GROUP_2 | 8);}' unless defined(&SYSCAP_NOSETTIME);
    eval 'sub SYSCAP_NOSCHED () {( &__SYSCAP_GROUP_2 | 9);}' unless defined(&SYSCAP_NOSCHED);
    eval 'sub SYSCAP_NOSCHED_CPUSET () {( &__SYSCAP_GROUP_2 | 10);}' unless defined(&SYSCAP_NOSCHED_CPUSET);
    eval 'sub SYSCAP_NOEXEC_SUID () {( &__SYSCAP_GROUP_3 | 0);}' unless defined(&SYSCAP_NOEXEC_SUID);
    eval 'sub SYSCAP_NOEXEC_SGID () {( &__SYSCAP_GROUP_3 | 1);}' unless defined(&SYSCAP_NOEXEC_SGID);
    eval 'sub SYSCAP_NOCRED_SETUID () {( &__SYSCAP_GROUP_4 | 0);}' unless defined(&SYSCAP_NOCRED_SETUID);
    eval 'sub SYSCAP_NOCRED_SETGID () {( &__SYSCAP_GROUP_4 | 1);}' unless defined(&SYSCAP_NOCRED_SETGID);
    eval 'sub SYSCAP_NOCRED_SETEUID () {( &__SYSCAP_GROUP_4 | 2);}' unless defined(&SYSCAP_NOCRED_SETEUID);
    eval 'sub SYSCAP_NOCRED_SETEGID () {( &__SYSCAP_GROUP_4 | 3);}' unless defined(&SYSCAP_NOCRED_SETEGID);
    eval 'sub SYSCAP_NOCRED_SETREUID () {( &__SYSCAP_GROUP_4 | 4);}' unless defined(&SYSCAP_NOCRED_SETREUID);
    eval 'sub SYSCAP_NOCRED_SETREGID () {( &__SYSCAP_GROUP_4 | 5);}' unless defined(&SYSCAP_NOCRED_SETREGID);
    eval 'sub SYSCAP_NOCRED_SETRESUID () {( &__SYSCAP_GROUP_4 | 6);}' unless defined(&SYSCAP_NOCRED_SETRESUID);
    eval 'sub SYSCAP_NOCRED_SETRESGID () {( &__SYSCAP_GROUP_4 | 7);}' unless defined(&SYSCAP_NOCRED_SETRESGID);
    eval 'sub SYSCAP_NOCRED_SETGROUPS () {( &__SYSCAP_GROUP_4 | 8);}' unless defined(&SYSCAP_NOCRED_SETGROUPS);
    eval 'sub SYSCAP_NOJAIL_CREATE () {( &__SYSCAP_GROUP_5 | 0);}' unless defined(&SYSCAP_NOJAIL_CREATE);
    eval 'sub SYSCAP_NOJAIL_ATTACH () {( &__SYSCAP_GROUP_5 | 1);}' unless defined(&SYSCAP_NOJAIL_ATTACH);
    eval 'sub SYSCAP_NONET_RESPORT () {( &__SYSCAP_GROUP_6 | 0);}' unless defined(&SYSCAP_NONET_RESPORT);
    eval 'sub SYSCAP_NONET_RAW () {( &__SYSCAP_GROUP_6 | 1);}' unless defined(&SYSCAP_NONET_RAW);
    eval 'sub SYSCAP_NONET_IFCONFIG () {( &__SYSCAP_GROUP_7 | 0);}' unless defined(&SYSCAP_NONET_IFCONFIG);
    eval 'sub SYSCAP_NONET_ROUTE () {( &__SYSCAP_GROUP_7 | 1);}' unless defined(&SYSCAP_NONET_ROUTE);
    eval 'sub SYSCAP_NONET_LAGG () {( &__SYSCAP_GROUP_7 | 2);}' unless defined(&SYSCAP_NONET_LAGG);
    eval 'sub SYSCAP_NONET_NETGRAPH () {( &__SYSCAP_GROUP_7 | 3);}' unless defined(&SYSCAP_NONET_NETGRAPH);
    eval 'sub SYSCAP_NONET_BT_RAW () {( &__SYSCAP_GROUP_7 | 4);}' unless defined(&SYSCAP_NONET_BT_RAW);
    eval 'sub SYSCAP_NONET_WIFI () {( &__SYSCAP_GROUP_7 | 5);}' unless defined(&SYSCAP_NONET_WIFI);
    eval 'sub SYSCAP_NOVFS_SYSFLAGS () {( &__SYSCAP_GROUP_8 | 0);}' unless defined(&SYSCAP_NOVFS_SYSFLAGS);
    eval 'sub SYSCAP_NOVFS_CHOWN () {( &__SYSCAP_GROUP_8 | 1);}' unless defined(&SYSCAP_NOVFS_CHOWN);
    eval 'sub SYSCAP_NOVFS_CHMOD () {( &__SYSCAP_GROUP_8 | 2);}' unless defined(&SYSCAP_NOVFS_CHMOD);
    eval 'sub SYSCAP_NOVFS_LINK () {( &__SYSCAP_GROUP_8 | 3);}' unless defined(&SYSCAP_NOVFS_LINK);
    eval 'sub SYSCAP_NOVFS_CHFLAGS_DEV () {( &__SYSCAP_GROUP_8 | 4);}' unless defined(&SYSCAP_NOVFS_CHFLAGS_DEV);
    eval 'sub SYSCAP_NOVFS_SETATTR () {( &__SYSCAP_GROUP_8 | 5);}' unless defined(&SYSCAP_NOVFS_SETATTR);
    eval 'sub SYSCAP_NOVFS_SETGID () {( &__SYSCAP_GROUP_8 | 6);}' unless defined(&SYSCAP_NOVFS_SETGID);
    eval 'sub SYSCAP_NOVFS_GENERATION () {( &__SYSCAP_GROUP_8 | 7);}' unless defined(&SYSCAP_NOVFS_GENERATION);
    eval 'sub SYSCAP_NOVFS_RETAINSUGID () {( &__SYSCAP_GROUP_8 | 8);}' unless defined(&SYSCAP_NOVFS_RETAINSUGID);
    eval 'sub SYSCAP_NOVFS_MKNOD_BAD () {( &__SYSCAP_GROUP_9 | 0);}' unless defined(&SYSCAP_NOVFS_MKNOD_BAD);
    eval 'sub SYSCAP_NOVFS_MKNOD_WHT () {( &__SYSCAP_GROUP_9 | 1);}' unless defined(&SYSCAP_NOVFS_MKNOD_WHT);
    eval 'sub SYSCAP_NOVFS_MKNOD_DIR () {( &__SYSCAP_GROUP_9 | 2);}' unless defined(&SYSCAP_NOVFS_MKNOD_DIR);
    eval 'sub SYSCAP_NOVFS_MKNOD_DEV () {( &__SYSCAP_GROUP_9 | 3);}' unless defined(&SYSCAP_NOVFS_MKNOD_DEV);
    eval 'sub SYSCAP_NOVFS_IOCTL () {( &__SYSCAP_GROUP_9 | 4);}' unless defined(&SYSCAP_NOVFS_IOCTL);
    eval 'sub SYSCAP_NOVFS_CHROOT () {( &__SYSCAP_GROUP_9 | 5);}' unless defined(&SYSCAP_NOVFS_CHROOT);
    eval 'sub SYSCAP_NOVFS_REVOKE () {( &__SYSCAP_GROUP_9 | 6);}' unless defined(&SYSCAP_NOVFS_REVOKE);
    eval 'sub SYSCAP_NOMOUNT_NULLFS () {( &__SYSCAP_GROUP_10 | 0);}' unless defined(&SYSCAP_NOMOUNT_NULLFS);
    eval 'sub SYSCAP_NOMOUNT_DEVFS () {( &__SYSCAP_GROUP_10 | 1);}' unless defined(&SYSCAP_NOMOUNT_DEVFS);
    eval 'sub SYSCAP_NOMOUNT_TMPFS () {( &__SYSCAP_GROUP_10 | 2);}' unless defined(&SYSCAP_NOMOUNT_TMPFS);
    eval 'sub SYSCAP_NOMOUNT_UMOUNT () {( &__SYSCAP_GROUP_10 | 3);}' unless defined(&SYSCAP_NOMOUNT_UMOUNT);
    eval 'sub SYSCAP_NOMOUNT_FUSE () {( &__SYSCAP_GROUP_10 | 4);}' unless defined(&SYSCAP_NOMOUNT_FUSE);
    eval 'sub SYSCAP_NOMOUNT_PROCFS () {( &__SYSCAP_GROUP_10 | 5);}' unless defined(&SYSCAP_NOMOUNT_PROCFS);
    if(0) {
	eval 'sub SYSCAP_NOBIND () {8;}' unless defined(&SYSCAP_NOBIND);
	eval 'sub SYSCAP_NOLISTEN () {9;}' unless defined(&SYSCAP_NOLISTEN);
	eval 'sub SYSCAP_NOACCEPT () {10;}' unless defined(&SYSCAP_NOACCEPT);
	eval 'sub SYSCAP_NOCONNECT () {11;}' unless defined(&SYSCAP_NOCONNECT);
	eval 'sub SYSCAP_NOFILE_UIDR () {16;}' unless defined(&SYSCAP_NOFILE_UIDR);
	eval 'sub SYSCAP_NOFILE_UIDW () {17;}' unless defined(&SYSCAP_NOFILE_UIDW);
	eval 'sub SYSCAP_NOFILE_UIDX () {18;}' unless defined(&SYSCAP_NOFILE_UIDX);
	eval 'sub SYSCAP_NOFILE_GIDR () {19;}' unless defined(&SYSCAP_NOFILE_GIDR);
	eval 'sub SYSCAP_NOFILE_GIDW () {20;}' unless defined(&SYSCAP_NOFILE_GIDW);
	eval 'sub SYSCAP_NOFILE_GIDX () {21;}' unless defined(&SYSCAP_NOFILE_GIDX);
	eval 'sub SYSCAP_NOFILE_OIDR () {22;}' unless defined(&SYSCAP_NOFILE_OIDR);
	eval 'sub SYSCAP_NOFILE_OIDW () {23;}' unless defined(&SYSCAP_NOFILE_OIDW);
	eval 'sub SYSCAP_NOFILE_OIDX () {24;}' unless defined(&SYSCAP_NOFILE_OIDX);
    }
    eval 'sub __SYSCAP_STRINGS_0 () {"any", "restricted_root", "sensitive_root", "noexec", "nocred", "nojail", "nonet", "nonet_sensitive", "novfs", "novfs_sensitive", "nomount";}' unless defined(&__SYSCAP_STRINGS_0);
    eval 'sub __SYSCAP_STRINGS_1 () {"nodriver", "novm_mlock", "novm_resident", "nocpuctl_wrmsr", "nocpuctl_update", "noacct", "nokenv_wr", "nokld", "nokern_wr", "noreboot";}' unless defined(&__SYSCAP_STRINGS_1);
    eval 'sub __SYSCAP_STRINGS_2 () {"noproc_trespass", "noproc_setlogin", "noproc_setrlimit", "nosysctl_wr", "novarsym_sys", "nosethostname", "noquota_wr", "nodebug_unpriv", "nosettime", "nosched", "nosched_cpuset";}' unless defined(&__SYSCAP_STRINGS_2);
    eval 'sub __SYSCAP_STRINGS_3 () {"noexec_suid", "noexec_sgid";}' unless defined(&__SYSCAP_STRINGS_3);
    eval 'sub __SYSCAP_STRINGS_4 () {"nocred_setuid", "nocred_setgid", "nocred_seteuid", "nocred_setegid", "nocred_setreuid", "nocred_setregid", "nocred_setresuid", "nocred_setresgid", "nocred_setgroups";}' unless defined(&__SYSCAP_STRINGS_4);
    eval 'sub __SYSCAP_STRINGS_5 () {"nojail_create", "nojail_attach";}' unless defined(&__SYSCAP_STRINGS_5);
    eval 'sub __SYSCAP_STRINGS_6 () {"nonet_resport", "nonet_raw";}' unless defined(&__SYSCAP_STRINGS_6);
    eval 'sub __SYSCAP_STRINGS_7 () {"nonet_ifconfig", "nonet_route", "nonet_lagg", "nonet_netgraph", "nonet_bt_raw", "nonet_wifi";}' unless defined(&__SYSCAP_STRINGS_7);
    eval 'sub __SYSCAP_STRINGS_8 () {"novfs_sysflags", "novfs_chown", "novfs_chmod", "novfs_chroot", "novfs_link", "novfs_chflags_dev", "novfs_revoke", "novfs_setattr", "novfs_setgid", "novfs_generation", "novfs_retainsugid";}' unless defined(&__SYSCAP_STRINGS_8);
    eval 'sub __SYSCAP_STRINGS_9 () {"novfs_mknod_bad", "novfs_mknod_wht", "novfs_mknod_dir", "novfs_mknod_dev", "novfs_ioct";}' unless defined(&__SYSCAP_STRINGS_9);
    eval 'sub __SYSCAP_STRINGS_10 () {"nomount_nullfs", "nomount_devfs", "nomount_tmpfs", "nomount_umount", "nomount_fuse";}' unless defined(&__SYSCAP_STRINGS_10);
    eval 'sub __SYSCAP_ALLSTRINGS () { &const \'char\' * $SyscapAllStrings[ &__SYSCAP_COUNT/16][16] = { {  &__SYSCAP_STRINGS_0 }, {  &__SYSCAP_STRINGS_1 }, {  &__SYSCAP_STRINGS_2 }, {  &__SYSCAP_STRINGS_3 }, {  &__SYSCAP_STRINGS_4 }, {  &__SYSCAP_STRINGS_5 }, {  &__SYSCAP_STRINGS_6 }, {  &__SYSCAP_STRINGS_7 }, {  &__SYSCAP_STRINGS_8 }, {  &__SYSCAP_STRINGS_9 }, {  &__SYSCAP_STRINGS_10 } };}' unless defined(&__SYSCAP_ALLSTRINGS);
    if(defined(&_KERNEL)) {
    }
}
1;
