require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_DEVFS_H_)) {
    eval 'sub _SYS_DEVFS_H_ () {1;}' unless defined(&_SYS_DEVFS_H_);
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	unless(defined(&_SYS_TYPES_H_)) {
	    require 'sys/types.ph';
	}
	unless(defined(&_SYS_QUEUE_H_)) {
	    require 'sys/queue.ph';
	}
	if(defined(&_KERNEL)) {
	    unless(defined(&_SYS_LOCK_H_)) {
		require 'sys/lock.ph';
	    }
	    unless(defined(&_SYS_CONF_H_)) {
		require 'sys/conf.ph';
	    }
	    unless(defined(&_SYS_MSGPORT_H_)) {
		require 'sys/msgport.ph';
	    }
	}
	unless(defined(&_SYS_DIRENT_H_)) {
	    require 'sys/dirent.ph';
	}
	unless(defined(&_SYS_DEVICE_H_)) {
	    require 'sys/device.ph';
	}
	if(defined(&_KERNEL)) {
	    unless(defined(&_SYS_UCRED_H_)) {
		require 'sys/ucred.ph';
	    }
	}
	eval("sub Nroot () { 0; }") unless defined(&Nroot);
	eval("sub Nlink () { 1; }") unless defined(&Nlink);
	eval("sub Nreg () { 2; }") unless defined(&Nreg);
	eval("sub Ndir () { 3; }") unless defined(&Ndir);
	eval("sub Ndev () { 4; }") unless defined(&Ndev);
	if(defined(&_KERNEL)) {
	    eval 'sub mdv_chandler () { ($__m_u->{__m_chandler});}' unless defined(&mdv_chandler);
	    eval 'sub mdv_mnt () { ($__m_u->{__m_mnt}->{mnt});}' unless defined(&mdv_mnt);
	    eval 'sub mdv_load () { ($__m_u->{__m_gen}->{load});}' unless defined(&mdv_load);
	    eval 'sub mdv_load2 () { ($__m_u->{__m_gen}->{load2});}' unless defined(&mdv_load2);
	    eval 'sub mdv_response () { ($__m_u->{__m_resp}->{resp});}' unless defined(&mdv_response);
	    eval 'sub mdv_dev () { ($__m_u->{__m_dev});}' unless defined(&mdv_dev);
	    eval 'sub mdv_link () { ($__m_u->{__m_link});}' unless defined(&mdv_link);
	    eval 'sub mdv_udev () { ($__m_u->{__m_udev}->{udev});}' unless defined(&mdv_udev);
	    eval 'sub mdv_cdev () { ($__m_u->{__m_cdev}->{cdev});}' unless defined(&mdv_cdev);
	    eval 'sub mdv_name () { ($__m_u->{__m_name}->{name});}' unless defined(&mdv_name);
	    eval 'sub mdv_clone () { ($__m_u->{__m_clone});}' unless defined(&mdv_clone);
	    eval 'sub mdv_node () { ($__m_u->{__m_node}->{node});}' unless defined(&mdv_node);
	    eval 'sub mdv_ops () { ($__m_u->{__m_ops});}' unless defined(&mdv_ops);
	    eval 'sub mdv_flags () { ($__m_u->{__m_flags});}' unless defined(&mdv_flags);
	    eval 'sub mdv_ino () { ($__m_u->{__m_ino});}' unless defined(&mdv_ino);
	    eval 'sub DEVFS_NODE {
	        my($x) = @_;
    		eval q(((($x)-> &v_data)));
	    }' unless defined(&DEVFS_NODE);
	    eval 'sub DEVFS_MNTDATA {
	        my($x) = @_;
    		eval q(((($x)-> &mnt_data)));
	    }' unless defined(&DEVFS_MNTDATA);
	    eval 'sub DEVFS_ORPHANLIST {
	        my($x) = @_;
    		eval q((( &DEVFS_MNTDATA($x)-> &orphan_list)));
	    }' unless defined(&DEVFS_ORPHANLIST);
	    eval 'sub DEVFS_DENODE_HEAD {
	        my($x) = @_;
    		eval q(((($x)-> &list)));
	    }' unless defined(&DEVFS_DENODE_HEAD);
	    if(0) {
		eval 'sub DEVFS_ISDIGIT {
		    my($x) = @_;
    		    eval q((($x >= ord(\'0\') && (x <= \'9\'))));
		}' unless defined(&DEVFS_ISDIGIT);
	    }
	    eval 'sub DEVFS_DEFAULT_MODE () {(( &VREAD| &VWRITE| &VEXEC) | (( &VREAD| &VEXEC)>>3) | (( &VREAD| &VEXEC)>>6));;}' unless defined(&DEVFS_DEFAULT_MODE);
	    eval 'sub DEVFS_DEFAULT_UID () {0;}' unless defined(&DEVFS_DEFAULT_UID);
	    eval 'sub DEVFS_DEFAULT_GID () {0;}' unless defined(&DEVFS_DEFAULT_GID);
	    eval 'sub DEVFS_DEBUG_SHOW () {0x;}' unless defined(&DEVFS_DEBUG_SHOW);
	    eval 'sub DEVFS_DEBUG_WARNING () {0x1;}' unless defined(&DEVFS_DEBUG_WARNING);
	    eval 'sub DEVFS_DEBUG_INFO () {0x2;}' unless defined(&DEVFS_DEBUG_INFO);
	    eval 'sub DEVFS_DEBUG_DEBUG () {0x3;}' unless defined(&DEVFS_DEBUG_DEBUG);
	    eval 'sub DEVFS_TERMINATE_CORE () {0x1;}' unless defined(&DEVFS_TERMINATE_CORE);
	    eval 'sub DEVFS_DEVICE_CREATE () {0x2;}' unless defined(&DEVFS_DEVICE_CREATE);
	    eval 'sub DEVFS_DEVICE_DESTROY () {0x3;}' unless defined(&DEVFS_DEVICE_DESTROY);
	    eval 'sub DEVFS_MOUNT_ADD () {0x4;}' unless defined(&DEVFS_MOUNT_ADD);
	    eval 'sub DEVFS_MOUNT_DEL () {0x5;}' unless defined(&DEVFS_MOUNT_DEL);
	    eval 'sub DEVFS_CREATE_ALL_DEV () {0x6;}' unless defined(&DEVFS_CREATE_ALL_DEV);
	    eval 'sub DEVFS_DESTROY_RELATED () {0x7;}' unless defined(&DEVFS_DESTROY_RELATED);
	    eval 'sub DEVFS_DESTROY_DEV_BY_OPS () {0x8;}' unless defined(&DEVFS_DESTROY_DEV_BY_OPS);
	    eval 'sub DEVFS_CHANDLER_ADD () {0x9;}' unless defined(&DEVFS_CHANDLER_ADD);
	    eval 'sub DEVFS_CHANDLER_DEL () {0xa;}' unless defined(&DEVFS_CHANDLER_DEL);
	    eval 'sub DEVFS_FIND_DEVICE_BY_DEVID () {0xb;}' unless defined(&DEVFS_FIND_DEVICE_BY_DEVID);
	    eval 'sub DEVFS_FIND_DEVICE_BY_NAME () {0xc;}' unless defined(&DEVFS_FIND_DEVICE_BY_NAME);
	    eval 'sub DEVFS_MAKE_ALIAS () {0xd;}' unless defined(&DEVFS_MAKE_ALIAS);
	    eval 'sub DEVFS_DESTROY_ALIAS () {0xe;}' unless defined(&DEVFS_DESTROY_ALIAS);
	    eval 'sub DEVFS_APPLY_RULES () {0xf;}' unless defined(&DEVFS_APPLY_RULES);
	    eval 'sub DEVFS_RESET_RULES () {0x10;}' unless defined(&DEVFS_RESET_RULES);
	    eval 'sub DEVFS_SCAN_CALLBACK () {0x11;}' unless defined(&DEVFS_SCAN_CALLBACK);
	    eval 'sub DEVFS_CLR_RELATED_FLAG () {0x12;}' unless defined(&DEVFS_CLR_RELATED_FLAG);
	    eval 'sub DEVFS_DESTROY_RELATED_WO_FLAG () {0x13;}' unless defined(&DEVFS_DESTROY_RELATED_WO_FLAG);
	    eval 'sub DEVFS_INODE_TO_VNODE () {0x14;}' unless defined(&DEVFS_INODE_TO_VNODE);
	    eval 'sub DEVFS_SYNC () {0x99;}' unless defined(&DEVFS_SYNC);
	    eval 'sub DEVFS_NODE_LINKED () {0x1;}' unless defined(&DEVFS_NODE_LINKED);
	    eval 'sub DEVFS_USER_CREATED () {0x2;}' unless defined(&DEVFS_USER_CREATED);
	    eval 'sub DEVFS_ORPHANED () {0x4;}' unless defined(&DEVFS_ORPHANED);
	    eval 'sub DEVFS_CLONED () {0x8;}' unless defined(&DEVFS_CLONED);
	    eval 'sub DEVFS_HIDDEN () {0x10;}' unless defined(&DEVFS_HIDDEN);
	    eval 'sub DEVFS_INVISIBLE () {0x20;}' unless defined(&DEVFS_INVISIBLE);
	    eval 'sub DEVFS_PTY () {0x40;}' unless defined(&DEVFS_PTY);
	    eval 'sub DEVFS_DESTROYED () {0x80;}' unless defined(&DEVFS_DESTROYED);
	    eval 'sub DEVFS_RULE_CREATED () {0x100;}' unless defined(&DEVFS_RULE_CREATED);
	    eval 'sub DEVFS_RULE_HIDDEN () {0x200;}' unless defined(&DEVFS_RULE_HIDDEN);
	    eval 'sub DEVFS_NLINKSWAIT () {0x400;}' unless defined(&DEVFS_NLINKSWAIT);
	    eval 'sub DEVFS_BITMAP_INITIAL_SIZE () {1;}' unless defined(&DEVFS_BITMAP_INITIAL_SIZE);
	    eval 'sub DEVFS_CLONE_BITMAP {
	        my($name) = @_;
    		eval q( &devfs_  $name   &_clone_bitmap);
	    }' unless defined(&DEVFS_CLONE_BITMAP);
	    eval 'sub DEVFS_DEFINE_CLONE_BITMAP {
	        my($name) = @_;
    		eval q(\'struct devfs_bitmap\'  &DEVFS_CLONE_BITMAP($name));
	    }' unless defined(&DEVFS_DEFINE_CLONE_BITMAP);
	    eval 'sub DEVFS_DECLARE_CLONE_BITMAP {
	        my($name) = @_;
    		eval q( &extern \'struct devfs_bitmap\'  &DEVFS_CLONE_BITMAP($name));
	    }' unless defined(&DEVFS_DECLARE_CLONE_BITMAP);
	}
	if(0) {
	}
	if(defined(&_KERNEL)) {
	}
    }
    eval 'sub DEVFS_MNT_RULESET () {0x1;}' unless defined(&DEVFS_MNT_RULESET);
    eval 'sub DEVFS_MNT_JAIL () {0x2;}' unless defined(&DEVFS_MNT_JAIL);
}
1;
