require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_IN_CKSUM_H_)) {
    eval 'sub _SYS_IN_CKSUM_H_ () {1;}' unless defined(&_SYS_IN_CKSUM_H_);
    unless(defined(&_SYS_TYPES_H_)) {
	require 'sys/types.ph';
    }
    require 'machine/stdint.ph';
    if(defined(&_KERNEL)) {
	eval 'sub in_cksum {
	    my($m,$len) = @_;
    	    eval q({ ( &in_cksum_range($m, 0, 0, $len)); });
	}' unless defined(&in_cksum);
	eval 'sub in_cksum_skip {
	    my($m,$len,$skip) = @_;
    	    eval q({ ( &in_cksum_range($m, 0, $skip, $len - $skip)); });
	}' unless defined(&in_cksum_skip);
	eval 'sub in_cksum_hdr {
	    my($ip) = @_;
    	    eval q({  &__uint32_t  &sum;  &sum =  &asm_ones32(( &const  &void *)$ip, 5);  &sum = ( &sum >> 16) + ( &sum & 0xffff);  &if ( &sum > 0xffff) ++ &sum; (~ &sum & 0xffff); });
	}' unless defined(&in_cksum_hdr);
    }
    eval 'sub in_addword {
        my($sum,$b) = @_;
	    eval q({  &__asm  &__volatile (\\"addw %1, %0; adcw $0,%0\\" : \\"+r\\" ($sum) : \\"r\\" ($b)); ($sum); });
    }' unless defined(&in_addword);
    eval 'sub in_pseudo {
        my($sum,$b,$c) = @_;
	    eval q({  &__asm  &__volatile (\\"addl %1,%0; adcl %2,%0; adcl $0,%0\\" : \\"+r\\" ($sum) : \\"g\\" ($b), \\"g\\" ($c)); $sum = ($sum & 0xffff) + ($sum >> 16);  &if ($sum > 0xffff) $sum -= 0xffff; ($sum); });
    }' unless defined(&in_pseudo);
}
1;
