require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_KOBJ_H_)) {
    eval 'sub _SYS_KOBJ_H_ () {1;}' unless defined(&_SYS_KOBJ_H_);
    unless(defined(&_SYS_TYPES_H_)) {
	require 'sys/types.ph';
    }
    if(!defined(&_KERNEL)  && !defined(&_KERNEL_STRUCTURES)) {
	die("This file should not be included by userland programs.");
    }
    eval 'sub KOBJ_CLASS_FIELDS () { &const \'char\' * &name;  &kobj_method_t * &methods; \'size_t\'  &size;  &kobj_class_t * &baseclasses; \'u_int\'  &refs;  &kobj_ops_t  &ops; \'u_int\'  &gpri;}' unless defined(&KOBJ_CLASS_FIELDS);
    eval 'sub KOBJ_FIELDS () { &kobj_ops_t  &ops;}' unless defined(&KOBJ_FIELDS);
    eval 'sub KOBJ_GPRI_ACPI () {0xff;}' unless defined(&KOBJ_GPRI_ACPI);
    eval 'sub KOBJ_GPRI_LAST () {0x;}' unless defined(&KOBJ_GPRI_LAST);
    eval 'sub KOBJ_GPRI_DEFAULT () { &KOBJ_GPRI_LAST;}' unless defined(&KOBJ_GPRI_DEFAULT);
    eval 'sub KOBJ_CACHE_SIZE () {256;}' unless defined(&KOBJ_CACHE_SIZE);
    eval 'sub KOBJMETHOD {
        my($NAME, $FUNC) = @_;
	    eval q({ $NAME &_desc, ( &kobjop_t) $FUNC });
    }' unless defined(&KOBJMETHOD);
    eval 'sub KOBJMETHOD_END () {{  &NULL,  &NULL };}' unless defined(&KOBJMETHOD_END);
    eval 'sub DECLARE_CLASS {
        my($name) = @_;
	    eval q( &extern \'struct kobj_class\' $name);
    }' unless defined(&DECLARE_CLASS);
    eval 'sub DEFINE_CLASS {
        my($name, $methods, $size) = @_;
	    eval q( &DEFINE_CLASS_0($name, $name   &_class, $methods, $size));
    }' unless defined(&DEFINE_CLASS);
    eval 'sub DEFINE_CLASS_0 {
        my($name, $classvar, $methods, $size) = @_;
	    eval q(\'struct kobj_class\' $classvar = { $name, $methods, $size,  &NULL, 0,  &NULL });
    }' unless defined(&DEFINE_CLASS_0);
    eval 'sub DEFINE_CLASS_EXT {
        my($name, $classvar, $methods, $size, $extname) = @_;
	    eval q(\'struct extname\' $classvar = { $name, $methods, $size,  &NULL, 0,  &NULL });
    }' unless defined(&DEFINE_CLASS_EXT);
    eval 'sub DEFINE_CLASS_1 {
        my($name, $classvar, $methods, $size,			       $base1) = @_;
	    eval q( &static  &kobj_class_t $name   $_baseclasses[] = { $base1, 0}; \'struct kobj_class\' $classvar = { $name, $methods, $size, $name   &_baseclasses });
    }' unless defined(&DEFINE_CLASS_1);
    eval 'sub DEFINE_CLASS_2 {
        my($name, $methods, $size,				       $base1, $base2) = @_;
	    eval q( &static  &kobj_class_t $name   $_baseclasses[] = { $base1, $base2, 0}; \'struct kobj_class\' $name   &_class = { $name, $methods, $size, $name   &_baseclasses });
    }' unless defined(&DEFINE_CLASS_2);
    eval 'sub DEFINE_CLASS_3 {
        my($name, $methods, $size,				       $base1, $base2, $base3) = @_;
	    eval q( &static  &kobj_class_t $name   $_baseclasses[] = { $base1, $base2, $base3, 0}; \'struct kobj_class\' $name   &_class = { $name, $methods, $size, $name   &_baseclasses });
    }' unless defined(&DEFINE_CLASS_3);
    if(defined(&_KERNEL)) {
	eval 'sub KOBJOPLOOKUP {
	    my($OPS,$OP) = @_;
    	    eval q( &do {  &_m =  &kobj_lookup_method_cache( ($OPS->{cls}),  ($OPS->{cache[0]}), $OP &_ &desc); }  &while(0));
	}' unless defined(&KOBJOPLOOKUP);
    }
}
1;
