require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_MBUF_H_)) {
    eval 'sub _SYS_MBUF_H_ () {1;}' unless defined(&_SYS_MBUF_H_);
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	unless(defined(&_SYS_TYPES_H_)) {
	    require 'sys/types.ph';
	}
	unless(defined(&_SYS_PARAM_H_)) {
	    require 'sys/param.ph';
	}
	unless(defined(&_SYS_QUEUE_H_)) {
	    require 'sys/queue.ph';
	}
	unless(defined(&_NET_NETISR_H_)) {
	    require 'net/netisr.ph';
	}
	unless(defined(&_NET_ETHERNET_H_)) {
	    require 'net/ethernet.ph';
	}
	eval 'sub MLEN () {( &MSIZE - $sizeof{\'struct m_hdr\'});}' unless defined(&MLEN);
	eval 'sub MHLEN () {( &MLEN - $sizeof{\'struct pkthdr\'});}' unless defined(&MHLEN);
	eval 'sub MINCLSIZE () {( &MHLEN + 1);}' unless defined(&MINCLSIZE);
	eval 'sub M_MAXCOMPRESS () {( &MHLEN / 2);}' unless defined(&M_MAXCOMPRESS);
	eval 'sub mtod {
	    my($m, $t) = @_;
    	    eval q((($t)(($m)-> &m_data)));
	}' unless defined(&mtod);
	eval 'sub mtodoff {
	    my($m, $t, $off) = @_;
    	    eval q((($t)(($m)-> &m_data + ($off))));
	}' unless defined(&mtodoff);
	if(defined(&MBUF_DEBUG)) {
	}
	eval 'sub mh_netmsg () { ($mh_msgu->{mhm_pkt});}' unless defined(&mh_netmsg);
	eval 'sub mh_sndmsg () { ($mh_msgu->{mhm_snd});}' unless defined(&mh_sndmsg);
	eval 'sub mh_arpmsg () { ($mh_msgu->{mhm_arp});}' unless defined(&mh_arpmsg);
	eval 'sub mh_ctlmsg () { ($mh_msgu->{mhm_ctl});}' unless defined(&mh_ctlmsg);
	eval 'sub mh_genmsg () { ($mh_msgu->{mhm_gen});}' unless defined(&mh_genmsg);
	eval 'sub mh_fwdmsg () { ($mh_msgu->{mhm_fwd});}' unless defined(&mh_fwdmsg);
	eval 'sub PF_TAG_GENERATED () {0x1;}' unless defined(&PF_TAG_GENERATED);
	eval 'sub PF_TAG_FRAGCACHE () {0x2;}' unless defined(&PF_TAG_FRAGCACHE);
	eval 'sub PF_TAG_TRANSLATE_LOCALHOST () {0x4;}' unless defined(&PF_TAG_TRANSLATE_LOCALHOST);
	eval 'sub PF_TAG_DIVERTED () {0x8;}' unless defined(&PF_TAG_DIVERTED);
	eval 'sub PF_TAG_DIVERTED_PACKET () {0x10;}' unless defined(&PF_TAG_DIVERTED_PACKET);
	eval 'sub PF_TAG_REROUTE () {0x20;}' unless defined(&PF_TAG_REROUTE);
	eval 'sub m_next () { ($m_hdr->{mh_next});}' unless defined(&m_next);
	eval 'sub m_len () { ($m_hdr->{mh_len});}' unless defined(&m_len);
	eval 'sub m_data () { ($m_hdr->{mh_data});}' unless defined(&m_data);
	eval 'sub m_type () { ($m_hdr->{mh_type});}' unless defined(&m_type);
	eval 'sub m_flags () { ($m_hdr->{mh_flags});}' unless defined(&m_flags);
	eval 'sub m_nextpkt () { ($m_hdr->{mh_nextpkt});}' unless defined(&m_nextpkt);
	eval 'sub m_stailqpkt () { ($m_hdr->{mh_stailqpkt});}' unless defined(&m_stailqpkt);
	eval 'sub m_pkthdr () { ($M_dat->{MH}->{MH_pkthdr});}' unless defined(&m_pkthdr);
	eval 'sub m_ext () { ($M_dat->{MH}->{MH_dat}->{MH_ext});}' unless defined(&m_ext);
	eval 'sub m_pktdat () { ($M_dat->{MH}->{MH_dat}->{MH_databuf});}' unless defined(&m_pktdat);
	eval 'sub m_dat () { ($M_dat->{M_databuf});}' unless defined(&m_dat);
	eval 'sub m_act () { &m_nextpkt;}' unless defined(&m_act);
	eval 'sub M_EXT () {0x1;}' unless defined(&M_EXT);
	eval 'sub M_PKTHDR () {0x2;}' unless defined(&M_PKTHDR);
	eval 'sub M_EOR () {0x4;}' unless defined(&M_EOR);
	eval 'sub M_PROTO1 () {0x8;}' unless defined(&M_PROTO1);
	eval 'sub M_PROTO2 () {0x10;}' unless defined(&M_PROTO2);
	eval 'sub M_PROTO3 () {0x20;}' unless defined(&M_PROTO3);
	eval 'sub M_PROTO4 () {0x40;}' unless defined(&M_PROTO4);
	eval 'sub M_PROTO5 () {0x80;}' unless defined(&M_PROTO5);
	eval 'sub M_BCAST () {0x100;}' unless defined(&M_BCAST);
	eval 'sub M_MCAST () {0x200;}' unless defined(&M_MCAST);
	eval 'sub M_FRAG () {0x400;}' unless defined(&M_FRAG);
	eval 'sub M_FIRSTFRAG () {0x800;}' unless defined(&M_FIRSTFRAG);
	eval 'sub M_LASTFRAG () {0x1000;}' unless defined(&M_LASTFRAG);
	eval 'sub M_CLCACHE () {0x2000;}' unless defined(&M_CLCACHE);
	eval 'sub M_EXT_CLUSTER () {0x4000;}' unless defined(&M_EXT_CLUSTER);
	eval 'sub M_PHCACHE () {0x8000;}' unless defined(&M_PHCACHE);
	eval 'sub M_UNUSED16 () {0x10000;}' unless defined(&M_UNUSED16);
	eval 'sub M_VLANTAG () {0x20000;}' unless defined(&M_VLANTAG);
	eval 'sub M_MPLSLABELED () {0x40000;}' unless defined(&M_MPLSLABELED);
	eval 'sub M_LENCHECKED () {0x80000;}' unless defined(&M_LENCHECKED);
	eval 'sub M_HASH () {0x100000;}' unless defined(&M_HASH);
	eval 'sub M_PROTO6 () {0x200000;}' unless defined(&M_PROTO6);
	eval 'sub M_PROTO7 () {0x400000;}' unless defined(&M_PROTO7);
	eval 'sub M_PROTO8 () {0x800000;}' unless defined(&M_PROTO8);
	eval 'sub M_CKHASH () {0x1000000;}' unless defined(&M_CKHASH);
	eval 'sub M_PRIO () {0x2000000;}' unless defined(&M_PRIO);
	eval 'sub M_SOLOCKED () {0x4000000;}' unless defined(&M_SOLOCKED);
	eval 'sub M_PROTOFLAGS () {( &M_PROTO1| &M_PROTO2| &M_PROTO3| &M_PROTO4| &M_PROTO5 |  &M_PROTO6| &M_PROTO7| &M_PROTO8);}' unless defined(&M_PROTOFLAGS);
	eval 'sub M_COPYFLAGS () {( &M_PKTHDR| &M_EOR| &M_PROTOFLAGS |  &M_BCAST| &M_MCAST| &M_FRAG| &M_FIRSTFRAG| &M_LASTFRAG |  &M_VLANTAG| &M_MPLSLABELED |  &M_LENCHECKED| &M_HASH| &M_CKHASH| &M_PRIO);}' unless defined(&M_COPYFLAGS);
	eval 'sub CSUM_IP () {0x1;}' unless defined(&CSUM_IP);
	eval 'sub CSUM_TCP () {0x2;}' unless defined(&CSUM_TCP);
	eval 'sub CSUM_UDP () {0x4;}' unless defined(&CSUM_UDP);
	eval 'sub CSUM_IP_FRAGS () {0x8;}' unless defined(&CSUM_IP_FRAGS);
	eval 'sub CSUM_FRAGMENT () {0x10;}' unless defined(&CSUM_FRAGMENT);
	eval 'sub CSUM_IP_CHECKED () {0x100;}' unless defined(&CSUM_IP_CHECKED);
	eval 'sub CSUM_IP_VALID () {0x200;}' unless defined(&CSUM_IP_VALID);
	eval 'sub CSUM_DATA_VALID () {0x400;}' unless defined(&CSUM_DATA_VALID);
	eval 'sub CSUM_PSEUDO_HDR () {0x800;}' unless defined(&CSUM_PSEUDO_HDR);
	eval 'sub CSUM_FRAG_NOT_CHECKED () {0x1000;}' unless defined(&CSUM_FRAG_NOT_CHECKED);
	eval 'sub CSUM_TSO () {0x2000;}' unless defined(&CSUM_TSO);
	eval 'sub CSUM_DELAY_DATA () {( &CSUM_TCP |  &CSUM_UDP);}' unless defined(&CSUM_DELAY_DATA);
	eval 'sub CSUM_DELAY_IP () {( &CSUM_IP);}' unless defined(&CSUM_DELAY_IP);
	eval 'sub FW_MBUF_GENERATED () {0x1;}' unless defined(&FW_MBUF_GENERATED);
	eval 'sub PF_MBUF_STRUCTURE () {0x2;}' unless defined(&PF_MBUF_STRUCTURE);
	eval 'sub PF_MBUF_ROUTED () {0x4;}' unless defined(&PF_MBUF_ROUTED);
	eval 'sub PF_MBUF_TAGGED () {0x8;}' unless defined(&PF_MBUF_TAGGED);
	eval 'sub IPFW_MBUF_CONTINUE () {0x10;}' unless defined(&IPFW_MBUF_CONTINUE);
	eval 'sub XX_MBUF_UNUSED20 () {0x20;}' unless defined(&XX_MBUF_UNUSED20);
	eval 'sub IPFORWARD_MBUF_TAGGED () {0x40;}' unless defined(&IPFORWARD_MBUF_TAGGED);
	eval 'sub DUMMYNET_MBUF_TAGGED () {0x80;}' unless defined(&DUMMYNET_MBUF_TAGGED);
	eval 'sub BRIDGE_MBUF_TAGGED () {0x100;}' unless defined(&BRIDGE_MBUF_TAGGED);
	eval 'sub FW_MBUF_REDISPATCH () {0x200;}' unless defined(&FW_MBUF_REDISPATCH);
	eval 'sub FW_MBUF_PRIVATE1 () {0x400;}' unless defined(&FW_MBUF_PRIVATE1);
	eval 'sub FW_MBUF_PRIVATE2 () {0x800;}' unless defined(&FW_MBUF_PRIVATE2);
	eval 'sub IPFW_MBUF_GENERATED () { &FW_MBUF_GENERATED;}' unless defined(&IPFW_MBUF_GENERATED);
	eval 'sub MT_FREE () {0;}' unless defined(&MT_FREE);
	eval 'sub MT_DATA () {1;}' unless defined(&MT_DATA);
	eval 'sub MT_HEADER () {2;}' unless defined(&MT_HEADER);
	eval 'sub MT_SONAME () {3;}' unless defined(&MT_SONAME);
	eval 'sub MT_CONTROL () {5;}' unless defined(&MT_CONTROL);
	eval 'sub MT_OOBDATA () {6;}' unless defined(&MT_OOBDATA);
	eval 'sub MT_NTYPES () {7;}' unless defined(&MT_NTYPES);
	eval 'sub MB_OCFLAG {
	    my($how) = @_;
    	    eval q((($how) &  &M_WAITOK ?  &M_WAITOK :  &M_NOWAIT));
	}' unless defined(&MB_OCFLAG);
	eval 'sub MGETHDR_C () {1;}' unless defined(&MGETHDR_C);
	eval 'sub MGET_C () {2;}' unless defined(&MGET_C);
	eval 'sub MGET {
	    my($m, $how, $type) = @_;
    	    eval q( &do { ($m) =  &m_get(($how), ($type)); }  &while (0));
	}' unless defined(&MGET);
	eval 'sub MGETHDR {
	    my($m, $how, $type) = @_;
    	    eval q( &do { ($m) =  &m_gethdr(($how), ($type)); }  &while (0));
	}' unless defined(&MGETHDR);
	eval 'sub MCLGET {
	    my($m, $how) = @_;
    	    eval q( &do {  &m_mclget(($m), ($how)); }  &while (0));
	}' unless defined(&MCLGET);
	eval 'sub M_MOVE_PKTHDR {
	    my($_to, $_from) = @_;
    	    eval q( &m_move_pkthdr(($_to), ($_from)));
	}' unless defined(&M_MOVE_PKTHDR);
	eval 'sub M_ALIGN {
	    my($m, $len) = @_;
    	    eval q( &do { ($m)-> &m_data +=  &rounddown2( &MLEN - ($len), $sizeof{\'long\'}); }  &while (0));
	}' unless defined(&M_ALIGN);
	eval 'sub MH_ALIGN {
	    my($m, $len) = @_;
    	    eval q( &do { ($m)-> &m_data +=  &rounddown2( &MHLEN - ($len), $sizeof{\'long\'}); }  &while (0));
	}' unless defined(&MH_ALIGN);
	eval 'sub M_EXT_WRITABLE {
	    my($m) = @_;
    	    eval q(( &m_sharecount($m) == 1));
	}' unless defined(&M_EXT_WRITABLE);
	eval 'sub M_WRITABLE {
	    my($m) = @_;
    	    eval q((!(($m)-> &m_flags &  &M_EXT) ||  &M_EXT_WRITABLE($m)));
	}' unless defined(&M_WRITABLE);
	eval 'sub M_ASSERTPKTHDR {
	    my($m) = @_;
    	    eval q( &KASSERT($m !=  &NULL  &&  ($m->{m_flags}) &  &M_PKTHDR, (\\"%s: invalid mbuf or no mbuf packet header!\\",  &__func__)));
	}' unless defined(&M_ASSERTPKTHDR);
	eval 'sub M_LEADINGSPACE {
	    my($m) = @_;
    	    eval q((($m)-> &m_flags &  &M_EXT ? ( &M_EXT_WRITABLE($m) ? ($m)-> &m_data - ($m)-> ($m_ext->{ext_buf}) : 0): ($m)-> &m_flags &  &M_PKTHDR ? ($m)-> &m_data - ($m)-> &m_pktdat : ($m)-> &m_data - ($m)-> &m_dat));
	}' unless defined(&M_LEADINGSPACE);
	eval 'sub M_TRAILINGSPACE {
	    my($m) = @_;
    	    eval q((($m)-> &m_flags &  &M_EXT ? ( &M_WRITABLE($m) ? ($m)-> ($m_ext->{ext_buf}) + ($m)-> ($m_ext->{ext_size})	 - (($m)-> &m_data + ($m)-> &m_len) : 0) : ($m)-> $m_dat[ &MLEN] - (($m)-> &m_data + ($m)-> &m_len)));
	}' unless defined(&M_TRAILINGSPACE);
	eval 'sub M_PREPEND {
	    my($m, $plen, $how) = @_;
    	    eval q( &do { \'struct mbuf\' ** &_mmp = ($m); \'struct mbuf\' * &_mm = * &_mmp; \'int\'  &_mplen = ($plen); \'int\'  &__mhow = ($how);  &if ( &M_LEADINGSPACE( &_mm) >=  &_mplen) {  ($_$mm->{m_data}) -=  &_mplen;  ($_$mm->{m_len}) +=  &_mplen; }  &else  &_mm =  &m_prepend( &_mm,  &_mplen,  &__mhow);  &if ( &_mm !=  &NULL  && ( ($_$mm->{m_flags}) &  &M_PKTHDR))  ($_$mm->{m_pkthdr}->{len}) +=  &_mplen; * &_mmp =  &_mm; }  &while (0));
	}' unless defined(&M_PREPEND);
	eval 'sub M_COPYALL () {1000000000;}' unless defined(&M_COPYALL);
	eval 'sub m_copy {
	    my($m, $o, $l) = @_;
    	    eval q( &m_copym(($m), ($o), ($l),  &M_NOWAIT));
	}' unless defined(&m_copy);
	if(defined(&_KERNEL)) {
	    if(defined(&MBUF_DEBUG)) {
	    } else {
	    }
	    if(defined(&MBUF_DEBUG)) {
		eval 'sub m_free {
		    my($m) = @_;
    		    eval q( &_m_free($m,  &__func__));
		}' unless defined(&m_free);
		eval 'sub m_freem {
		    my($m) = @_;
    		    eval q( &_m_freem($m,  &__func__));
		}' unless defined(&m_freem);
	    } else {
		eval 'sub mbuftrackid {
		    my($m, $id) = @_;
    		    eval q();
		}' unless defined(&mbuftrackid);
	    }
	    eval 'sub m_sethash {
	        my($m,$hash) = @_;
    		eval q({  ($m->{m_flags}) |=  &M_HASH;  ($m->{m_pkthdr}->{hash}) = $hash; });
	    }' unless defined(&m_sethash);
	    eval 'sub m_getlj {
	        my($len,$how,$type,$flags,$psize) = @_;
    		eval q({  &if ($len >  &MCLBYTES) { \'struct mbuf\' * &m;  &m =  &m_getjcl($how, $type, $flags,  &MJUMPAGESIZE);  &if ($psize !=  &NULL) *$psize =  &MJUMPAGESIZE;  &m; }  &m_getl($len, $how, $type, $flags, $psize); });
	    }' unless defined(&m_getlj);
	    eval 'sub PACKET_TAG_NONE () {0;}' unless defined(&PACKET_TAG_NONE);
	    eval 'sub PACKET_TAG_ENCAP () {6;}' unless defined(&PACKET_TAG_ENCAP);
	    eval 'sub PACKET_TAG_IPV6_INPUT () {8;}' unless defined(&PACKET_TAG_IPV6_INPUT);
	    eval 'sub PACKET_TAG_IPFW_DIVERT () {9;}' unless defined(&PACKET_TAG_IPFW_DIVERT);
	    eval 'sub PACKET_TAG_DUMMYNET () {15;}' unless defined(&PACKET_TAG_DUMMYNET);
	    eval 'sub PACKET_TAG_IPFORWARD () {18;}' unless defined(&PACKET_TAG_IPFORWARD);
	    eval 'sub PACKET_TAG_IPSRCRT () {27;}' unless defined(&PACKET_TAG_IPSRCRT);
	    eval 'sub PACKET_TAG_CARP () {28;}' unless defined(&PACKET_TAG_CARP);
	    eval 'sub PACKET_TAG_PF () {29;}' unless defined(&PACKET_TAG_PF);
	    eval 'sub PACKET_TAG_PF_DIVERT () {0x200;}' unless defined(&PACKET_TAG_PF_DIVERT);
	    eval 'sub MTAG_ABI_COMPAT () {0;}' unless defined(&MTAG_ABI_COMPAT);
	    eval 'sub m_tag_data {
	        my($tag) = @_;
    		eval q({ (( &void *)($tag + 1)); });
	    }' unless defined(&m_tag_data);
	    eval 'sub m_tag_get {
	        my($type,$length,$mflags) = @_;
    		eval q({  &m_tag_alloc( &MTAG_ABI_COMPAT, $type, $length, $mflags); });
	    }' unless defined(&m_tag_get);
	    eval 'sub m_tag_find {
	        my($m,$type,$start) = @_;
    		eval q({  &m_tag_locate($m,  &MTAG_ABI_COMPAT, $type, $start); });
	    }' unless defined(&m_tag_find);
	    eval 'sub mbufq_init {
	        my($mq,$maxlen) = @_;
    		eval q({  &STAILQ_INIT( ($mq->{mq_head}));  ($mq->{mq_maxlen}) = $maxlen;  ($mq->{mq_len}) = 0; });
	    }' unless defined(&mbufq_init);
	    eval 'sub mbufq_flush {
	        my($mq) = @_;
    		eval q({ \'struct mbuf\' * &m;  &m =  &STAILQ_FIRST( ($mq->{mq_head}));  &STAILQ_INIT( ($mq->{mq_head}));  ($mq->{mq_len}) = 0; ( &m); });
	    }' unless defined(&mbufq_flush);
	    eval 'sub mbufq_drain {
	        my($mq) = @_;
    		eval q({ \'struct mbuf\' * &m, * &n;  &n =  &mbufq_flush($mq);  &while (( &m =  &n) !=  &NULL) {  &n =  &STAILQ_NEXT( &m,  &m_stailqpkt);  &m_freem( &m); } });
	    }' unless defined(&mbufq_drain);
	    eval 'sub mbufq_first {
	        my($mq) = @_;
    		eval q({ ( &STAILQ_FIRST( ($mq->{mq_head}))); });
	    }' unless defined(&mbufq_first);
	    eval 'sub mbufq_last {
	        my($mq) = @_;
    		eval q({ ( &STAILQ_LAST( ($mq->{mq_head}),  &mbuf,  &m_stailqpkt)); });
	    }' unless defined(&mbufq_last);
	    eval 'sub mbufq_full {
	        my($mq) = @_;
    		eval q({ ( ($mq->{mq_len}) >=  ($mq->{mq_maxlen})); });
	    }' unless defined(&mbufq_full);
	    eval 'sub mbufq_len {
	        my($mq) = @_;
    		eval q({ ( ($mq->{mq_len})); });
	    }' unless defined(&mbufq_len);
	    eval 'sub mbufq_enqueue {
	        my($mq,$m) = @_;
    		eval q({  &if ( &mbufq_full($mq)) ( &ENOBUFS);  &STAILQ_INSERT_TAIL( ($mq->{mq_head}), $m,  &m_stailqpkt);  ($mq->{mq_len})++; (0); });
	    }' unless defined(&mbufq_enqueue);
	    eval 'sub mbufq_dequeue {
	        my($mq) = @_;
    		eval q({ \'struct mbuf\' * &m;  &m =  &STAILQ_FIRST( ($mq->{mq_head}));  &if ( &m) {  &STAILQ_REMOVE_HEAD( ($mq->{mq_head}),  &m_stailqpkt);  ($m->{m_nextpkt}) =  &NULL;  ($mq->{mq_len})--; } ( &m); });
	    }' unless defined(&mbufq_dequeue);
	    eval 'sub mbufq_prepend {
	        my($mq,$m) = @_;
    		eval q({  &STAILQ_INSERT_HEAD( ($mq->{mq_head}), $m,  &m_stailqpkt);  ($mq->{mq_len})++; });
	    }' unless defined(&mbufq_prepend);
	}
    }
}
1;
