require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_RMAN_H_)) {
    eval 'sub _SYS_RMAN_H_ () {1;}' unless defined(&_SYS_RMAN_H_);
    unless(defined(&_SYS_TYPES_H_)) {
	require 'sys/types.ph';
    }
    unless(defined(&_SYS_QUEUE_H_)) {
	require 'sys/queue.ph';
    }
    unless(defined(&_SYS_BUS_H_)) {
	require 'sys/bus.ph';
    }
    eval 'sub RF_ALLOCATED () {0x1;}' unless defined(&RF_ALLOCATED);
    eval 'sub RF_ACTIVE () {0x2;}' unless defined(&RF_ACTIVE);
    eval 'sub RF_SHAREABLE () {0x4;}' unless defined(&RF_SHAREABLE);
    eval 'sub RF_TIMESHARE () {0x8;}' unless defined(&RF_TIMESHARE);
    eval 'sub RF_WANTED () {0x10;}' unless defined(&RF_WANTED);
    eval 'sub RF_FIRSTSHARE () {0x20;}' unless defined(&RF_FIRSTSHARE);
    eval 'sub RF_PREFETCHABLE () {0x40;}' unless defined(&RF_PREFETCHABLE);
    eval 'sub RF_OPTIONAL () {0x80;}' unless defined(&RF_OPTIONAL);
    eval 'sub RF_ALIGNMENT_SHIFT () {10;}' unless defined(&RF_ALIGNMENT_SHIFT);
    eval 'sub RF_ALIGNMENT_MASK () {(0x3f <<  &RF_ALIGNMENT_SHIFT);}' unless defined(&RF_ALIGNMENT_MASK);
    eval 'sub RF_ALIGNMENT_LOG2 {
        my($x) = @_;
	    eval q((($x) <<  &RF_ALIGNMENT_SHIFT));
    }' unless defined(&RF_ALIGNMENT_LOG2);
    eval 'sub RF_ALIGNMENT {
        my($x) = @_;
	    eval q(((($x) &  &RF_ALIGNMENT_MASK) >>  &RF_ALIGNMENT_SHIFT));
    }' unless defined(&RF_ALIGNMENT);
    eval("sub RMAN_UNINIT () { 0; }") unless defined(&RMAN_UNINIT);
    eval("sub RMAN_GAUGE () { 1; }") unless defined(&RMAN_GAUGE);
    eval("sub RMAN_ARRAY () { 2; }") unless defined(&RMAN_ARRAY);
    eval 'sub RM_TEXTLEN () {32;}' unless defined(&RM_TEXTLEN);
    if(defined(&_KERNEL)) {
	if(0) {
	}
	eval 'sub rman_get_start {
	    my($r) = @_;
    	    eval q((($r)-> &r_start));
	}' unless defined(&rman_get_start);
	eval 'sub rman_get_end {
	    my($r) = @_;
    	    eval q((($r)-> &r_end));
	}' unless defined(&rman_get_end);
	eval 'sub rman_get_device {
	    my($r) = @_;
    	    eval q((($r)-> &r_dev));
	}' unless defined(&rman_get_device);
	eval 'sub rman_set_device {
	    my($r,$dev) = @_;
    	    eval q((($r)-> &r_dev = ($dev)));
	}' unless defined(&rman_set_device);
	eval 'sub rman_get_size {
	    my($r) = @_;
    	    eval q((($r)-> &r_end - ($r)-> &r_start + 1));
	}' unless defined(&rman_get_size);
	eval 'sub rman_get_flags {
	    my($r) = @_;
    	    eval q((($r)-> &r_flags));
	}' unless defined(&rman_get_flags);
	eval 'sub rman_set_virtual {
	    my($r,$v) = @_;
    	    eval q((($r)-> &r_virtual = ($v)));
	}' unless defined(&rman_set_virtual);
	eval 'sub rman_get_virtual {
	    my($r) = @_;
    	    eval q((($r)-> &r_virtual));
	}' unless defined(&rman_get_virtual);
	eval 'sub rman_set_bustag {
	    my($r,$t) = @_;
    	    eval q((($r)-> &r_bustag = ($t)));
	}' unless defined(&rman_set_bustag);
	eval 'sub rman_get_bustag {
	    my($r) = @_;
    	    eval q((($r)-> &r_bustag));
	}' unless defined(&rman_get_bustag);
	eval 'sub rman_set_bushandle {
	    my($r,$h) = @_;
    	    eval q((($r)-> &r_bushandle = ($h)));
	}' unless defined(&rman_set_bushandle);
	eval 'sub rman_get_bushandle {
	    my($r) = @_;
    	    eval q((($r)-> &r_bushandle));
	}' unless defined(&rman_get_bushandle);
	eval 'sub rman_set_rid {
	    my($r,$i) = @_;
    	    eval q((($r)-> &r_rid = ($i)));
	}' unless defined(&rman_set_rid);
	eval 'sub rman_get_rid {
	    my($r) = @_;
    	    eval q((($r)-> &r_rid));
	}' unless defined(&rman_get_rid);
	eval 'sub rman_is_region_manager {
	    my($r,$rm) = @_;
    	    eval q((($r)-> &r_rm == $rm));
	}' unless defined(&rman_is_region_manager);
	eval 'sub rman_get_cpuid {
	    my($r) = @_;
    	    eval q((($r)-> ($r_rm->{rm_cpuid})));
	}' unless defined(&rman_get_cpuid);
    }
}
1;
