require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_SIGNALVAR_H_)) {
    eval 'sub _SYS_SIGNALVAR_H_ () {1;}' unless defined(&_SYS_SIGNALVAR_H_);
    require 'sys/signal.ph';
    if(defined(&_KERNEL)) {
	require 'sys/proc.ph';
	require 'machine/lock.ph';
    }
    eval 'sub SIG_CATCH () {(( &__sighandler_t *)2);}' unless defined(&SIG_CATCH);
    eval 'sub SIG_HOLD () {(( &__sighandler_t *)3);}' unless defined(&SIG_HOLD);
    if(defined(&_KERNEL)) {
	eval 'sub SIGACTION {
	    my($p, $sig) = @_;
    	    eval q(( ($p->{p_sigacts}->{ps_sigact[_SIG_IDX($sig)]})));
	}' unless defined(&SIGACTION);
    }
    eval 'sub SIGADDSET {
        my($set, $signo) = @_;
	    eval q(($set). $__bits[ &_SIG_WORD($signo)] |=  &_SIG_BIT($signo));
    }' unless defined(&SIGADDSET);
    eval 'sub SIGADDSET_ATOMIC {
        my($set, $signo) = @_;
	    eval q( &atomic_set_int(($set). $__bits[ &_SIG_WORD($signo)],  &_SIG_BIT($signo)));
    }' unless defined(&SIGADDSET_ATOMIC);
    eval 'sub SIGDELSET {
        my($set, $signo) = @_;
	    eval q(($set). $__bits[ &_SIG_WORD($signo)] &= ~ &_SIG_BIT($signo));
    }' unless defined(&SIGDELSET);
    eval 'sub SIGDELSET_ATOMIC {
        my($set, $signo) = @_;
	    eval q( &atomic_clear_int(($set). $__bits[ &_SIG_WORD($signo)],  &_SIG_BIT($signo)));
    }' unless defined(&SIGDELSET_ATOMIC);
    eval 'sub SIGEMPTYSET {
        my($set) = @_;
	    eval q( &do { \'int\'  &__i;  &for ( &__i = 0;  &__i <  &_SIG_WORDS;  &__i++) ($set). $__bits[ &__i] = 0; }  &while (0));
    }' unless defined(&SIGEMPTYSET);
    eval 'sub SIGFILLSET {
        my($set) = @_;
	    eval q( &do { \'int\'  &__i;  &for ( &__i = 0;  &__i <  &_SIG_WORDS;  &__i++) . $__bits[ &__i] = ~0; }  &while (0));
    }' unless defined(&SIGFILLSET);
    eval 'sub SIGISMEMBER {
        my($set, $signo) = @_;
	    eval q((($set). $__bits[ &_SIG_WORD($signo)] &  &_SIG_BIT($signo)));
    }' unless defined(&SIGISMEMBER);
    eval 'sub SIGISEMPTY {
        my($set) = @_;
	    eval q( &__sigisempty(($set)));
    }' unless defined(&SIGISEMPTY);
    eval 'sub SIGNOTEMPTY {
        my($set) = @_;
	    eval q((! &__sigisempty(($set))));
    }' unless defined(&SIGNOTEMPTY);
    eval 'sub SIGSETEQ {
        my($set1, $set2) = @_;
	    eval q( &__sigseteq(($set1), ($set2)));
    }' unless defined(&SIGSETEQ);
    eval 'sub SIGSETNEQ {
        my($set1, $set2) = @_;
	    eval q((! &__sigseteq(($set1), ($set2))));
    }' unless defined(&SIGSETNEQ);
    eval 'sub SIGSETOR {
        my($set1, $set2) = @_;
	    eval q( &do { \'int\'  &__i;  &for ( &__i = 0;  &__i <  &_SIG_WORDS;  &__i++) ($set1). $__bits[ &__i] |= ($set2). $__bits[ &__i]; }  &while (0));
    }' unless defined(&SIGSETOR);
    eval 'sub SIGSETAND {
        my($set1, $set2) = @_;
	    eval q( &do { \'int\'  &__i;  &for ( &__i = 0;  &__i <  &_SIG_WORDS;  &__i++) ($set1). $__bits[ &__i] &= ($set2). $__bits[ &__i]; }  &while (0));
    }' unless defined(&SIGSETAND);
    eval 'sub SIGSETNAND {
        my($set1, $set2) = @_;
	    eval q( &do { \'int\'  &__i;  &for ( &__i = 0;  &__i <  &_SIG_WORDS;  &__i++) ($set1). $__bits[ &__i] &= ~($set2). $__bits[ &__i]; }  &while (0));
    }' unless defined(&SIGSETNAND);
    eval 'sub SIGSETOR_CANTMASK {
        my($set) = @_;
	    eval q( &SIGADDSET($set,  &SIGKILL),  &SIGADDSET($set,  &SIGSTOP));
    }' unless defined(&SIGSETOR_CANTMASK);
    eval 'sub SIG_CONDBLOCKALLSIGS {
        my($set, $lp) = @_;
	    eval q( &__sig_condblockallsigs(($set), $lp));
    }' unless defined(&SIG_CONDBLOCKALLSIGS);
    eval 'sub SIG_CANTMASK {
        my($set) = @_;
	    eval q( &SIGDELSET($set,  &SIGKILL),  &SIGDELSET($set,  &SIGSTOP));
    }' unless defined(&SIG_CANTMASK);
    eval 'sub SIG_STOPSIGMASK {
        my($set) = @_;
	    eval q( &SIGDELSET($set,  &SIGSTOP),  &SIGDELSET($set,  &SIGTSTP),  &SIGDELSET($set,  &SIGTTIN),  &SIGDELSET($set,  &SIGTTOU));
    }' unless defined(&SIG_STOPSIGMASK);
    eval 'sub SIG_STOPSIGMASK_ATOMIC {
        my($set) = @_;
	    eval q( &SIGDELSET_ATOMIC($set,  &SIGSTOP),  &SIGDELSET_ATOMIC($set,  &SIGTSTP),  &SIGDELSET_ATOMIC($set,  &SIGTTIN),  &SIGDELSET_ATOMIC($set,  &SIGTTOU));
    }' unless defined(&SIG_STOPSIGMASK_ATOMIC);
    eval 'sub SIG_CONTSIGMASK {
        my($set) = @_;
	    eval q( &SIGDELSET($set,  &SIGCONT));
    }' unless defined(&SIG_CONTSIGMASK);
    eval 'sub SIG_CONTSIGMASK_ATOMIC {
        my($set) = @_;
	    eval q( &SIGDELSET_ATOMIC($set,  &SIGCONT));
    }' unless defined(&SIG_CONTSIGMASK_ATOMIC);
    eval 'sub sigcantmask () {( &sigmask( &SIGKILL) |  &sigmask( &SIGSTOP));}' unless defined(&sigcantmask);
    eval 'sub __sigisempty {
        my($set) = @_;
	    eval q({ \'int\'  &i;  &for ( &i = 0;  &i <  &_SIG_WORDS;  &i++) {  &if ( ($set->{__bits[&i]})) (0); } (1); });
    }' unless defined(&__sigisempty);
    eval 'sub __sigseteq {
        my($set1,$set2) = @_;
	    eval q({ \'int\'  &i;  &for ( &i = 0;  &i <  &_SIG_WORDS;  &i++) {  &if ( ($set1->{__bits[&i]}) !=  ($set2->{__bits[&i]})) (0); } (1); });
    }' unless defined(&__sigseteq);
    if(defined(&_KERNEL)) {
    }
}
1;
