require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_SOCKETVAR_H_)) {
    eval 'sub _SYS_SOCKETVAR_H_ () {1;}' unless defined(&_SYS_SOCKETVAR_H_);
    unless(defined(&_SYS_TYPES_H_)) {
	require 'sys/types.ph';
    }
    unless(defined(&_SYS_QUEUE_H_)) {
	require 'sys/queue.ph';
    }
    unless(defined(&_SYS_EVENT_H_)) {
	require 'sys/event.ph';
    }
    unless(defined(&_SYS_THREAD_H_)) {
	require 'sys/thread.ph';
    }
    unless(defined(&_SYS_SOCKBUF_H_)) {
	require 'sys/sockbuf.ph';
    }
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	unless(defined(&_NET_NETMSG_H_)) {
	    require 'net/netmsg.ph';
	}
	unless(defined(&_SYS_SPINLOCK_H_)) {
	    require 'sys/spinlock.ph';
	}
	eval 'sub ssb_cc () { ($sb->{sb_cc});}' unless defined(&ssb_cc);
	eval 'sub ssb_mb () { ($sb->{sb_mb});}' unless defined(&ssb_mb);
	eval 'sub ssb_mbcnt () { ($sb->{sb_mbcnt});}' unless defined(&ssb_mbcnt);
	eval 'sub ssb_cc_prealloc () { ($sb->{sb_cc_prealloc});}' unless defined(&ssb_cc_prealloc);
	eval 'sub ssb_mbcnt_prealloc () { ($sb->{sb_mbcnt_prealloc});}' unless defined(&ssb_mbcnt_prealloc);
	eval 'sub SSB_LOCK () {0x1;}' unless defined(&SSB_LOCK);
	eval 'sub SSB_WANT () {0x2;}' unless defined(&SSB_WANT);
	eval 'sub SSB_WAIT () {0x4;}' unless defined(&SSB_WAIT);
	eval 'sub SSB_ASYNC () {0x10;}' unless defined(&SSB_ASYNC);
	eval 'sub SSB_UPCALL () {0x20;}' unless defined(&SSB_UPCALL);
	eval 'sub SSB_NOINTR () {0x40;}' unless defined(&SSB_NOINTR);
	eval 'sub SSB_KNOTE () {0x100;}' unless defined(&SSB_KNOTE);
	eval 'sub SSB_MEVENT () {0x200;}' unless defined(&SSB_MEVENT);
	eval 'sub SSB_STOP () {0x400;}' unless defined(&SSB_STOP);
	eval 'sub SSB_AUTOSIZE () {0x800;}' unless defined(&SSB_AUTOSIZE);
	eval 'sub SSB_AUTOLOWAT () {0x1000;}' unless defined(&SSB_AUTOLOWAT);
	eval 'sub SSB_WAKEUP () {0x2000;}' unless defined(&SSB_WAKEUP);
	eval 'sub SSB_PREALLOC () {0x4000;}' unless defined(&SSB_PREALLOC);
	eval 'sub SSB_STOPSUPP () {0x8000;}' unless defined(&SSB_STOPSUPP);
	eval 'sub SSB_CLEAR_MASK () {( &SSB_ASYNC |  &SSB_UPCALL |  &SSB_STOP |  &SSB_AUTOSIZE |  &SSB_AUTOLOWAT);}' unless defined(&SSB_CLEAR_MASK);
	eval 'sub SSB_NOTIFY_MASK () {( &SSB_WAIT |  &SSB_ASYNC |  &SSB_UPCALL |  &SSB_KNOTE |  &SSB_MEVENT);}' unless defined(&SSB_NOTIFY_MASK);
    }
    eval 'sub SS_NOFDREF () {0x1;}' unless defined(&SS_NOFDREF);
    eval 'sub SS_ISCONNECTED () {0x2;}' unless defined(&SS_ISCONNECTED);
    eval 'sub SS_ISCONNECTING () {0x4;}' unless defined(&SS_ISCONNECTING);
    eval 'sub SS_ISDISCONNECTING () {0x8;}' unless defined(&SS_ISDISCONNECTING);
    eval 'sub SS_CANTSENDMORE () {0x10;}' unless defined(&SS_CANTSENDMORE);
    eval 'sub SS_CANTRCVMORE () {0x20;}' unless defined(&SS_CANTRCVMORE);
    eval 'sub SS_RCVATMARK () {0x40;}' unless defined(&SS_RCVATMARK);
    eval 'sub SS_ISCLOSING () {0x80;}' unless defined(&SS_ISCLOSING);
    eval 'sub SS_ASSERTINPROG () {0x100;}' unless defined(&SS_ASSERTINPROG);
    eval 'sub SS_ASYNC () {0x200;}' unless defined(&SS_ASYNC);
    eval 'sub SS_ISCONFIRMING () {0x400;}' unless defined(&SS_ISCONFIRMING);
    eval 'sub SS_INCOMP () {0x800;}' unless defined(&SS_INCOMP);
    eval 'sub SS_COMP () {0x1000;}' unless defined(&SS_COMP);
    eval 'sub SS_ISDISCONNECTED () {0x2000;}' unless defined(&SS_ISDISCONNECTED);
    eval 'sub SS_ACCEPTMECH () {0x4000;}' unless defined(&SS_ACCEPTMECH);
    eval 'sub sosendallatonce {
        my($so) = @_;
	    eval q((($so)-> ($so_proto->{pr_flags}) &  &PR_ATOMIC));
    }' unless defined(&sosendallatonce);
    eval 'sub soreadable {
        my($so) = @_;
	    eval q((($so)-> ($so_rcv->{ssb_cc}) >= ($so)-> ($so_rcv->{ssb_lowat}) || (($so)-> &so_state &  &SS_CANTRCVMORE) || ! &TAILQ_EMPTY(($so)-> &so_comp) || ($so)-> &so_error || ($so)-> &so_rerror));
    }' unless defined(&soreadable);
    eval 'sub sowriteable {
        my($so) = @_;
	    eval q((( &ssb_space(($so)-> &so_snd) >= ($so)-> ($so_snd->{ssb_lowat})  && ((($so)-> &so_state &SS_ISCONNECTED) || (($so)-> ($so_proto->{pr_flags})& &PR_CONNREQUIRED)==0)) || (($so)-> &so_state &  &SS_CANTSENDMORE) || ($so)-> &so_error));
    }' unless defined(&sowriteable);
    if(defined(&_KERNEL)) {
	eval 'sub ssb_space_prealloc {
	    my($ssb) = @_;
    	    eval q({ my $bleft,  &bleft_prealloc; my $mleft,  &mleft_prealloc;  &if ( ($ssb->{ssb_flags}) &  &SSB_STOP) (0);  $bleft =  ($ssb->{ssb_hiwat}) -  ($ssb->{ssb_cc});  &bleft_prealloc =  ($ssb->{ssb_hiwat}) -  ($ssb->{ssb_cc_prealloc});  &if ( &bleft_prealloc <  $bleft)  $bleft =  &bleft_prealloc;  $mleft =  ($ssb->{ssb_mbmax}) -  ($ssb->{ssb_mbcnt});  &mleft_prealloc =  ($ssb->{ssb_mbmax}) -  ($ssb->{ssb_mbcnt_prealloc});  &if ( &mleft_prealloc <  $mleft)  $mleft =  &mleft_prealloc; (( $bleft <  $mleft) ?  $bleft :  $mleft); });
	}' unless defined(&ssb_space_prealloc);
    }
    eval 'sub ssb_append {
        my($ssb, $m) = @_;
	    eval q( &sbappend(($ssb)-> &sb, $m));
    }' unless defined(&ssb_append);
    eval 'sub ssb_appendstream {
        my($ssb, $m) = @_;
	    eval q( &sbappendstream(($ssb)-> &sb, $m));
    }' unless defined(&ssb_appendstream);
    eval 'sub ssb_appendrecord {
        my($ssb, $m) = @_;
	    eval q( &sbappendrecord(($ssb)-> &sb, $m));
    }' unless defined(&ssb_appendrecord);
    eval 'sub ssb_appendaddr {
        my($ssb, $src, $m, $control) = @_;
	    eval q((( &ssb_space($ssb) <= 0) ? 0:  &sbappendaddr(($ssb)-> &sb, $src, $m, $control)));
    }' unless defined(&ssb_appendaddr);
    eval 'sub ssb_appendcontrol {
        my($ssb, $m, $control) = @_;
	    eval q((( &ssb_space($ssb) <= 0) ? 0:  &sbappendcontrol(($ssb)-> &sb, $m, $control)));
    }' unless defined(&ssb_appendcontrol);
    eval 'sub ssb_insert_knote {
        my($ssb, $kn) = @_;
	    eval q( &do {  &knote_insert(($ssb)-> ($ssb_kq->{ki_note}), $kn);  &atomic_set_int(($ssb)-> &ssb_flags,  &SSB_KNOTE); }  &while(0));
    }' unless defined(&ssb_insert_knote);
    eval 'sub ssb_remove_knote {
        my($ssb, $kn) = @_;
	    eval q( &do {  &knote_remove(($ssb)-> ($ssb_kq->{ki_note}), $kn);  &if ( &SLIST_EMPTY(($ssb)-> ($ssb_kq->{ki_note})))  &atomic_clear_int(($ssb)-> &ssb_flags,  &SSB_KNOTE); }  &while(0));
    }' unless defined(&ssb_remove_knote);
    eval 'sub sorwakeup {
        my($so) = @_;
	    eval q( &sowakeup(($so), ($so)-> &so_rcv));
    }' unless defined(&sorwakeup);
    eval 'sub sowwakeup {
        my($so) = @_;
	    eval q( &sowakeup(($so), ($so)-> &so_snd));
    }' unless defined(&sowwakeup);
    if(defined(&_KERNEL)) {
	eval("sub SOPT_GET () { 0; }") unless defined(&SOPT_GET);
	eval("sub SOPT_SET () { 1; }") unless defined(&SOPT_SET);
	if(defined(&MALLOC_DECLARE)) {
	}
	if(defined(&ACCEPT_FILTER_MOD)) {
	}
    }
}
1;
