require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_SPINLOCK2_H_)) {
    eval 'sub _SYS_SPINLOCK2_H_ () {1;}' unless defined(&_SYS_SPINLOCK2_H_);
    unless(defined(&_KERNEL)) {
	die("This file should not be included by userland programs.");
    }
    unless(defined(&_SYS_SYSTM_H_)) {
	require 'sys/systm.ph';
    }
    unless(defined(&_SYS_THREAD2_H_)) {
	require 'sys/thread2.ph';
    }
    unless(defined(&_SYS_GLOBALDATA_H_)) {
	require 'sys/globaldata.ph';
    }
    require 'machine/atomic.ph';
    require 'machine/cpufunc.ph';
    eval 'sub spin_lock {
        my($spin) = @_;
	    eval q( &_spin_lock($spin,  &__func__));
    }' unless defined(&spin_lock);
    eval 'sub spin_lock_quick {
        my($spin) = @_;
	    eval q( &_spin_lock_quick($spin,  &__func__));
    }' unless defined(&spin_lock_quick);
    eval 'sub spin_lock_shared {
        my($spin) = @_;
	    eval q( &_spin_lock_shared($spin,  &__func__));
    }' unless defined(&spin_lock_shared);
    eval 'sub spin_lock_shared_quick {
        my($spin) = @_;
	    eval q( &_spin_lock_shared_quick($spin,  &__func__));
    }' unless defined(&spin_lock_shared_quick);
    if(defined(&DEBUG_LOCKS)) {
    }
    if(defined(&DEBUG_LOCKS)) {
    }
    eval 'sub _spin_lock {
        my($spin,$ident) = @_;
	    eval q({  &_spin_lock_quick( &mycpu, $spin, $ident); });
    }' unless defined(&_spin_lock);
    if(defined(&DEBUG_LOCKS)) {
    }
    if(defined(&DEBUG_LOCKS)) {
    }
    if(defined(&DEBUG_LOCKS)) {
    }
    eval 'sub spin_unlock {
        my($spin) = @_;
	    eval q({  &spin_unlock_quick( &mycpu, $spin); });
    }' unless defined(&spin_unlock);
    eval 'sub spin_unlock_any {
        my($spin) = @_;
	    eval q({  &spin_unlock_quick( &mycpu, $spin); });
    }' unless defined(&spin_unlock_any);
    if(defined(&DEBUG_LOCKS)) {
    }
    if(defined(&DEBUG_LOCKS)) {
    }
    if(defined(&DEBUG_LOCKS)) {
    }
    if(defined(&DEBUG_LOCKS)) {
    }
    eval 'sub _spin_lock_shared {
        my($spin,$ident) = @_;
	    eval q({  &_spin_lock_shared_quick( &mycpu, $spin, $ident); });
    }' unless defined(&_spin_lock_shared);
    eval 'sub spin_unlock_shared {
        my($spin) = @_;
	    eval q({  &spin_unlock_shared_quick( &mycpu, $spin); });
    }' unless defined(&spin_unlock_shared);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub spin_init {
        my($spin,$__unused) = @_;
	    eval q({  ($spin->{lock}) = 0;  ($spin->{update}) = 0; });
    }' unless defined(&spin_init);
    eval 'sub spin_uninit {
        my($spin) = @_;
	    eval q({ } \'int\'  &spin_access_start(\'struct spinlock\' *$spin) { \'int\'  &v;  &v = *( &volatile \'int\' *) ($spin->{update});  &cpu_lfence();  &if ( &__predict_false( &v & 1))  &spin_lock_shared($spin);  &v; });
    }' unless defined(&spin_uninit);
    eval 'sub spin_access_end {
        my($spin,$v) = @_;
	    eval q({  &if ( &__predict_false($v & 1)) {  &spin_unlock_shared($spin); 0; }  &cpu_lfence(); (*( &volatile \'int\' *) ($spin->{update}) != $v); });
    }' unless defined(&spin_access_end);
    eval 'sub spin_lock_update {
        my($spin) = @_;
	    eval q({  &spin_lock($spin);  &atomic_add_int_nonlocked( ($spin->{update}), 1);  &cpu_sfence();  &KKASSERT_UNSPIN(( ($spin->{update}) & 1), $spin); });
    }' unless defined(&spin_lock_update);
    eval 'sub spin_unlock_update {
        my($spin) = @_;
	    eval q({  &cpu_sfence();  &atomic_add_int_nonlocked( ($spin->{update}), 1);  &KKASSERT_UNSPIN((( ($spin->{update}) & 1) == 0), $spin);  &spin_unlock($spin); });
    }' unless defined(&spin_unlock_update);
    eval 'sub spin_access_check_inprog {
        my($v) = @_;
	    eval q({ ($v & 1); });
    }' unless defined(&spin_access_check_inprog);
    eval 'sub spin_access_end_only {
        my($spin,$v) = @_;
	    eval q({  &cpu_lfence(); (*( &volatile \'int\' *) ($spin->{update}) != $v); });
    }' unless defined(&spin_access_end_only);
    eval 'sub spin_lock_update_only {
        my($spin) = @_;
	    eval q({  &atomic_add_int_nonlocked( ($spin->{update}), 1);  &cpu_sfence();  &KKASSERT( ($spin->{update}) & 1); });
    }' unless defined(&spin_lock_update_only);
    eval 'sub spin_unlock_update_only {
        my($spin) = @_;
	    eval q({  &cpu_sfence();  &atomic_add_int_nonlocked( ($spin->{update}), 1);  &KKASSERT(( ($spin->{update}) & 1) == 0); });
    }' unless defined(&spin_unlock_update_only);
}
1;
