require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_SYSCTL_H_)) {
    eval 'sub _SYS_SYSCTL_H_ () {1;}' unless defined(&_SYS_SYSCTL_H_);
    unless(defined(&_SYS_TYPES_H_)) {
	require 'sys/types.ph';
    }
    unless(defined(&_SYS_QUEUE_H_)) {
	require 'sys/queue.ph';
    }
    eval 'sub CTL_MAXNAME () {12;}' unless defined(&CTL_MAXNAME);
    eval 'sub CTLTYPE () {0x1f;}' unless defined(&CTLTYPE);
    eval 'sub CTLTYPE_NODE () {0x1;}' unless defined(&CTLTYPE_NODE);
    eval 'sub CTLTYPE_INT () {0x2;}' unless defined(&CTLTYPE_INT);
    eval 'sub CTLTYPE_STRING () {0x3;}' unless defined(&CTLTYPE_STRING);
    eval 'sub CTLTYPE_S64 () {0x4;}' unless defined(&CTLTYPE_S64);
    eval 'sub CTLTYPE_QUAD () { &CTLTYPE_S64;}' unless defined(&CTLTYPE_QUAD);
    eval 'sub CTLTYPE_OPAQUE () {0x5;}' unless defined(&CTLTYPE_OPAQUE);
    eval 'sub CTLTYPE_STRUCT () { &CTLTYPE_OPAQUE;}' unless defined(&CTLTYPE_STRUCT);
    eval 'sub CTLTYPE_UINT () {0x6;}' unless defined(&CTLTYPE_UINT);
    eval 'sub CTLTYPE_LONG () {0x7;}' unless defined(&CTLTYPE_LONG);
    eval 'sub CTLTYPE_ULONG () {0x8;}' unless defined(&CTLTYPE_ULONG);
    eval 'sub CTLTYPE_U64 () {0x9;}' unless defined(&CTLTYPE_U64);
    eval 'sub CTLTYPE_UQUAD () { &CTLTYPE_U64;}' unless defined(&CTLTYPE_UQUAD);
    eval 'sub CTLTYPE_U8 () {0xa;}' unless defined(&CTLTYPE_U8);
    eval 'sub CTLTYPE_U16 () {0xb;}' unless defined(&CTLTYPE_U16);
    eval 'sub CTLTYPE_S8 () {0xc;}' unless defined(&CTLTYPE_S8);
    eval 'sub CTLTYPE_S16 () {0xd;}' unless defined(&CTLTYPE_S16);
    eval 'sub CTLTYPE_S32 () {0xe;}' unless defined(&CTLTYPE_S32);
    eval 'sub CTLTYPE_U32 () {0xf;}' unless defined(&CTLTYPE_U32);
    eval 'sub CTLTYPE_BIT32 {
        my($n) = @_;
	    eval q((0x10 | (($n) <<  &CTLSHIFT_BITFLD)));
    }' unless defined(&CTLTYPE_BIT32);
    eval 'sub CTLTYPE_BIT64 {
        my($n) = @_;
	    eval q((0x11 | (($n) <<  &CTLSHIFT_BITFLD)));
    }' unless defined(&CTLTYPE_BIT64);
    eval 'sub CTLFLAG_RD () {0x80000000;}' unless defined(&CTLFLAG_RD);
    eval 'sub CTLFLAG_WR () {0x40000000;}' unless defined(&CTLFLAG_WR);
    eval 'sub CTLFLAG_RW () {( &CTLFLAG_RD| &CTLFLAG_WR);}' unless defined(&CTLFLAG_RW);
    eval 'sub CTLFLAG_ANYBODY () {0x10000000;}' unless defined(&CTLFLAG_ANYBODY);
    eval 'sub CTLFLAG_SECURE () {0x8000000;}' unless defined(&CTLFLAG_SECURE);
    eval 'sub CTLFLAG_PRISON () {0x4000000;}' unless defined(&CTLFLAG_PRISON);
    eval 'sub CTLFLAG_DYN () {0x2000000;}' unless defined(&CTLFLAG_DYN);
    eval 'sub CTLFLAG_SKIP () {0x1000000;}' unless defined(&CTLFLAG_SKIP);
    eval 'sub CTLMASK_SECURE () {0xf00000;}' unless defined(&CTLMASK_SECURE);
    eval 'sub CTLFLAG_DYING () {0x10000;}' unless defined(&CTLFLAG_DYING);
    eval 'sub CTLFLAG_SHLOCK () {0x8000;}' unless defined(&CTLFLAG_SHLOCK);
    eval 'sub CTLFLAG_EXLOCK () {0x4000;}' unless defined(&CTLFLAG_EXLOCK);
    eval 'sub CTLFLAG_NOLOCK () {0x2000;}' unless defined(&CTLFLAG_NOLOCK);
    eval 'sub CTLFLAG_RSV12 () {0x1000;}' unless defined(&CTLFLAG_RSV12);
    eval 'sub CTLMASK_BITFLD () {0xfc0;}' unless defined(&CTLMASK_BITFLD);
    eval 'sub CTLFLAG_RSV5 () {0x20;}' unless defined(&CTLFLAG_RSV5);
    eval 'sub CTLMASK_TYPE () {0x1f;}' unless defined(&CTLMASK_TYPE);
    eval 'sub CTLSHIFT_BITFLD () {6;}' unless defined(&CTLSHIFT_BITFLD);
    eval 'sub CTLINFO_MAXBITN () {64;}' unless defined(&CTLINFO_MAXBITN);
    eval 'sub OID_AUTO () {(-1);}' unless defined(&OID_AUTO);
    if(defined(&_KERNEL)) {
	require 'sys/kernel.ph';
	unless(defined(&_SYS_LOCK_H_)) {
	    require 'sys/lock.ph';
	}
	eval 'sub SYSCTL_HANDLER_ARGS () {\'struct sysctl_oid\' * &oidp,  &void * &arg1, \'int\'  &arg2, \'struct sysctl_req\' * &req;}' unless defined(&SYSCTL_HANDLER_ARGS);
	eval 'sub SYSCTL_IN {
	    my($r, $p, $l) = @_;
    	    eval q(( ($r->{newfunc}))($r, $p, $l));
	}' unless defined(&SYSCTL_IN);
	eval 'sub SYSCTL_OUT {
	    my($r, $p, $l) = @_;
    	    eval q(( ($r->{o$ldfunc}))($r, $p, $l));
	}' unless defined(&SYSCTL_OUT);
	eval 'sub SYSCTL_OUT_STR {
	    my($r, $p) = @_;
    	    eval q(( ($r->{oldfunc}))($r, $p,  &strlen($p) + 1));
	}' unless defined(&SYSCTL_OUT_STR);
	eval 'sub SYSCTL_XLOCK () {
	    eval q( &_sysctl_xlock());
	}' unless defined(&SYSCTL_XLOCK);
	eval 'sub SYSCTL_XUNLOCK () {
	    eval q( &_sysctl_xunlock());
	}' unless defined(&SYSCTL_XUNLOCK);
	eval 'sub SYSCTL_SLOCK () {
	    eval q( &lockmgr( ($mycpu->{gd_sysctllock}),  &LK_SHARED));
	}' unless defined(&SYSCTL_SLOCK);
	eval 'sub SYSCTL_SUNLOCK () {
	    eval q( &lockmgr( ($mycpu->{gd_sysctllock}),  &LK_RELEASE));
	}' unless defined(&SYSCTL_SUNLOCK);
	eval 'sub SYSCTL_ASSERT_LOCKED () {
	    eval q( &KKASSERT( &lockstatus( ($mycpu->{gd_sysctllock}),  &curthread) != 0));
	}' unless defined(&SYSCTL_ASSERT_LOCKED);
	eval 'sub SYSCTL_DECL {
	    my($name) = @_;
    	    eval q( &extern \'struct sysctl_oid_list\'  &sysctl_$name &_children);
	}' unless defined(&SYSCTL_DECL);
	eval 'sub SYSCTL_SET_CHILDREN {
	    my($oid_ptr, $children) = @_;
    	    eval q( &do { ($oid_ptr)-> &oid_arg1 = ($children); }  &while(0));
	}' unless defined(&SYSCTL_SET_CHILDREN);
	eval 'sub SYSCTL_CHILDREN {
	    my($oid_ptr) = @_;
    	    eval q( ($oid_ptr)-> &oid_arg1);
	}' unless defined(&SYSCTL_CHILDREN);
	eval 'sub SYSCTL_STATIC_CHILDREN {
	    my($oid_name) = @_;
    	    eval q(( &sysctl_$oid_name &_children));
	}' unless defined(&SYSCTL_STATIC_CHILDREN);
	eval 'sub SYSCTL_NODE_CHILDREN {
	    my($parent, $name) = @_;
    	    eval q( &sysctl_$parent &_$name &_children);
	}' unless defined(&SYSCTL_NODE_CHILDREN);
	unless(defined(&NO_SYSCTL_DESCR)) {
	    eval 'sub __DESCR {
	        my($d) = @_;
    		eval q($d);
	    }' unless defined(&__DESCR);
	} else {
	    eval 'sub __DESCR {
	        my($d) = @_;
    		eval q(\\"\\");
	    }' unless defined(&__DESCR);
	}
	eval 'sub SYSCTL_OID {
	    my($parent, $nbr, $name, $kind, $a1, $a2, $handler, $fmt, $descr) = @_;
    	    eval q( &static \'struct sysctl_oid\'  &sysctl__$parent &_$name = {  &sysctl_$parent &_children, {  &NULL }, $nbr, $kind, $a1, $a2, $name, $handler, $fmt, 0, 0,  &__DESCR($descr) };  &DATA_SET( &sysctl_set,  &sysctl__$parent &_$name));
	}' unless defined(&SYSCTL_OID);
	eval 'sub SYSCTL_ADD_OID {
	    my($ctx, $parent, $nbr, $name, $kind, $a1, $a2, $handler, $fmt, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name, $kind, $a1, $a2, $handler, $fmt, $descr););
	}' unless defined(&SYSCTL_ADD_OID);
	eval 'sub SYSCTL_NODE {
	    my($parent, $nbr, $name, $access, $handler, $descr) = @_;
    	    eval q(\'struct sysctl_oid_list\'  &SYSCTL_NODE_CHILDREN($parent, $name);  &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_NODE|($access), ( &void*) &SYSCTL_NODE_CHILDREN($parent, $name), 0, $handler, \\"N\\", $descr));
	}' unless defined(&SYSCTL_NODE);
	eval 'sub SYSCTL_ADD_NODE {
	    my($ctx, $parent, $nbr, $name, $access, $handler, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_NODE|($access), 0, 0, $handler, \\"N\\", $descr));
	}' unless defined(&SYSCTL_ADD_NODE);
	eval 'sub SYSCTL_STRING {
	    my($parent, $nbr, $name, $access, $arg, $len, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_STRING|($access), $arg, $len,  &sysctl_handle_string, \\"A\\", $descr));
	}' unless defined(&SYSCTL_STRING);
	eval 'sub SYSCTL_ADD_STRING {
	    my($ctx, $parent, $nbr, $name, $access, $arg, $len, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_STRING|($access), $arg, $len,  &sysctl_handle_string, \\"A\\", $descr));
	}' unless defined(&SYSCTL_ADD_STRING);
	eval 'sub SYSCTL_INT {
	    my($parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_INT| &CTLFLAG_NOLOCK|($access), $ptr, $val,  &sysctl_handle_int, \\"I\\", $descr));
	}' unless defined(&SYSCTL_INT);
	eval 'sub SYSCTL_ADD_INT {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_INT| &CTLFLAG_NOLOCK|($access), $ptr, $val,  &sysctl_handle_int, \\"I\\", $descr));
	}' unless defined(&SYSCTL_ADD_INT);
	eval 'sub SYSCTL_QUAD {
	    my($parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_QUAD| &CTLFLAG_NOLOCK|($access), $ptr, $val,  &sysctl_handle_quad, \\"Q\\", $descr));
	}' unless defined(&SYSCTL_QUAD);
	eval 'sub SYSCTL_ADD_QUAD {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_QUAD| &CTLFLAG_NOLOCK|($access), $ptr, $val,  &sysctl_handle_quad, \\"Q\\", $descr));
	}' unless defined(&SYSCTL_ADD_QUAD);
	eval 'sub SYSCTL_UQUAD {
	    my($parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_UQUAD| &CTLFLAG_NOLOCK|($access), $ptr, $val,  &sysctl_handle_quad, \\"QU\\", $descr));
	}' unless defined(&SYSCTL_UQUAD);
	eval 'sub SYSCTL_ADD_UQUAD {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_UQUAD| &CTLFLAG_NOLOCK|($access), $ptr, $val,  &sysctl_handle_quad, \\"QU\\", $descr));
	}' unless defined(&SYSCTL_ADD_UQUAD);
	eval 'sub SYSCTL_UINT {
	    my($parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_UINT| &CTLFLAG_NOLOCK|($access), $ptr, $val,  &sysctl_handle_int, \\"IU\\", $descr));
	}' unless defined(&SYSCTL_UINT);
	eval 'sub SYSCTL_ADD_UINT {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_UINT| &CTLFLAG_NOLOCK|($access), $ptr, $val,  &sysctl_handle_int, \\"IU\\", $descr));
	}' unless defined(&SYSCTL_ADD_UINT);
	eval 'sub SYSCTL_LONG {
	    my($parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_LONG| &CTLFLAG_NOLOCK|($access), $ptr, $val, \'sysctl_handle_long\', \\"L\\", $descr));
	}' unless defined(&SYSCTL_LONG);
	eval 'sub SYSCTL_ADD_LONG {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_LONG| &CTLFLAG_NOLOCK|($access), $ptr, 0, \'sysctl_handle_long\', \\"L\\", $descr));
	}' unless defined(&SYSCTL_ADD_LONG);
	eval 'sub SYSCTL_ULONG {
	    my($parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_ULONG| &CTLFLAG_NOLOCK|($access), $ptr, $val, \'sysctl_handle_long\', \\"LU\\", $descr));
	}' unless defined(&SYSCTL_ULONG);
	eval 'sub SYSCTL_ADD_ULONG {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_ULONG| &CTLFLAG_NOLOCK|($access), $ptr, 0, \'sysctl_handle_long\', \\"LU\\", $descr));
	}' unless defined(&SYSCTL_ADD_ULONG);
	eval 'sub SYSCTL_S8 {
	    my($parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_S8|($access), $ptr, $val,  &sysctl_handle_8, \\"C\\", $descr));
	}' unless defined(&SYSCTL_S8);
	eval 'sub SYSCTL_ADD_S8 {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_S8|($access), $ptr, 0,  &sysctl_handle_8, \\"C\\", $descr));
	}' unless defined(&SYSCTL_ADD_S8);
	eval 'sub SYSCTL_S16 {
	    my($parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_S16|($access), $ptr, $val,  &sysctl_handle_16, \\"S\\", $descr));
	}' unless defined(&SYSCTL_S16);
	eval 'sub SYSCTL_ADD_S16 {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_S16|($access), $ptr, 0,  &sysctl_handle_16, \\"S\\", $descr));
	}' unless defined(&SYSCTL_ADD_S16);
	eval 'sub SYSCTL_S32 {
	    my($parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_S32|($access), $ptr, $val,  &sysctl_handle_32, \\"I\\", $descr));
	}' unless defined(&SYSCTL_S32);
	eval 'sub SYSCTL_ADD_S32 {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_S32|($access), $ptr, 0,  &sysctl_handle_32, \\"I\\", $descr));
	}' unless defined(&SYSCTL_ADD_S32);
	eval 'sub SYSCTL_S64 {
	    my($parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_S64|($access), $ptr, $val,  &sysctl_handle_64, \\"Q\\", $descr));
	}' unless defined(&SYSCTL_S64);
	eval 'sub SYSCTL_ADD_S64 {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_S64|($access), $ptr, 0,  &sysctl_handle_64, \\"Q\\", $descr));
	}' unless defined(&SYSCTL_ADD_S64);
	eval 'sub SYSCTL_U8 {
	    my($parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_U8|($access), $ptr, $val,  &sysctl_handle_8, \\"CU\\", $descr));
	}' unless defined(&SYSCTL_U8);
	eval 'sub SYSCTL_ADD_U8 {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_U8|($access), $ptr, 0,  &sysctl_handle_8, \\"CU\\", $descr));
	}' unless defined(&SYSCTL_ADD_U8);
	eval 'sub SYSCTL_U16 {
	    my($parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_U16|($access), $ptr, $val,  &sysctl_handle_16, \\"SU\\", $descr));
	}' unless defined(&SYSCTL_U16);
	eval 'sub SYSCTL_ADD_U16 {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_U16|($access), $ptr, 0,  &sysctl_handle_16, \\"SU\\", $descr));
	}' unless defined(&SYSCTL_ADD_U16);
	eval 'sub SYSCTL_U32 {
	    my($parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_U32|($access), $ptr, $val,  &sysctl_handle_32, \\"IU\\", $descr));
	}' unless defined(&SYSCTL_U32);
	eval 'sub SYSCTL_ADD_U32 {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_U32|($access), $ptr, 0,  &sysctl_handle_32, \\"IU\\", $descr));
	}' unless defined(&SYSCTL_ADD_U32);
	eval 'sub SYSCTL_U64 {
	    my($parent, $nbr, $name, $access, $ptr, $val, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_U64|($access), $ptr, $val,  &sysctl_handle_64, \\"QU\\", $descr));
	}' unless defined(&SYSCTL_U64);
	eval 'sub SYSCTL_ADD_U64 {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_U64|($access), $ptr, 0,  &sysctl_handle_64, \\"QU\\", $descr));
	}' unless defined(&SYSCTL_ADD_U64);
	eval 'sub SYSCTL_BIT32 {
	    my($parent, $nbr, $name, $access, $ptr, $val, $bit, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_BIT32($bit)| &CTLFLAG_NOLOCK|($access), $ptr, $val,  &sysctl_handle_bit32, \\"I\\", $descr));
	}' unless defined(&SYSCTL_BIT32);
	eval 'sub SYSCTL_ADD_BIT32 {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $val, $bit, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_BIT32($bit)| &CTLFLAG_NOLOCK|($access), $ptr, $val,  &sysctl_handle_bit32, \\"I\\", $descr));
	}' unless defined(&SYSCTL_ADD_BIT32);
	eval 'sub SYSCTL_BIT64 {
	    my($parent, $nbr, $name, $access, $ptr, $val, $bit, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_BIT64($bit)| &CTLFLAG_NOLOCK|($access), $ptr, $val,  &sysctl_handle_bit64, \\"I\\", $descr));
	}' unless defined(&SYSCTL_BIT64);
	eval 'sub SYSCTL_ADD_BIT64 {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $val, $bit, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_BIT64($bit)| &CTLFLAG_NOLOCK|($access), $ptr, $val,  &sysctl_handle_bit64, \\"I\\", $descr));
	}' unless defined(&SYSCTL_ADD_BIT64);
	eval 'sub SYSCTL_OPAQUE {
	    my($parent, $nbr, $name, $access, $ptr, $len, $fmt, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_OPAQUE|($access), $ptr, $len,  &sysctl_handle_opaque, $fmt, $descr));
	}' unless defined(&SYSCTL_OPAQUE);
	eval 'sub SYSCTL_ADD_OPAQUE {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $len, $fmt, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_OPAQUE|($access), $ptr, $len,  &sysctl_handle_opaque, $fmt, $descr));
	}' unless defined(&SYSCTL_ADD_OPAQUE);
	eval 'sub SYSCTL_STRUCT {
	    my($parent, $nbr, $name, $access, $ptr, $type, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name,  &CTLTYPE_OPAQUE|($access), $ptr, $sizeof{\'struct type\'},  &sysctl_handle_opaque, \\"S,\\" $type, $descr));
	}' unless defined(&SYSCTL_STRUCT);
	eval 'sub SYSCTL_ADD_STRUCT {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $type, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name,  &CTLTYPE_OPAQUE|($access), $ptr, $sizeof{\'struct type\'},  &sysctl_handle_opaque, \\"S,\\" $type, $descr));
	}' unless defined(&SYSCTL_ADD_STRUCT);
	eval 'sub SYSCTL_PROC {
	    my($parent, $nbr, $name, $access, $ptr, $arg, $handler, $fmt, $descr) = @_;
    	    eval q( &SYSCTL_OID($parent, $nbr, $name, ($access), $ptr, $arg, $handler, $fmt, $descr));
	}' unless defined(&SYSCTL_PROC);
	eval 'sub SYSCTL_ADD_PROC {
	    my($ctx, $parent, $nbr, $name, $access, $ptr, $arg, $handler, $fmt, $descr) = @_;
    	    eval q( &sysctl_add_oid($ctx, $parent, $nbr, $name, ($access), $ptr, $arg, $handler, $fmt, $descr));
	}' unless defined(&SYSCTL_ADD_PROC);
    }
    eval 'sub CTL_SYSCTL () {0;}' unless defined(&CTL_SYSCTL);
    eval 'sub CTL_KERN () {1;}' unless defined(&CTL_KERN);
    eval 'sub CTL_VM () {2;}' unless defined(&CTL_VM);
    eval 'sub CTL_VFS () {3;}' unless defined(&CTL_VFS);
    eval 'sub CTL_NET () {4;}' unless defined(&CTL_NET);
    eval 'sub CTL_DEBUG () {5;}' unless defined(&CTL_DEBUG);
    eval 'sub CTL_HW () {6;}' unless defined(&CTL_HW);
    eval 'sub CTL_MACHDEP () {7;}' unless defined(&CTL_MACHDEP);
    eval 'sub CTL_USER () {8;}' unless defined(&CTL_USER);
    eval 'sub CTL_P1003_1B () {9;}' unless defined(&CTL_P1003_1B);
    eval 'sub CTL_LWKT () {10;}' unless defined(&CTL_LWKT);
    eval 'sub CTL_MAXID () {11;}' unless defined(&CTL_MAXID);
    eval 'sub CTL_NAMES () {{ { 0, 0}, { "kern",  &CTLTYPE_NODE }, { "vm",  &CTLTYPE_NODE }, { "vfs",  &CTLTYPE_NODE }, { "net",  &CTLTYPE_NODE }, { "debug",  &CTLTYPE_NODE }, { "hw",  &CTLTYPE_NODE }, { "machdep",  &CTLTYPE_NODE }, { "user",  &CTLTYPE_NODE }, { "p1003_1b",  &CTLTYPE_NODE }, { "lwkt",  &CTLTYPE_NODE }, };}' unless defined(&CTL_NAMES);
    eval 'sub CTL_SYSCTL_DEBUG () {0;}' unless defined(&CTL_SYSCTL_DEBUG);
    eval 'sub CTL_SYSCTL_NAME () {1;}' unless defined(&CTL_SYSCTL_NAME);
    eval 'sub CTL_SYSCTL_NEXT () {2;}' unless defined(&CTL_SYSCTL_NEXT);
    eval 'sub CTL_SYSCTL_NAME2OID () {3;}' unless defined(&CTL_SYSCTL_NAME2OID);
    eval 'sub CTL_SYSCTL_OIDFMT () {4;}' unless defined(&CTL_SYSCTL_OIDFMT);
    eval 'sub CTL_SYSCTL_OIDDESCR () {5;}' unless defined(&CTL_SYSCTL_OIDDESCR);
    eval 'sub KERN_OSTYPE () {1;}' unless defined(&KERN_OSTYPE);
    eval 'sub KERN_OSRELEASE () {2;}' unless defined(&KERN_OSRELEASE);
    eval 'sub KERN_OSREV () {3;}' unless defined(&KERN_OSREV);
    eval 'sub KERN_VERSION () {4;}' unless defined(&KERN_VERSION);
    eval 'sub KERN_MAXVNODES () {5;}' unless defined(&KERN_MAXVNODES);
    eval 'sub KERN_MAXPROC () {6;}' unless defined(&KERN_MAXPROC);
    eval 'sub KERN_MAXFILES () {7;}' unless defined(&KERN_MAXFILES);
    eval 'sub KERN_ARGMAX () {8;}' unless defined(&KERN_ARGMAX);
    eval 'sub KERN_SECURELVL () {9;}' unless defined(&KERN_SECURELVL);
    eval 'sub KERN_HOSTNAME () {10;}' unless defined(&KERN_HOSTNAME);
    eval 'sub KERN_HOSTID () {11;}' unless defined(&KERN_HOSTID);
    eval 'sub KERN_CLOCKRATE () {12;}' unless defined(&KERN_CLOCKRATE);
    eval 'sub KERN_VNODE () {13;}' unless defined(&KERN_VNODE);
    eval 'sub KERN_PROC () {14;}' unless defined(&KERN_PROC);
    eval 'sub KERN_FILE () {15;}' unless defined(&KERN_FILE);
    eval 'sub KERN_UNUSED16 () {16;}' unless defined(&KERN_UNUSED16);
    eval 'sub KERN_POSIX1 () {17;}' unless defined(&KERN_POSIX1);
    eval 'sub KERN_NGROUPS () {18;}' unless defined(&KERN_NGROUPS);
    eval 'sub KERN_JOB_CONTROL () {19;}' unless defined(&KERN_JOB_CONTROL);
    eval 'sub KERN_SAVED_IDS () {20;}' unless defined(&KERN_SAVED_IDS);
    eval 'sub KERN_BOOTTIME () {21;}' unless defined(&KERN_BOOTTIME);
    eval 'sub KERN_NISDOMAINNAME () {22;}' unless defined(&KERN_NISDOMAINNAME);
    eval 'sub KERN_UPDATEINTERVAL () {23;}' unless defined(&KERN_UPDATEINTERVAL);
    eval 'sub KERN_OSRELDATE () {24;}' unless defined(&KERN_OSRELDATE);
    eval 'sub KERN_NTP_PLL () {25;}' unless defined(&KERN_NTP_PLL);
    eval 'sub KERN_BOOTFILE () {26;}' unless defined(&KERN_BOOTFILE);
    eval 'sub KERN_MAXFILESPERPROC () {27;}' unless defined(&KERN_MAXFILESPERPROC);
    eval 'sub KERN_MAXPROCPERUID () {28;}' unless defined(&KERN_MAXPROCPERUID);
    eval 'sub KERN_DUMPDEV () {29;}' unless defined(&KERN_DUMPDEV);
    eval 'sub KERN_IPC () {30;}' unless defined(&KERN_IPC);
    eval 'sub KERN_DUMMY () {31;}' unless defined(&KERN_DUMMY);
    eval 'sub KERN_PS_STRINGS () {32;}' unless defined(&KERN_PS_STRINGS);
    eval 'sub KERN_USRSTACK () {33;}' unless defined(&KERN_USRSTACK);
    eval 'sub KERN_LOGSIGEXIT () {34;}' unless defined(&KERN_LOGSIGEXIT);
    eval 'sub KERN_IOV_MAX () {35;}' unless defined(&KERN_IOV_MAX);
    eval 'sub KERN_MAXPOSIXLOCKSPERUID () {36;}' unless defined(&KERN_MAXPOSIXLOCKSPERUID);
    eval 'sub KERN_STATIC_TLS_EXTRA () {37;}' unless defined(&KERN_STATIC_TLS_EXTRA);
    eval 'sub KERN_MAXID () {38;}' unless defined(&KERN_MAXID);
    eval 'sub CTL_KERN_NAMES () {{ { 0, 0}, { "ostype",  &CTLTYPE_STRING }, { "osrelease",  &CTLTYPE_STRING }, { "osrevision",  &CTLTYPE_INT }, { "version",  &CTLTYPE_STRING }, { "maxvnodes",  &CTLTYPE_INT }, { "maxproc",  &CTLTYPE_INT }, { "maxfiles",  &CTLTYPE_INT }, { "argmax",  &CTLTYPE_INT }, { "securelevel",  &CTLTYPE_INT }, { "hostname",  &CTLTYPE_STRING }, { "hostid",  &CTLTYPE_UINT }, { "clockrate",  &CTLTYPE_STRUCT }, { "vnode",  &CTLTYPE_STRUCT }, { "proc",  &CTLTYPE_STRUCT }, { "file",  &CTLTYPE_STRUCT }, { "profiling",  &CTLTYPE_NODE }, { "posix1version",  &CTLTYPE_INT }, { "ngroups",  &CTLTYPE_INT }, { "job_control",  &CTLTYPE_INT }, { "saved_ids",  &CTLTYPE_INT }, { "boottime",  &CTLTYPE_STRUCT }, { "nisdomainname",  &CTLTYPE_STRING }, { "update",  &CTLTYPE_INT }, { "osreldate",  &CTLTYPE_INT }, { "ntp_pll",  &CTLTYPE_NODE }, { "bootfile",  &CTLTYPE_STRING }, { "maxfilesperproc",  &CTLTYPE_INT }, { "maxprocperuid",  &CTLTYPE_INT }, { "dumpdev",  &CTLTYPE_STRUCT }, { "ipc",  &CTLTYPE_NODE }, { "dummy",  &CTLTYPE_INT }, { "ps_strings",  &CTLTYPE_INT }, { "usrstack",  &CTLTYPE_INT }, { "logsigexit",  &CTLTYPE_INT }, { "iov_max",  &CTLTYPE_INT }, { "maxposixlocksperuid",  &CTLTYPE_INT }, };}' unless defined(&CTL_KERN_NAMES);
    eval 'sub CTL_VFS_NAMES () {{ { "vfsconf",  &CTLTYPE_STRUCT }, };}' unless defined(&CTL_VFS_NAMES);
    eval 'sub KERN_PROC_ALL () {0;}' unless defined(&KERN_PROC_ALL);
    eval 'sub KERN_PROC_PID () {1;}' unless defined(&KERN_PROC_PID);
    eval 'sub KERN_PROC_PGRP () {2;}' unless defined(&KERN_PROC_PGRP);
    eval 'sub KERN_PROC_SESSION () {3;}' unless defined(&KERN_PROC_SESSION);
    eval 'sub KERN_PROC_TTY () {4;}' unless defined(&KERN_PROC_TTY);
    eval 'sub KERN_PROC_UID () {5;}' unless defined(&KERN_PROC_UID);
    eval 'sub KERN_PROC_RUID () {6;}' unless defined(&KERN_PROC_RUID);
    eval 'sub KERN_PROC_ARGS () {7;}' unless defined(&KERN_PROC_ARGS);
    eval 'sub KERN_PROC_CWD () {8;}' unless defined(&KERN_PROC_CWD);
    eval 'sub KERN_PROC_PATHNAME () {9;}' unless defined(&KERN_PROC_PATHNAME);
    eval 'sub KERN_PROC_SIGTRAMP () {10;}' unless defined(&KERN_PROC_SIGTRAMP);
    eval 'sub KERN_PROC_FLAGMASK () {0xf0;}' unless defined(&KERN_PROC_FLAGMASK);
    eval 'sub KERN_PROC_FLAG_LWP () {0x10;}' unless defined(&KERN_PROC_FLAG_LWP);
    eval 'sub KERN_PROC_FLAG_LWKT () {0x20;}' unless defined(&KERN_PROC_FLAG_LWKT);
    eval 'sub KIPC_MAXSOCKBUF () {1;}' unless defined(&KIPC_MAXSOCKBUF);
    eval 'sub KIPC_SOCKBUF_WASTE () {2;}' unless defined(&KIPC_SOCKBUF_WASTE);
    eval 'sub KIPC_SOMAXCONN () {3;}' unless defined(&KIPC_SOMAXCONN);
    eval 'sub KIPC_MAX_LINKHDR () {4;}' unless defined(&KIPC_MAX_LINKHDR);
    eval 'sub KIPC_MAX_PROTOHDR () {5;}' unless defined(&KIPC_MAX_PROTOHDR);
    eval 'sub KIPC_MAX_HDR () {6;}' unless defined(&KIPC_MAX_HDR);
    eval 'sub KIPC_MAX_DATALEN () {7;}' unless defined(&KIPC_MAX_DATALEN);
    eval 'sub KIPC_MBSTAT () {8;}' unless defined(&KIPC_MBSTAT);
    eval 'sub KIPC_NMBCLUSTERS () {9;}' unless defined(&KIPC_NMBCLUSTERS);
    eval 'sub HW_MACHINE () {1;}' unless defined(&HW_MACHINE);
    eval 'sub HW_MODEL () {2;}' unless defined(&HW_MODEL);
    eval 'sub HW_NCPU () {3;}' unless defined(&HW_NCPU);
    eval 'sub HW_BYTEORDER () {4;}' unless defined(&HW_BYTEORDER);
    eval 'sub HW_PHYSMEM () {5;}' unless defined(&HW_PHYSMEM);
    eval 'sub HW_USERMEM () {6;}' unless defined(&HW_USERMEM);
    eval 'sub HW_PAGESIZE () {7;}' unless defined(&HW_PAGESIZE);
    eval 'sub HW_DISKNAMES () {8;}' unless defined(&HW_DISKNAMES);
    eval 'sub HW_DISKSTATS () {9;}' unless defined(&HW_DISKSTATS);
    eval 'sub HW_FLOATINGPT () {10;}' unless defined(&HW_FLOATINGPT);
    eval 'sub HW_MACHINE_ARCH () {11;}' unless defined(&HW_MACHINE_ARCH);
    eval 'sub HW_MACHINE_PLATFORM () {12;}' unless defined(&HW_MACHINE_PLATFORM);
    eval 'sub HW_SENSORS () {13;}' unless defined(&HW_SENSORS);
    eval 'sub HW_MAXID () {14;}' unless defined(&HW_MAXID);
    eval 'sub USER_CS_PATH () {1;}' unless defined(&USER_CS_PATH);
    eval 'sub USER_BC_BASE_MAX () {2;}' unless defined(&USER_BC_BASE_MAX);
    eval 'sub USER_BC_DIM_MAX () {3;}' unless defined(&USER_BC_DIM_MAX);
    eval 'sub USER_BC_SCALE_MAX () {4;}' unless defined(&USER_BC_SCALE_MAX);
    eval 'sub USER_BC_STRING_MAX () {5;}' unless defined(&USER_BC_STRING_MAX);
    eval 'sub USER_COLL_WEIGHTS_MAX () {6;}' unless defined(&USER_COLL_WEIGHTS_MAX);
    eval 'sub USER_EXPR_NEST_MAX () {7;}' unless defined(&USER_EXPR_NEST_MAX);
    eval 'sub USER_LINE_MAX () {8;}' unless defined(&USER_LINE_MAX);
    eval 'sub USER_RE_DUP_MAX () {9;}' unless defined(&USER_RE_DUP_MAX);
    eval 'sub USER_POSIX2_VERSION () {10;}' unless defined(&USER_POSIX2_VERSION);
    eval 'sub USER_POSIX2_C_BIND () {11;}' unless defined(&USER_POSIX2_C_BIND);
    eval 'sub USER_POSIX2_C_DEV () {12;}' unless defined(&USER_POSIX2_C_DEV);
    eval 'sub USER_POSIX2_CHAR_TERM () {13;}' unless defined(&USER_POSIX2_CHAR_TERM);
    eval 'sub USER_POSIX2_FORT_DEV () {14;}' unless defined(&USER_POSIX2_FORT_DEV);
    eval 'sub USER_POSIX2_FORT_RUN () {15;}' unless defined(&USER_POSIX2_FORT_RUN);
    eval 'sub USER_POSIX2_LOCALEDEF () {16;}' unless defined(&USER_POSIX2_LOCALEDEF);
    eval 'sub USER_POSIX2_SW_DEV () {17;}' unless defined(&USER_POSIX2_SW_DEV);
    eval 'sub USER_POSIX2_UPE () {18;}' unless defined(&USER_POSIX2_UPE);
    eval 'sub USER_STREAM_MAX () {19;}' unless defined(&USER_STREAM_MAX);
    eval 'sub USER_TZNAME_MAX () {20;}' unless defined(&USER_TZNAME_MAX);
    eval 'sub USER_MAXID () {21;}' unless defined(&USER_MAXID);
    eval 'sub CTL_USER_NAMES () {{ { 0, 0}, { "cs_path",  &CTLTYPE_STRING }, { "bc_base_max",  &CTLTYPE_INT }, { "bc_dim_max",  &CTLTYPE_INT }, { "bc_scale_max",  &CTLTYPE_INT }, { "bc_string_max",  &CTLTYPE_INT }, { "coll_weights_max",  &CTLTYPE_INT }, { "expr_nest_max",  &CTLTYPE_INT }, { "line_max",  &CTLTYPE_INT }, { "re_dup_max",  &CTLTYPE_INT }, { "posix2_version",  &CTLTYPE_INT }, { "posix2_c_bind",  &CTLTYPE_INT }, { "posix2_c_dev",  &CTLTYPE_INT }, { "posix2_char_term",  &CTLTYPE_INT }, { "posix2_fort_dev",  &CTLTYPE_INT }, { "posix2_fort_run",  &CTLTYPE_INT }, { "posix2_localedef",  &CTLTYPE_INT }, { "posix2_sw_dev",  &CTLTYPE_INT }, { "posix2_upe",  &CTLTYPE_INT }, { "stream_max",  &CTLTYPE_INT }, { "tzname_max",  &CTLTYPE_INT }, };}' unless defined(&CTL_USER_NAMES);
    eval 'sub CTL_P1003_1B_ASYNCHRONOUS_IO () {1;}' unless defined(&CTL_P1003_1B_ASYNCHRONOUS_IO);
    eval 'sub CTL_P1003_1B_MAPPED_FILES () {2;}' unless defined(&CTL_P1003_1B_MAPPED_FILES);
    eval 'sub CTL_P1003_1B_MEMLOCK () {3;}' unless defined(&CTL_P1003_1B_MEMLOCK);
    eval 'sub CTL_P1003_1B_MEMLOCK_RANGE () {4;}' unless defined(&CTL_P1003_1B_MEMLOCK_RANGE);
    eval 'sub CTL_P1003_1B_MEMORY_PROTECTION () {5;}' unless defined(&CTL_P1003_1B_MEMORY_PROTECTION);
    eval 'sub CTL_P1003_1B_MESSAGE_PASSING () {6;}' unless defined(&CTL_P1003_1B_MESSAGE_PASSING);
    eval 'sub CTL_P1003_1B_PRIORITIZED_IO () {7;}' unless defined(&CTL_P1003_1B_PRIORITIZED_IO);
    eval 'sub CTL_P1003_1B_PRIORITY_SCHEDULING () {8;}' unless defined(&CTL_P1003_1B_PRIORITY_SCHEDULING);
    eval 'sub CTL_P1003_1B_REALTIME_SIGNALS () {9;}' unless defined(&CTL_P1003_1B_REALTIME_SIGNALS);
    eval 'sub CTL_P1003_1B_SEMAPHORES () {10;}' unless defined(&CTL_P1003_1B_SEMAPHORES);
    eval 'sub CTL_P1003_1B_FSYNC () {11;}' unless defined(&CTL_P1003_1B_FSYNC);
    eval 'sub CTL_P1003_1B_SHARED_MEMORY_OBJECTS () {12;}' unless defined(&CTL_P1003_1B_SHARED_MEMORY_OBJECTS);
    eval 'sub CTL_P1003_1B_SYNCHRONIZED_IO () {13;}' unless defined(&CTL_P1003_1B_SYNCHRONIZED_IO);
    eval 'sub CTL_P1003_1B_TIMERS () {14;}' unless defined(&CTL_P1003_1B_TIMERS);
    eval 'sub CTL_P1003_1B_AIO_LISTIO_MAX () {15;}' unless defined(&CTL_P1003_1B_AIO_LISTIO_MAX);
    eval 'sub CTL_P1003_1B_AIO_MAX () {16;}' unless defined(&CTL_P1003_1B_AIO_MAX);
    eval 'sub CTL_P1003_1B_AIO_PRIO_DELTA_MAX () {17;}' unless defined(&CTL_P1003_1B_AIO_PRIO_DELTA_MAX);
    eval 'sub CTL_P1003_1B_DELAYTIMER_MAX () {18;}' unless defined(&CTL_P1003_1B_DELAYTIMER_MAX);
    eval 'sub CTL_P1003_1B_UNUSED19 () {19;}' unless defined(&CTL_P1003_1B_UNUSED19);
    eval 'sub CTL_P1003_1B_PAGESIZE () {20;}' unless defined(&CTL_P1003_1B_PAGESIZE);
    eval 'sub CTL_P1003_1B_RTSIG_MAX () {21;}' unless defined(&CTL_P1003_1B_RTSIG_MAX);
    eval 'sub CTL_P1003_1B_SEM_NSEMS_MAX () {22;}' unless defined(&CTL_P1003_1B_SEM_NSEMS_MAX);
    eval 'sub CTL_P1003_1B_UNUSED23 () {23;}' unless defined(&CTL_P1003_1B_UNUSED23);
    eval 'sub CTL_P1003_1B_SIGQUEUE_MAX () {24;}' unless defined(&CTL_P1003_1B_SIGQUEUE_MAX);
    eval 'sub CTL_P1003_1B_TIMER_MAX () {25;}' unless defined(&CTL_P1003_1B_TIMER_MAX);
    eval 'sub CTL_P1003_1B_MAXID () {26;}' unless defined(&CTL_P1003_1B_MAXID);
    eval 'sub CTL_P1003_1B_NAMES () {{ { 0, 0}, { "asynchronous_io",  &CTLTYPE_INT }, { "mapped_files",  &CTLTYPE_INT }, { "memlock",  &CTLTYPE_INT }, { "memlock_range",  &CTLTYPE_INT }, { "memory_protection",  &CTLTYPE_INT }, { "message_passing",  &CTLTYPE_INT }, { "prioritized_io",  &CTLTYPE_INT }, { "priority_scheduling",  &CTLTYPE_INT }, { "realtime_signals",  &CTLTYPE_INT }, { "semaphores",  &CTLTYPE_INT }, { "fsync",  &CTLTYPE_INT }, { "shared_memory_objects",  &CTLTYPE_INT }, { "synchronized_io",  &CTLTYPE_INT }, { "timers",  &CTLTYPE_INT }, { "aio_listio_max",  &CTLTYPE_INT }, { "aio_max",  &CTLTYPE_INT }, { "aio_prio_delta_max",  &CTLTYPE_INT }, { "delaytimer_max",  &CTLTYPE_INT }, { "unused1",  &CTLTYPE_INT }, { "pagesize",  &CTLTYPE_INT }, { "rtsig_max",  &CTLTYPE_INT }, { "nsems_max",  &CTLTYPE_INT }, { "sem_value_max",  &CTLTYPE_INT }, { "sigqueue_max",  &CTLTYPE_INT }, { "timer_max",  &CTLTYPE_INT }, };}' unless defined(&CTL_P1003_1B_NAMES);
    if(defined(&_KERNEL)) {
	eval 'sub FEATURE {
	    my($name, $desc) = @_;
    	    eval q( &SYSCTL_INT( &_kern_features,  &OID_AUTO, $name,  &CTLFLAG_RD,  &NULL, 1, $desc));
	}' unless defined(&FEATURE);
    }
    if(!defined(&_KERNEL) || defined(&_KERNEL_VIRTUAL)) {
	require 'sys/cdefs.ph';
    }
}
1;
