require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_SYSTM_H_)) {
    eval 'sub _SYS_SYSTM_H_ () {1;}' unless defined(&_SYS_SYSTM_H_);
    unless(defined(&_KERNEL)) {
	die("This file should not be included by userland programs.");
    }
    unless(defined(&_MACHINE_TYPES_H_)) {
	require 'machine/types.ph';
    }
    require 'machine/stdarg.ph';
    require 'machine/atomic.ph';
    require 'machine/cpufunc.ph';
    require 'machine/int_limits.ph';
    if(defined(&INVARIANTS)) {
	eval 'sub KASSERT {
	    my($exp,$msg) = @_;
    	    eval q( &do {  &if ( &__predict_false(!($exp)))  &panic $msg; }  &while (0));
	}' unless defined(&KASSERT);
	eval 'sub KKASSERT {
	    my($exp) = @_;
    	    eval q( &do {  &if ( &__predict_false(!($exp)))  &panic(\\"assertion \\\\\\"%s\\\\\\" failed \\" \\"in %s at %s:%u\\", $exp,  &__func__,  &__FILE__,  &__LINE__); }  &while (0));
	}' unless defined(&KKASSERT);
	eval 'sub KKASSERT_UNSPIN {
	    my($exp, $spin) = @_;
    	    eval q( &do {  &if ( &__predict_false(!($exp))) {  &spin_unlock_any($spin);  &panic(\\"assertion \\\\\\"%s\\\\\\" failed \\" \\"in %s at %s:%u\\", $exp,  &__func__,  &__FILE__,  &__LINE__); } }  &while (0));
	}' unless defined(&KKASSERT_UNSPIN);
	eval 'sub __debugvar () {1;}' unless defined(&__debugvar);
	eval 'sub __assert_unreachable () {
	    eval q( &do {  &panic(\\"executing segment marked \\" \\"as unreachable at %s:%d (%s)\\\\n\\",  &__FILE__,  &__LINE__,  &__func__); }  &while (0));
	}' unless defined(&__assert_unreachable);
    } else {
	eval 'sub KASSERT {
	    my($exp,$msg) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&KASSERT);
	eval 'sub KKASSERT {
	    my($exp) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&KKASSERT);
	eval 'sub KKASSERT_UNSPIN {
	    my($exp, $spin) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&KKASSERT_UNSPIN);
	eval 'sub __debugvar () { &__attribute__(( &__unused__));}' unless defined(&__debugvar);
	eval 'sub __assert_unreachable () {
	    eval q( &__unreachable());
	}' unless defined(&__assert_unreachable);
    }
    eval 'sub __read_mostly () { &__section(".data.read_mostly");}' unless defined(&__read_mostly);
    eval 'sub __read_frequently () { &__section(".data.read_frequently");}' unless defined(&__read_frequently);
    eval 'sub __exclusive_cache_line () { &__aligned( &__VM_CACHELINE_SIZE*2)  &__section(".data.exclusive_cache_line");}' unless defined(&__exclusive_cache_line);
    eval 'sub HD_COLUMN_MASK () {0xff;}' unless defined(&HD_COLUMN_MASK);
    eval 'sub HD_DELIM_MASK () {0xff00;}' unless defined(&HD_DELIM_MASK);
    eval 'sub HD_OMIT_COUNT () {(1<< 16);}' unless defined(&HD_OMIT_COUNT);
    eval 'sub HD_OMIT_HEX () {(1<< 17);}' unless defined(&HD_OMIT_HEX);
    eval 'sub HD_OMIT_CHARS () {(1<< 18);}' unless defined(&HD_OMIT_CHARS);
    if(1) {
	eval 'sub bcopy {
	    my($from, $to, $len) = @_;
    	    eval q( &__builtin_memmove( &__DEQUALIFY( &void *, ($to)),  &__DEQUALIFY( &void *, ($from)), ($len)));
	}' unless defined(&bcopy);
	eval 'sub memcpy {
	    my($to, $from, $len) = @_;
    	    eval q( &__builtin_memcpy( &__DEQUALIFY( &void *, ($to)),  &__DEQUALIFY( &void *, ($from)), ($len)));
	}' unless defined(&memcpy);
	eval 'sub memset {
	    my($ptr, $c, $len) = @_;
    	    eval q( &__builtin_memset( &__DEQUALIFY( &void *, ($ptr)), ($c), ($len)));
	}' unless defined(&memset);
	eval 'sub memmove {
	    my($to, $from, $len) = @_;
    	    eval q( &__builtin_memmove( &__DEQUALIFY( &void *, ($to)),  &__DEQUALIFY( &void *, ($from)), ($len)));
	}' unless defined(&memmove);
	eval 'sub bzero {
	    my($buf, $len) = @_;
    	    eval q( &__builtin_memset( &__DEQUALIFY( &void *, ($buf)), 0, ($len)));
	}' unless defined(&bzero);
    } else {
    }
    require 'sys/libkern.ph';
    if(defined(&__x86_64__)) {
    }
    eval 'sub bitcount32 {
        my($x) = @_;
	    eval q({ $x = ($x & 0x55555555) + (($x & 0xaaaaaaaa) >> 1); $x = ($x & 0x33333333) + (($x & 0xcccccccc) >> 2); $x = ($x + ($x >> 4)) & 0xf0f0f0f; $x = ($x + ($x >> 8)); $x = ($x + ($x >> 16)) & 0xff; ($x); });
    }' unless defined(&bitcount32);
    eval 'sub bitcount64 {
        my($x) = @_;
	    eval q({ $x = ($x & 0x5555555555555555) + (($x & 0xaaaaaaaaaaaaaaaa) >> 1); $x = ($x & 0x3333333333333333) + (($x & 0xcccccccccccccccc) >> 2); $x = ($x + ($x >> 4)) & 0xf0f0f0f0f0f0f0f; $x = ($x + ($x >> 8)); $x = ($x + ($x >> 16)); $x = ($x + ($x >> 32)) & 0xff; ($x); });
    }' unless defined(&bitcount64);
}
1;
