require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_TTY_H_)) {
    eval 'sub _SYS_TTY_H_ () {1;}' unless defined(&_SYS_TTY_H_);
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	require 'sys/_termios.ph';
	require 'sys/event.ph';
	require 'sys/queue.ph';
	require 'sys/ttycom.ph';
	if(defined(&_KERNEL)) {
	    require 'sys/device.ph';
	}
	unless(defined(&_SYS_THREAD_H_)) {
	    require 'sys/thread.ph';
	}
	eval 'sub t_cc () { ($t_termios->{c_cc});}' unless defined(&t_cc);
	eval 'sub t_cflag () { ($t_termios->{c_cflag});}' unless defined(&t_cflag);
	eval 'sub t_iflag () { ($t_termios->{c_iflag});}' unless defined(&t_iflag);
	eval 'sub t_ispeed () { ($t_termios->{c_ispeed});}' unless defined(&t_ispeed);
	eval 'sub t_lflag () { ($t_termios->{c_lflag});}' unless defined(&t_lflag);
	eval 'sub t_min () { ($t_termios->{c_min});}' unless defined(&t_min);
	eval 'sub t_oflag () { ($t_termios->{c_oflag});}' unless defined(&t_oflag);
	eval 'sub t_ospeed () { ($t_termios->{c_ospeed});}' unless defined(&t_ospeed);
	eval 'sub t_time () { ($t_termios->{c_time});}' unless defined(&t_time);
    }
    eval 'sub IBUFSIZ () {384;}' unless defined(&IBUFSIZ);
    eval 'sub OBUFSIZ () {100;}' unless defined(&OBUFSIZ);
    unless(defined(&TTYHOG)) {
	eval 'sub TTYHOG () {1024;}' unless defined(&TTYHOG);
    }
    if(defined(&_KERNEL)) {
	eval 'sub TTMAXHIWAT () {2048;}' unless defined(&TTMAXHIWAT);
	eval 'sub TTMINHIWAT () {100;}' unless defined(&TTMINHIWAT);
	eval 'sub TTMAXLOWAT () {256;}' unless defined(&TTMAXLOWAT);
	eval 'sub TTMINLOWAT () {32;}' unless defined(&TTMINLOWAT);
    }
    eval 'sub TS_SO_OLOWAT () {0x1;}' unless defined(&TS_SO_OLOWAT);
    eval 'sub TS_ASYNC () {0x2;}' unless defined(&TS_ASYNC);
    eval 'sub TS_BUSY () {0x4;}' unless defined(&TS_BUSY);
    eval 'sub TS_CARR_ON () {0x8;}' unless defined(&TS_CARR_ON);
    eval 'sub TS_FLUSH () {0x10;}' unless defined(&TS_FLUSH);
    eval 'sub TS_ISOPEN () {0x20;}' unless defined(&TS_ISOPEN);
    eval 'sub TS_TBLOCK () {0x40;}' unless defined(&TS_TBLOCK);
    eval 'sub TS_TIMEOUT () {0x80;}' unless defined(&TS_TIMEOUT);
    eval 'sub TS_TTSTOP () {0x100;}' unless defined(&TS_TTSTOP);
    if(defined(&notyet)) {
	eval 'sub TS_WOPEN () {0x200;}' unless defined(&TS_WOPEN);
    }
    eval 'sub TS_XCLUDE () {0x400;}' unless defined(&TS_XCLUDE);
    eval 'sub TS_BKSL () {0x800;}' unless defined(&TS_BKSL);
    eval 'sub TS_CNTTB () {0x1000;}' unless defined(&TS_CNTTB);
    eval 'sub TS_ERASE () {0x2000;}' unless defined(&TS_ERASE);
    eval 'sub TS_LNCH () {0x4000;}' unless defined(&TS_LNCH);
    eval 'sub TS_TYPEN () {0x8000;}' unless defined(&TS_TYPEN);
    eval 'sub TS_LOCAL () {( &TS_BKSL |  &TS_CNTTB |  &TS_ERASE |  &TS_LNCH |  &TS_TYPEN);}' unless defined(&TS_LOCAL);
    eval 'sub TS_CAN_BYPASS_L_RINT () {0x10000;}' unless defined(&TS_CAN_BYPASS_L_RINT);
    eval 'sub TS_CONNECTED () {0x20000;}' unless defined(&TS_CONNECTED);
    eval 'sub TS_SNOOP () {0x40000;}' unless defined(&TS_SNOOP);
    eval 'sub TS_SO_OCOMPLETE () {0x80000;}' unless defined(&TS_SO_OCOMPLETE);
    eval 'sub TS_ZOMBIE () {0x100000;}' unless defined(&TS_ZOMBIE);
    eval 'sub TS_CAR_OFLOW () {0x200000;}' unless defined(&TS_CAR_OFLOW);
    if(defined(&notyet)) {
	eval 'sub TS_CTS_OFLOW () {0x400000;}' unless defined(&TS_CTS_OFLOW);
	eval 'sub TS_DSR_OFLOW () {0x800000;}' unless defined(&TS_DSR_OFLOW);
    }
    eval 'sub TS_REGISTERED () {0x1000000;}' unless defined(&TS_REGISTERED);
    eval 'sub TS_MARKER () {0x2000000;}' unless defined(&TS_MARKER);
    eval 'sub ORDINARY () {0;}' unless defined(&ORDINARY);
    eval 'sub CONTROL () {1;}' unless defined(&CONTROL);
    eval 'sub BACKSPACE () {2;}' unless defined(&BACKSPACE);
    eval 'sub NEWLINE () {3;}' unless defined(&NEWLINE);
    eval 'sub TAB () {4;}' unless defined(&TAB);
    eval 'sub VTAB () {5;}' unless defined(&VTAB);
    eval 'sub RETURN () {6;}' unless defined(&RETURN);
    eval 'sub DMSET () {0;}' unless defined(&DMSET);
    eval 'sub DMBIS () {1;}' unless defined(&DMBIS);
    eval 'sub DMBIC () {2;}' unless defined(&DMBIC);
    eval 'sub DMGET () {3;}' unless defined(&DMGET);
    eval 'sub TTY_CHARMASK () {0xff;}' unless defined(&TTY_CHARMASK);
    eval 'sub TTY_QUOTE () {0x100;}' unless defined(&TTY_QUOTE);
    eval 'sub TTY_ERRORMASK () {0xff000000;}' unless defined(&TTY_ERRORMASK);
    eval 'sub TTY_FE () {0x1000000;}' unless defined(&TTY_FE);
    eval 'sub TTY_PE () {0x2000000;}' unless defined(&TTY_PE);
    eval 'sub TTY_OE () {0x4000000;}' unless defined(&TTY_OE);
    eval 'sub TTY_BI () {0x8000000;}' unless defined(&TTY_BI);
    eval 'sub isctty {
        my($p, $tp) = @_;
	    eval q((($p)-> &p_session == ($tp)-> &t_session  && (($p)-> &p_flags &  &P_CONTROLT)));
    }' unless defined(&isctty);
    eval 'sub isbackground {
        my($p, $tp) = @_;
	    eval q(( &isctty(($p), ($tp))  && ($p)-> &p_pgrp != ($tp)-> &t_pgrp));
    }' unless defined(&isbackground);
    eval 'sub TSA_CARR_ON {
        my($tp) = @_;
	    eval q((( &void *)($tp)-> &t_rawq));
    }' unless defined(&TSA_CARR_ON);
    eval 'sub TSA_HUP_OR_INPUT {
        my($tp) = @_;
	    eval q((( &void *)($tp)-> ($t_rawq->{c_cchead})));
    }' unless defined(&TSA_HUP_OR_INPUT);
    eval 'sub TSA_OCOMPLETE {
        my($tp) = @_;
	    eval q((( &void *)($tp)-> ($t_outq->{c_ccmax})));
    }' unless defined(&TSA_OCOMPLETE);
    eval 'sub TSA_OLOWAT {
        my($tp) = @_;
	    eval q((( &void *)($tp)-> &t_outq));
    }' unless defined(&TSA_OLOWAT);
    eval 'sub TSA_PTC_READ {
        my($tp) = @_;
	    eval q((( &void *)($tp)-> ($t_outq->{c_cchead})));
    }' unless defined(&TSA_PTC_READ);
    eval 'sub TSA_PTC_WRITE {
        my($tp) = @_;
	    eval q((( &void *)($tp)-> ($t_rawq->{c_ccmax})));
    }' unless defined(&TSA_PTC_WRITE);
    eval 'sub TSA_PTS_READ {
        my($tp) = @_;
	    eval q((( &void *)($tp)-> &t_canq));
    }' unless defined(&TSA_PTS_READ);
    if(defined(&_KERNEL)) {
	if(defined(&MALLOC_DECLARE)) {
	}
    }
}
1;
