require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_VNODE_H_)) {
    eval 'sub _SYS_VNODE_H_ () {1;}' unless defined(&_SYS_VNODE_H_);
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	unless(defined(&_SYS_QUEUE_H_)) {
	    require 'sys/queue.ph';
	}
	unless(defined(&_SYS_LOCK_H_)) {
	    require 'sys/lock.ph';
	}
	unless(defined(&_SYS_EVENT_H_)) {
	    require 'sys/event.ph';
	}
	unless(defined(&_SYS_BIOTRACK_H_)) {
	    require 'sys/biotrack.ph';
	}
	unless(defined(&_SYS__UIO_H_)) {
	    require 'sys/_uio.ph';
	}
	unless(defined(&_SYS_ACL_H_)) {
	    require 'sys/acl.ph';
	}
	unless(defined(&_SYS_NAMECACHE_H_)) {
	    require 'sys/namecache.ph';
	}
	unless(defined(&_SYS_THREAD_H_)) {
	    require 'sys/thread.ph';
	}
	unless(defined(&_SYS_VFSOPS_H_)) {
	    require 'sys/vfsops.ph';
	}
	unless(defined(&_SYS_VFSCACHE_H_)) {
	    require 'sys/vfscache.ph';
	}
	unless(defined(&_SYS_TREE_H_)) {
	    require 'sys/tree.ph';
	}
	unless(defined(&_SYS_SYSLINK_RPC_H_)) {
	    require 'sys/syslink_rpc.ph';
	}
	unless(defined(&_MACHINE_LOCK_H_)) {
	    require 'machine/lock.ph';
	}
	eval 'sub v_socket () { ($v_un->{vu_socket});}' unless defined(&v_socket);
	eval 'sub v_umajor () { ($v_un->{vu_cdev}->{vu_umajor});}' unless defined(&v_umajor);
	eval 'sub v_uminor () { ($v_un->{vu_cdev}->{vu_uminor});}' unless defined(&v_uminor);
	eval 'sub v_rdev () { ($v_un->{vu_cdev}->{vu_cdevinfo});}' unless defined(&v_rdev);
	eval 'sub v_cdevnext () { ($v_un->{vu_cdev}->{vu_cdevnext});}' unless defined(&v_cdevnext);
	eval 'sub v_fifoinfo () { ($v_un->{vu_fifoinfo});}' unless defined(&v_fifoinfo);
	eval 'sub VROOT () {0x1;}' unless defined(&VROOT);
	eval 'sub VTEXT () {0x2;}' unless defined(&VTEXT);
	eval 'sub VSYSTEM () {0x4;}' unless defined(&VSYSTEM);
	eval 'sub VISTTY () {0x8;}' unless defined(&VISTTY);
	eval 'sub VCTTYISOPEN () {0x10;}' unless defined(&VCTTYISOPEN);
	eval 'sub VCKPT () {0x20;}' unless defined(&VCKPT);
	eval 'sub VKVABIO () {0x40;}' unless defined(&VKVABIO);
	eval 'sub VMAYHAVELOCKS () {0x80;}' unless defined(&VMAYHAVELOCKS);
	eval 'sub VPFSROOT () {0x100;}' unless defined(&VPFSROOT);
	eval 'sub VAGE0 () {0x400;}' unless defined(&VAGE0);
	eval 'sub VAGE1 () {0x800;}' unless defined(&VAGE1);
	eval 'sub VOBJBUF () {0x2000;}' unless defined(&VOBJBUF);
	eval 'sub VINACTIVE () {0x4000;}' unless defined(&VINACTIVE);
	eval 'sub VRECLAIMED () {0x40000;}' unless defined(&VRECLAIMED);
	eval 'sub VLASTWRITETS () {0x80000;}' unless defined(&VLASTWRITETS);
	eval 'sub VNOTSEEKABLE () {0x100000;}' unless defined(&VNOTSEEKABLE);
	eval 'sub VONWORKLST () {0x200000;}' unless defined(&VONWORKLST);
	eval 'sub VISDIRTY () {0x400000;}' unless defined(&VISDIRTY);
	eval 'sub VOBJDIRTY () {0x800000;}' unless defined(&VOBJDIRTY);
	eval 'sub VSWAPCACHE () {0x1000000;}' unless defined(&VSWAPCACHE);
	eval 'sub VS_CACHED () {0;}' unless defined(&VS_CACHED);
	eval 'sub VS_ACTIVE () {1;}' unless defined(&VS_ACTIVE);
	eval 'sub VS_INACTIVE () {2;}' unless defined(&VS_INACTIVE);
	eval 'sub VS_DYING () {3;}' unless defined(&VS_DYING);
	eval 'sub VREF_TERMINATE () {0x80000000;}' unless defined(&VREF_TERMINATE);
	eval 'sub VREF_FINALIZE () {0x40000000;}' unless defined(&VREF_FINALIZE);
	eval 'sub VREF_MASK () {0xbfffffff;}' unless defined(&VREF_MASK);
	eval 'sub VREFCNT {
	    my($vp) = @_;
    	    eval q(((($vp)-> &v_refcnt &  &VREF_MASK)));
	}' unless defined(&VREFCNT);
	eval 'sub VMSC_GETVP () {0x1;}' unless defined(&VMSC_GETVP);
	eval 'sub VMSC_GETVX () {0x2;}' unless defined(&VMSC_GETVX);
	eval 'sub VMSC_NOWAIT () {0x10;}' unless defined(&VMSC_NOWAIT);
	eval 'sub VMSC_ONEPASS () {0x20;}' unless defined(&VMSC_ONEPASS);
	eval 'sub IO_UNIT () {0x1;}' unless defined(&IO_UNIT);
	eval 'sub IO_APPEND () {0x2;}' unless defined(&IO_APPEND);
	eval 'sub IO_SYNC () {0x4;}' unless defined(&IO_SYNC);
	eval 'sub IO_NODELOCKED () {0x8;}' unless defined(&IO_NODELOCKED);
	eval 'sub IO_NDELAY () {0x10;}' unless defined(&IO_NDELAY);
	eval 'sub IO_VMIO () {0x20;}' unless defined(&IO_VMIO);
	eval 'sub IO_INVAL () {0x40;}' unless defined(&IO_INVAL);
	eval 'sub IO_ASYNC () {0x80;}' unless defined(&IO_ASYNC);
	eval 'sub IO_DIRECT () {0x100;}' unless defined(&IO_DIRECT);
	eval 'sub IO_RECURSE () {0x200;}' unless defined(&IO_RECURSE);
	eval 'sub IO_CORE () {0x400;}' unless defined(&IO_CORE);
	eval 'sub IO_NRDELAY () {0x800;}' unless defined(&IO_NRDELAY);
	eval 'sub IO_SEQMAX () {0x7f;}' unless defined(&IO_SEQMAX);
	eval 'sub IO_SEQSHIFT () {16;}' unless defined(&IO_SEQSHIFT);
	eval 'sub VSUID () {04000;}' unless defined(&VSUID);
	eval 'sub VSGID () {02000;}' unless defined(&VSGID);
	eval 'sub VSVTX () {01000;}' unless defined(&VSVTX);
	eval 'sub VREAD () {00400;}' unless defined(&VREAD);
	eval 'sub VWRITE () {00200;}' unless defined(&VWRITE);
	eval 'sub VEXEC () {00100;}' unless defined(&VEXEC);
	eval 'sub VNOVAL () {(-1);}' unless defined(&VNOVAL);
	eval 'sub VLKTIMEOUT () {( &hz / 20+ 1);}' unless defined(&VLKTIMEOUT);
	if(defined(&_KERNEL)) {
	    eval 'sub IFTOVT {
	        my($mode) = @_;
    		eval q(( $iftovt_tab[(($mode) &  &S_IFMT) >> 12]));
	    }' unless defined(&IFTOVT);
	    eval 'sub VTTOIF {
	        my($indx) = @_;
    		eval q(( $vttoif_tab[($indx)]));
	    }' unless defined(&VTTOIF);
	    eval 'sub MAKEIMODE {
	        my($indx, $mode) = @_;
    		eval q(( &VTTOIF($indx) | ($mode)));
	    }' unless defined(&MAKEIMODE);
	    eval 'sub SKIPSYSTEM () {0x1;}' unless defined(&SKIPSYSTEM);
	    eval 'sub FORCECLOSE () {0x2;}' unless defined(&FORCECLOSE);
	    eval 'sub WRITECLOSE () {0x4;}' unless defined(&WRITECLOSE);
	    eval 'sub DOCLOSE () {0x8;}' unless defined(&DOCLOSE);
	    eval 'sub V_SAVE () {0x1;}' unless defined(&V_SAVE);
	    if(defined(&DIAGNOSTIC)) {
		eval 'sub VATTR_NULL {
		    my($vap) = @_;
    		    eval q( &vattr_null($vap));
		}' unless defined(&VATTR_NULL);
	    } else {
		eval 'sub VATTR_NULL {
		    my($vap) = @_;
    		    eval q((*($vap) =  &va_null));
		}' unless defined(&VATTR_NULL);
	    }
	    eval 'sub NULLVP () {( &NULL);}' unless defined(&NULLVP);
	    eval 'sub VNODEOP_SET {
	        my($f) = @_;
    		eval q( &SYSINIT($f &init,  &SI_SUB_VFS,  &SI_ORDER_SECOND,  &vfs_nadd_vnodeops_sysinit, $f);  &SYSUNINIT($f &uninit,  &SI_SUB_VFS,  &SI_ORDER_SECOND, &vfs_nrm_vnodeops_sysinit, $f));
	    }' unless defined(&VNODEOP_SET);
	    eval 'sub NVEXTF_TRIVIAL () {0x1;}' unless defined(&NVEXTF_TRIVIAL);
	    eval 'sub NVEXTF_BUWRITE () {0x2;}' unless defined(&NVEXTF_BUWRITE);
	    eval 'sub VOPARG_OFFSET {
	        my($p_type,$field) = @_;
    		eval q(( (( (((($p_type) &NULL)->$field))) - (  &NULL))));
	    }' unless defined(&VOPARG_OFFSET);
	    eval 'sub VOPARG_OFFSETOF {
	        my($s_type,$field) = @_;
    		eval q( &VOPARG_OFFSET($s_type*,$field));
	    }' unless defined(&VOPARG_OFFSETOF);
	    eval 'sub VOPARG_OFFSETTO {
	        my($S_TYPE,$S_OFFSET,$STRUCT_P) = @_;
    		eval q((($S_TYPE)((($STRUCT_P))+($S_OFFSET))));
	    }' unless defined(&VOPARG_OFFSETTO);
	    eval 'sub VOCALL {
	        my($vops, $ap) = @_;
    		eval q((*( &vocall_func_t *)(($vops)+(($ap)-> ($a_desc->{sd_offset}))))($ap));
	    }' unless defined(&VOCALL);
	    eval 'sub VDESC {
	        my($OP) = @_;
    		eval q((&  &__CONCAT($OP, &_desc)));
	    }' unless defined(&VDESC);
	    if(defined(&DEBUG_VN_UNLOCK)) {
		eval 'sub vn_unlock {
		    my($vp) = @_;
    		    eval q( &debug_vn_unlock($vp,  &__FILE__,  &__LINE__));
		}' unless defined(&vn_unlock);
	    }
	    if(defined(&DEBUG_VPUT)) {
		eval 'sub vput {
		    my($vp) = @_;
    		    eval q( &debug_vput($vp,  &__FILE__,  &__LINE__));
		}' unless defined(&vput);
	    }
	}
    }
}
1;
